/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rdm.web.project.DashboardTabPage");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dijit._base");
dojo.require("dijit.form.Button");
dojo.require("dijit.Tooltip");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dojox.layout.ContentPane");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.Menu");
dojo.require("dijit.MenuSeparator");
dojo.require("dojo.date.locale");
dojo.require("dojo.date.stamp");
dojo.require("dojo.i18n");
dojo.require("dijit.form.ComboButton");

dojo.require("jazz.ui.Button");
dojo.require("jazz.ui.MessageBox");

dojo.require("com.ibm.rdm.web.project.AttributesSection");
dojo.require("com.ibm.rdm.web.project.DashboardConstants");
dojo.require("com.ibm.rdm.web.project.FilterSectionsContainer");
dojo.require("com.ibm.rdm.web.project.FoldersSection");
dojo.require("com.ibm.rdm.web.project.TagsSection");
dojo.require("com.ibm.rdm.web.project.SavedFiltersSection");
dojo.require("com.ibm.rdm.web.common.MimeTypes");
dojo.require("com.ibm.rdm.web.project.ResultSetGridView");
dojo.require("com.ibm.rdm.web.common.ProjectCache");
dojo.require("com.ibm.rdm.web.util.domutils");
dojo.require("com.ibm.rdm.web.common.StatusDisplay");
dojo.require("com.ibm.rdm.web.notifications.ChangeNotifier");
dojo.require("com.ibm.rdm.web.notifications.EventTopics");
dojo.require("com.ibm.rdm.web.project.NewArtifactForm");
dojo.require("com.ibm.rdm.web.common.ResourceLinksHandler");
dojo.require("com.ibm.rdm.web.query.ViewServiceClient");
dojo.require("com.ibm.rdm.web.model.types.RRMTypes");
dojo.require("com.ibm.rdm.web.model.resources.ResourceManager");
dojo.require("com.ibm.rdm.web.server.client.utils.TypeServiceUtil");
dojo.require("com.ibm.rdm.web.history.RevisionsCache");
dojo.require("com.ibm.rdm.web.project.UploadArtifactForm");
dojo.require("com.ibm.rdm.web.common.MessageForm");
dojo.require("com.ibm.rdm.web.common.MessageHandler");
dojo.require("com.ibm.rdm.web.common.ArtifactIcons");
dojo.require("com.ibm.rdm.web.server.client.utils.ResourceUtil");
dojo.require("com.ibm.rdm.web.common.Splitter");
dojo.require("com.ibm.rdm.web.server.client.utils.ArtifactTemplateUtil");
dojo.require("com.ibm.rdm.web.picker.CopyFolderPicker");
dojo.require("com.ibm.rdm.web.external.ImportWizard");
dojo.require("com.ibm.rdm.web.server.cache.ProcessOperationsCache");
dojo.require("com.ibm.rdm.web.project.EditManager");
dojo.require("com.ibm.rdm.web.util.queryutils");
dojo.require("com.ibm.rdm.web.suspicion.model.types");
dojo.require("com.ibm.rdm.web.model.types.GridColumnTypes");
dojo.require("com.ibm.rdm.web.suspicion.SuspectLinksUtil");
dojo.require("com.ibm.rdm.web.project.FirstArtifactInModuleHelper");
dojo.require("com.ibm.rdm.web.links.LinkTypeUtils");
dojo.require("com.ibm.rdm.web.viewer.RecentlyViewedSection");
dojo.require("com.ibm.rdm.web.locks.LockManager");
dojo.require("com.ibm.rdm.web.extensions.APIEventTopics");
dojo.require("com.ibm.rdm.web.common.dnd.DragTypes");
dojo.require("com.ibm.rdm.web.links.linkutils");
dojo.require("com.ibm.rdm.web.util.storage");
dojo.require("com.ibm.rdm.web.artifactgrid.ArtifactConstants");
dojo.require("com.ibm.rdm.web.artifactgrid.headingTypes");
dojo.require("com.ibm.rdm.web.project.ModuleComboButton");
dojo.require("com.ibm.rdm.web.links.SimpleLinkDialog");
dojo.require("com.ibm.rdm.web.common.ComboButton");
dojo.require("com.ibm.rdm.web.icons.IconManager");
dojo.require("com.ibm.rdm.web.util.vvcutils");
dojo.require("com.ibm.rdm.web.common.Constants");
dojo.require("com.ibm.rdm.web.viewer.viewerutils");
dojo.require("com.ibm.rdm.web.linkvalidity.LinkValidityUtils");

dojo.requireLocalization("com.ibm.rdm.web.project", "DashboardTabPage");


var ArtifactTemplateUtil = com.ibm.rdm.web.server.client.utils.ArtifactTemplateUtil;
var ChangeNotifier = com.ibm.rdm.web.notifications.ChangeNotifier;
var MimeTypes = com.ibm.rdm.web.common.MimeTypes;
var ArtifactIcons = com.ibm.rdm.web.common.ArtifactIcons;
var ProcessOperationsCache = com.ibm.rdm.web.server.cache.ProcessOperationsCache;
var ProjectCache = com.ibm.rdm.web.common.ProjectCache;
var RRMTypes = com.ibm.rdm.web.model.types.RRMTypes;
var ResourceLinksHandler = com.ibm.rdm.web.common.ResourceLinksHandler;
var ResourceManager = com.ibm.rdm.web.model.resources.ResourceManager;
var ResourceUtil = com.ibm.rdm.web.server.client.utils.ResourceUtil;
var RevisionsCache = com.ibm.rdm.web.history.RevisionsCache;
var StatusDisplay = com.ibm.rdm.web.common.StatusDisplay;
var SuspectLinksUtil = com.ibm.rdm.web.suspicion.SuspectLinksUtil;
var TypeServiceUtil = com.ibm.rdm.web.server.client.utils.TypeServiceUtil;
var ViewServiceClient = com.ibm.rdm.web.query.ViewServiceClient;
var domutils = com.ibm.rdm.web.util.domutils;
var queryutils = com.ibm.rdm.web.util.queryutils;
var LinkTypeUtils = com.ibm.rdm.web.links.LinkTypeUtils;
var RecentlyViewedSection = com.ibm.rdm.web.viewer.RecentlyViewedSection;
var LockManager = com.ibm.rdm.web.locks.LockManager;
var DragTypes = com.ibm.rdm.web.common.dnd.DragTypes;
var DashboardConstants = com.ibm.rdm.web.project.DashboardConstants;
var MimeTypeRegistry = com.ibm.rdm.web.common.MimeTypeRegistry;
var IconManager = com.ibm.rdm.web.icons.IconManager;
var linkutils = com.ibm.rdm.web.links.linkutils;
var headingTypes = com.ibm.rdm.web.artifactgrid.headingTypes;
var VvcUtils = com.ibm.rdm.web.util.vvcutils;
var ArtifactConstants = com.ibm.rdm.web.artifactgrid.ArtifactConstants;
var Constants = com.ibm.rdm.web.common.Constants;
var viewerutils = com.ibm.rdm.web.viewer.viewerutils;
var LinkValidityUtils = com.ibm.rdm.web.linkvalidity.LinkValidityUtils;

// TODO Read the padding settings in from CSS.
var FILTER_SECTIONS_CONTAINER_TOP_PADDING = 2;
var FILTER_SECTIONS_CONTAINER_BOTTOM_PADDING = 0;
var GAP_BETWEEN_FILTER_SECTIONS = 0;
var FILTER_SECTION_WIDTH = 250;
var ONE_CLICK_COOKIE = "isOneClickCreateEnabled";

dojo.declare(
	"com.ibm.rdm.web.project.DashboardTabPage",
	[dijit._Widget, dijit._Templated],
{
	// summary:
	//		This class is used to present content associated with views that contain
	//		a result set grid area.
	// description:
	//		This class is used to present the content within the following view types:
	//		- Browse Artifacts
	//		- Browse Collections
	//		- Browse Modules
	//		- A particular Module
	//		- A particular Collection

	templateString: null, //To un-inherit from superclass
	templatePath: dojo.moduleUrl("com.ibm.rdm.web", "project/templates/DashboardTabPage.html"),
	widgetsInTemplate: true,

	rdmModulePath: dojo.moduleUrl("com.ibm.rdm.web"),

	///////////////////////////////////////////////////////////////////////////////////
	// Attach points

	_leftSidebarContentPane: null,
	_filterSectionsContainerDiv: null,
	_resultSetDiv: null,
	_borderContainer: null,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Public fields

	projectURI: null,
	folderId: null,	//ID of initially applied folder
	filterId: null, //ID of initially applied saved filter
	baselineURI: null,
	footerHeight: null,
	// viewType: object (representing an enum)
	//		The value of this field must be one of the values found in the
	//		DashboardConstants.VIEW_TYPES property list.
	viewType: null,
	implementedByAvailable: false,
	trackedByAvailable: false,
	affectedByAvailable: false,
	validatedByAvailable: false,
	snapshotUnderConstruction: false,
	colRemovedCallback: null,
	loadCompleteCallback: null,
	loadCompleteScope: null,
	showBaseProperties:false,
	moduleStructure: null,
	dashboardToolbar: null,
	projectButtonAndMenuActions: null,
	
	//Special edit mode to modify saved filter without applying changes immediately
	filterEditMode: false,

	// getArtifactTypeURI: Function
	//		Get the artifact type URI associated with the currently opened module or collection.
	getArtifactTypeURI: null,
	
	// getArtifactOwnerURI: Function
	//		Get the URI of the process area that owns the currently opened module or collection.
	getArtifactOwnerURI: null,
	
	// In the case of a collection, we have an 'Add Existing Artifact' button
	// These fields maintain whether it is showing, and the function
	// to execute if it is clicked
	isAddToCollectionButtonActive: false,
	isAddToModuleButtonActive: false,
	onAddArtifacts: null,

	///////////////////////////////////////////////////////////////////////////////////
	// Private fields

	_messages: null,
	_tagsSection: null,
	_savedFiltersSection: null,
	_attributesSection: null,
	_foldersSection: null,
	_refreshInProgress: null,
	_resultSetGridView: null,
	_started: false,
	_beingDestroyed: false,
	_sectionsAndResultsSetViewAlreadyStarted: null,
	_deferredArray: null,
	_filterSectionsContainer: null,
	_moduleExplorerDiv: null,
	_disableModuleReuseMode: false,
	_toDestroy: [],
	_pageCache: {},
	
	_busyCursorTally: 0,

	_lastComboButtonWidth: 0,

	_filterSectionsAboveGapHeight: 0,

	_parentSidebarLayoutId: null,

	///////////////////////////////////////////////////////////////////////////////////
	// NLS fields requiring translation

	name: null,
	lastModifiedBy: null,
	lastModifiedDate: null,
	
	/////////////////////////////////////////////////////////////////////////////////
	// Total number of artifacts in the view 
	totalArtifactCount: 0,
	///////////////////////////////////////////////////////////////////////////
	// Public API

	postCreate: function() {
		// Note by SPC: I would have preferred to just add a:
		//     _splitterClass="com.ibm.rdm.web.common.Splitter"
		// to the DashboardTabPage.html template, but that doesn't seem to work
		// so instead we make the following assignment ...
		this._borderContainer._splitterClass = "com.ibm.rdm.web.common.Splitter";

		this._connections = [];
		this._toDestroy = [];
		this._sectionsAndResultsSetViewAlreadyStarted = false;
		this._refreshInProgress = false;
		this._busyCursorTally = 0;
		
		//We show a 'need filter' meesage - until the user has cleared a filter explicitly. 91953: Backout this behaviour
		this._filtersHaveBeenChanged = false;
		
		//always show base properties outside of module by default, unelss specified otherwise (collections, baselines etc.)
		this.showBaseProperties = (this.viewType !== DashboardConstants.VIEW_TYPES.MODULE);
		
		// Please note that in the following we're giving preference to initially
		// displaying the folders section (as Bill from UX has specified) ... but
		// only if a folders section is present (which is in artifacts, modules and collections pages).
		// In addition we're also showing the headerDiv only in the case of the artifacts, modules
		// and collections pages (by default the widget template code has "display: none;" on it).

		var indexOfInitialFilterSectionToSelect;
		if (this.viewType === DashboardConstants.VIEW_TYPES.ARTIFACTS
			|| this.viewType === DashboardConstants.VIEW_TYPES.COLLECTIONS
			|| this.viewType === DashboardConstants.VIEW_TYPES.MODULES) {
			indexOfInitialFilterSectionToSelect = 3;
		} else {
			indexOfInitialFilterSectionToSelect = 0;
		}
		
		if (this.viewType === DashboardConstants.VIEW_TYPES.ARTIFACTS
			|| this.viewType === DashboardConstants.VIEW_TYPES.COLLECTIONS
			|| this.viewType === DashboardConstants.VIEW_TYPES.MODULES) {
			dojo.style(this._headerDiv, "display", "");
			dojo.addClass(this.domNode, "headerPagerIsPresent");
		}
		else if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
			dojo.addClass(this.domNode, "headerPagerIsPresent");
		}

		// Create a container that will hold all of the filter sections (saved
		// filters, tags, attributes and folders).
		this._filterSectionsContainer = new com.ibm.rdm.web.project.FilterSectionsContainer(
			{
				cookieName: (!this.baselineURI ? (this.projectURI + "_" + this.viewType + "_filterStateCookie") : null),
				indexOfInitialFilterSectionToSelect: indexOfInitialFilterSectionToSelect,
				gapBetweenFilterSections: GAP_BETWEEN_FILTER_SECTIONS
			},
			this._filterSectionsContainerDiv
		);
		this._toDestroy.push(this._filterSectionsContainer);
		
		// Note by SPC: I would have preferred to use just a CSS style rule
		// involving setting of padding-top for this container in order to
		// achieve a small gap above it.  However, it appears not to work
		// for IE8 (only).  As a workaround I'm creating a div to achieve
		// the same purpose.
		var div = document.createElement("div");
		div.style.height = FILTER_SECTIONS_CONTAINER_TOP_PADDING + "px";
		this._filterSectionsContainer.domNode.parentNode.insertBefore(
			div, this._filterSectionsContainer.domNode);

		// Add the "Saved Filters" section.
		
		this._savedFiltersSection = new com.ibm.rdm.web.project.SavedFiltersSection(
			{
				projectURI: this.projectURI,
				resourceURI: this.resourceURI,
				filterSectionsContainer: this._filterSectionsContainer,
				sectionWidth: FILTER_SECTION_WIDTH,
				baselineURI: this.baselineURI,
				sectionTitle: this._messages.filterSavedFilters,
				dashboardTabPage: this,
				viewType: this.viewType,
				getArtifactTypeURI: this.getArtifactTypeURI,
				getArtifactOwnerURI: this.getArtifactOwnerURI
			},
			null
		);
		this._toDestroy.push(this._savedFiltersSection);
		
		this._filterSectionsContainer.addFilterSection(this._savedFiltersSection);

		// Add the "Filter Display by Tag" section.
		this._tagsSection = new com.ibm.rdm.web.project.TagsSection(
			{
				projectURI: this.projectURI,
				filterSectionsContainer: this._filterSectionsContainer,
				sectionWidth: FILTER_SECTION_WIDTH,
				baselineURI: this.baselineURI,
				snapshotUnderConstruction: this.snapshotUnderConstruction,
				sectionTitle: this._messages.filterDisplayByTag,
				dashboardTabPage: this
			},
			null
		);
		this._toDestroy.push(this._tagsSection);
		
		this._tagsSection._updateClearFilterState();
		this._filterSectionsContainer.addFilterSection(this._tagsSection);
		
		// Add the "Filter Display by Attribute" section.
		var restrictedArtifactFormatNames;
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			// Make sure that if the user uses an "Artifact format" filter the resulting listed
			// artifact formats will NOT include Collection or Module.
			restrictedArtifactFormatNames =
				RRMTypes.getFilteredArtifactFormats(
					this.projectURI,
					[
						RRMTypes.ARTIFACT_FORMAT_NAMES.Collection,
						RRMTypes.ARTIFACT_FORMAT_NAMES.Module
					]
				);
		}
		else if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
			// Make sure that if the user uses an "Artifact format" filter the resulting listed
			// artifact formats will NOT include Collection.
			restrictedArtifactFormatNames =
				RRMTypes.getFilteredArtifactFormats(
					this.projectURI,
					[RRMTypes.ARTIFACT_FORMAT_NAMES.Collection]
				);
		}
		var attributesSectionProperties = {
			projectURI: this.projectURI,
			filterSectionsContainer: this._filterSectionsContainer,
			sectionWidth: FILTER_SECTION_WIDTH,
			sectionTitle: this._messages.filterDisplayByAttribute,
			dashboardTabPage: this,
			viewType: this.viewType,
			baselineURI: this.baselineURI
		};
		if (restrictedArtifactFormatNames) {
			attributesSectionProperties.restrictedValuesToUseInArtifactFormats = {
				artifactFormats: restrictedArtifactFormatNames
			};
		}
		this._attributesSection = new com.ibm.rdm.web.project.AttributesSection(
			attributesSectionProperties
		);
		this._toDestroy.push(this._attributesSection);
		
		this._filterSectionsContainer.addFilterSection(this._attributesSection);

		// Add the "Filter Display by Folder" section for all sections - apart from collections & modules themselves
		if (this.viewType !== DashboardConstants.VIEW_TYPES.COLLECTION 
				&& this.viewType !== DashboardConstants.VIEW_TYPES.MODULE) {
			var initialFolder = null;
			
			//ignore initial folder if there is a filter specified
			if (this.folderId && !this.filterId){
				initialFolder = this.folderId;
				//If we are told the folder to display, don't try to resurrect filters from local storage
				this._ignoreLocalStorage = true;
			}
			this._foldersSection = new com.ibm.rdm.web.project.FoldersSection(
				{
					projectURI: this.projectURI,
					isMultiSelect: true,
					filterSectionsContainer: this._filterSectionsContainer,
					sectionWidth: FILTER_SECTION_WIDTH,
					includeContextMenu: true,
					initiallySelectedFolderURI: initialFolder,
					baselineURI: this.baselineURI,
					snapshotUnderConstruction: this.snapshotUnderConstruction,
					sectionTitle: this._messages.filterDisplayByFolder,
					dashboardTabPage: this,
					persistState: this.baselineURI ? false : true,		// Persist the expansion state in a cookie only
																		// if we are not displaying a baseline.  For
																		// baselines we do not need to preserve the expansion
																		// state, and we must not share the cookie with the
																		// normal project dashboard tree.
					persistCookieName: this.projectURI + "_DashboardTree_",	// Name of cookie to persist under.
					suppressInitialRootFolderSelection: true,	//Skip auto selection of root folder always
					isInPicker: false
					//suppressInitialRootFolderSelection: (this.filterId ? true : false)	//Skip auto selection of root folder if
					//																	//a saved filter ID is passed
				},
				null
			);
			this._toDestroy.push(this._foldersSection);
			
			this._filterSectionsContainer.addFilterSection(this._foldersSection);
			// Make sure RecentlyViewedSection has access to foldersSection
			RecentlyViewedSection.setFoldersSection(this._foldersSection);
		}
		var configureGridArgs = {
			onSelectionChange: dojo.hitch(this, function(selection) {
				
				var objectTypeURI = null;
				if(selection.length > 0){
					var selectedGridResource = this._resultSetGridView.getRecordInfo([selection[selection.length-1].uri]);
					var types = selectedGridResource.getTypes();
					for (var typeURI in types) {
						objectTypeURI = typeURI;
						break;
					}
					this.isAddToCollectionButtonActive = false;
					this.isAddToModuleButtonActive = false;
					this.updateCreateButtonLabel(objectTypeURI);
				}
				
				this._resultSetGridView.setNumSelected(selection.length);
				
				var selectionUris = [];
				dojo.forEach(selection, function(selItem) {selectionUris.push(selItem.uri);});
				
				this.ensureInCache(selectionUris, dojo.hitch(this, function() {
					var notifierArgs = dojo.map(selection, dojo.hitch(this, function(s) {
						var resource = this._resultSetGridView.getRecordInfo(s.uri);
						resource.moduleURI = (this.moduleStructure && this.moduleStructure.moduleURI);
						
						return resource;
						
					}));
					
					//Update the sidebars if active
					if (this.resourceViewer) {
						this.resourceViewer.setSelection(notifierArgs);
					}
				
					ChangeNotifier.notifyListeners({
						eventTopic: com.ibm.rdm.web.extensions.APIEventTopics.ARTIFACT_SELECTED,
						resources: notifierArgs
					}); 	
				}));
			})
		};
		
		this.dragDropArgs = this.configureDragDropArgs(this.dragDropArgs);

		this._resultSetGridView = new com.ibm.rdm.web.project.ResultSetGridView(
			{
				projectURI: this.projectURI,
				resourceURI: this.resourceURI,
				baselineURI: this.baselineURI,
				_isInHistoryMode: (this.resourceViewer && this.resourceViewer.isInHistoryMode()),
				_isInReviewMode: (this.resourceViewer && this.resourceViewer.isInReviewMode()),
				_viewType: this.viewType,
				projectToolbar: this.dashboardToolbar,
				projectButtonAndMenuActions: this.projectButtonAndMenuActions,
				dashboardTabPage: this,
				configureGridArgs: configureGridArgs,
				fixedPageSize: this.fixedPageSize,
				moduleStructure: this.moduleStructure,
				dragDropArgs: this.dragDropArgs,
				fetchArtifactsToMatchView: dojo.hitch(this, this._performViewRequestOnURIs),
				getArtifactTypeURI: this.getArtifactTypeURI,
				headerNodes: {
					headerDiv: this._headerDiv,
					headerTitleSpan: this._headerTitleSpan,
					hoverSpan: this._hoverSpan,
					toolbarContainer: this._toolbarContainer
				},
				onHidePagingWidget: this.onHidePagingWidget,
				onShowPagingWidget: this.onShowPagingWidget
			},
			this._resultSetDiv
		);
		this._toDestroy.push(this._resultSetGridView);
		
		
		if (this.dashboardToolbar) {
			this.dashboardToolbar.set("projectURI", this.projectURI);
		}
		this._started = false;
		this._beingDestroyed = false;
		this._deferredArray = [];
		
		this.addListeners();

		this._handleLeftSidebarResizeEvents();
		
		this._createComboButton();
		
		//Set the 'default' configuration
		this._defaultConfiguration = {
				columns: null,
				displayedLinks: [],
				sortBy: null,
				groupBy: null,
				expansionLevel: -1,
				expansionRules: [],
				hierarchyLevel: null // null means "Show Full Hierarchy"
		};
		
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE){
			
			this.connect(this.moduleStructure, "onChange", this.destroyOrShowCreateFirstArtifactHelper);
			this.connect(this.moduleStructure, "onChange", this.enableOrDisableCreateButton);
			this.connect(this.moduleStructure, "onLoad", this.destroyOrShowCreateFirstArtifactHelper);
			this.connect(this.moduleStructure, "onLoad", this.enableOrDisableCreateButton);
			
			this._defaultConfiguration.columns = [
				{
					colType: "s",
					colURI: "id-col",
					width: "" + ArtifactConstants.ID_COL_WIDTH
				},
				{
					colType: "s",
					colURI: ArtifactConstants.MODULE_CONTENT_COL,
					width: "" + ArtifactConstants.MODULE_CONTENT_COL_WIDTH
				}
			];
			//If no other sort is provided on a module, sort should be ascending bookorder
			this._defaultConfiguration.sortBy = {
					def: RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.BookOrder,
					order: "a",
					sortType: "custom"
			};
		}
		else{
			this._defaultConfiguration.columns = [
				{
					colType: "s",
					colURI: "id-col",
					width: "" + ArtifactConstants.ID_COL_WIDTH
				},
				{
					colType: "s",
					colURI: "name",
					width: "" + ArtifactConstants.TITLE_COL_WIDTH
				},
				{
					colType: "s",
					colURI: "obj_type_col",
					width: "" + ArtifactConstants.TYPE_COL_WIDTH
				},
				{
					colType: "s",
					colURI: "mod-user",
					width: "" + ArtifactConstants.CONTRIBUTOR_COL_WIDTH
				},
				{
					colType: "s",
					colURI: "mod-date",
					width: "" + ArtifactConstants.MODIFIED_ON_COL_WIDTH
				}
			];
		}
		
		var projectOperationsDeferred = com.ibm.rdm.web.common.ProjectCache.getProjectPermissions(this.projectURI);
		projectOperationsDeferred.addCallback(this, function(projectOperations){
			var canCreateLinks = projectOperations.item(com.ibm.rdm.web.common.ProjectCache.MODIFY_RESOURCE);
			// Below here added for drag-n-drop ResourceWrapper Creation
			if (canCreateLinks && (dojo.isIE > 9 || !dojo.isIE) && !this.baselineURI && !this.isInReviewMode){
				
				
				var dropMessage = '<span style="text-align: center; font-size: 14pt; padding-top: 16px; padding-bottom: 16px;">'+this._messages["dropHere"]+'</span>';
				if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
					dropMessage = "";
				}
				
				this._dropMessageBox = new dijit.Tooltip({
					label: dropMessage,
					position: ["above"]
				});
				
				this._toDestroy.push(this._dropMessageBox);
				var dropZone1 = new com.ibm.rdm.web.common.dnd.DropZone({
					node: this._centerContent.domNode,
					accepts: [DragTypes.FILES],
					onDrop: dojo.hitch(this, function(ev) {
						dojo.removeClass(this._resultSetGridView.domNode, "dragging");
						dojo.removeClass(this._resultSetGridView.grid.module.getDndWrapper(), "dndFiles");
						this._startDropUpload(ev.baseEvent);
						dojo.stopEvent(ev.baseEvent);
					}),
					onDragOver: dojo.hitch(this, function(ev){
						dojo.addClass(this._resultSetGridView.grid.module.getDndWrapper(), "dndFiles");
						ev.dataTransfer.dropEffect = 'copy';
					}),
					onDragEnter: dojo.hitch(this, function(ev){
						this._dropMessageBox.open(this._centerContent.domNode);
						dojo.stopEvent(ev);
					}),
					onDragLeave: dojo.hitch(this, function(ev, abort){
						this._handleLeaveOrAbort(
							true, // leave
							ev
						);
					})
				});
				this._toDestroy.push(dropZone1);
			}
		});
		VvcUtils.isChangeSetWorkflowEnabledOnCurrentConfiguration().then(dojo.hitch(this, function(workflowEnabled) {
			if (VvcUtils.isCurrentConfigurationSnapshot() || workflowEnabled) {
				dojo.addClass(this.domNode, "snapshot");
			}
		}));
		
		this.preventDropRedirect();
	},
	
	onHidePagingWidget: function() {
		// summary:
		//		User defined function to handle the case of the paging widget
		//		getting hidden (i.e. 'display' set to 'none').
		// tags:
		//		callback
	},

	onShowPagingWidget: function() {
		// summary:
		//		User defined function to handle the case of the paging widget
		//		getting shown (i.e. 'display' set to '').
		// tags:
		//		callback
	},

	preventDropRedirect: function() {
		// summmary
		//		Adds drop listener to the document node.
		if(dojo.isIE) {
			// IE doesn't navigate to the artifact on drop, so we won't bother.
			return;
		}
		this._toDestroy.push(new com.ibm.rdm.web.common.dnd.DropZone({
			node: document,
			accepts: [DragTypes.RRC_MODULE, DragTypes.RRC_ARTIFACT],
			onDragOver: dojo.hitch(this, function(ev){
				ev.dataTransfer.dropEffect = 'none';
			}),
			onDrop: dojo.hitch(this, function(ev) {
				dojo.stopEvent(ev.baseEvent);
			})
		}));
	},

	isCurrentQueryDefaultQuery: function() {
		// summary:
		//		Return true if and only if the current filters and grid settings 
		//		represent the "default" filters and grid settings.
		// description:
		//		The default filters are NO filters so we'd return false if any
		//		filters are currently in effect.  Likewise, we'd return false
		//		if the user has customized in any way how things are presented
		//		in the result set area (please see the _isUsingDefaultGridSettings
		//		method for details on that).

		var params = this._getViewServiceRequestParams(true);
		var isDefaultAttributeConditionInfos = dojo.hitch(this, function(attributeConditionInfos){
			switch (this.viewType) {
			case DashboardConstants.VIEW_TYPES.MODULES:
			case DashboardConstants.VIEW_TYPES.COLLECTIONS:
				// Note: The Modules and Collections views have a "built in" filter for 
				// restricting the artifact format to either Module or Collection, so
				// we ignore that single filter for these cases.
				return attributeConditionInfos && attributeConditionInfos.length === 1;
			default:
				return this._isNullOrEmptyArray(attributeConditionInfos);
			}
		});
		
		if (this._isNullOrEmptyArray(params.tagURIs) &&
			this._isNullOrEmptyArray(params.folderURIs) &&
			isDefaultAttributeConditionInfos(params.attributeConditionInfos) &&
			this._isNullOrEmptyArray(params.linkedArtifactConditionInfos) &&
			this._isNullOrEmptyArray(params.clmFilters) &&
			!params.artifactTypeConditionInfo &&
			!params.whereUsedConditionInfo &&
			this._isUsingDefaultGridSettings()
		   )
		{
			return true;
		} else {
			return false;
		}
	},

	_handleLeaveOrAbort: function(/*Boolean*/isLeave, /*Object?*/event) {
		// Note: if isLeave is set to false it means we're aborting.
		var bumpScroller = this._resultSetGridView.bumpScroller;
		if (bumpScroller && !bumpScroller.isMouseWithinBumperZone()) {
			dojo.removeClass(this._resultSetGridView.grid.module.getDndWrapper(), "dndFiles");
		}
		if (event) {
			dojo.stopEvent(event);
		}
		var closeMessageBoxAndTweakDndCss = dojo.hitch(this, function(){
			this._dropMessageBox.close();
			dojo.removeClass(this._resultSetGridView.domNode, "dragging");
		});
		//Prevent premature vanishing of the upload area
		if (isLeave) {
			var dropBoxCoords = dojo.position(this._centerContent.domNode);
			var contentLeft = dropBoxCoords.x;
			var contentRight = dropBoxCoords.x + dropBoxCoords.w;
			var contentBottom = dropBoxCoords.y + dropBoxCoords.h;
			var contentTop = dropBoxCoords.y;
			if (event.pageX < contentLeft || event.pageX > contentRight ||
				event.pageY < contentTop || event.pageY > contentBottom){
				closeMessageBoxAndTweakDndCss();
			}
		} else {
			closeMessageBoxAndTweakDndCss();
		}
	},

	_performViewRequestOnURIs: function (uris, /*Array?*/additionalAttributes) {
		// summmary:
		//       Gets row details for additional URIs, looking like the current grid settings.
		// uris:
		//       an array of URIs
		// additionalAttributes:
		//       an array of attributedefinition URIs to add to those requested
		// returns:
		//       callback which calls back with view response data - has an array of
		//       resources and also link data if applicable

		var viewDeferred = new dojo.Deferred();
		var viewServiceRequestParams = this._getViewServiceRequestParams(true);
		if (additionalAttributes) {
			viewServiceRequestParams.requestedAttributeUris =
				viewServiceRequestParams.requestedAttributeUris.concat(additionalAttributes);
		}

		// Pass 'artifactUris' so that we get info for our already known set of URIs.
		viewServiceRequestParams.artifactUris = uris;

		// It's not necessarily the case that the artifactUris would match the current
		// filters so we need to make sure to "blank them out" (so to speak).  For example,
		// perhaps the user just created a new artifact that's in a different folder than
		// the currently selected folder, or the user has created a new artifact that
		// doesn't contain the tag that's currently selected.  In these cases this method
		// is called to enable adding a new "yellow row" that doesn't necessarily match the
		// currently selected filters.
		viewServiceRequestParams.collectionURI = null;
		viewServiceRequestParams.folderURIs = null;
		viewServiceRequestParams.tagURIs = null;
		viewServiceRequestParams.artifactTypeConditionInfo = null;
		viewServiceRequestParams.whereUsedConditionInfo = null;
		viewServiceRequestParams.attributeConditionInfos = null;
		viewServiceRequestParams.linkedArtifactConditionInfos = null;
		viewServiceRequestParams.clmFilters = null;
		viewServiceRequestParams.suspicionProfileURIs = null;

		viewServiceRequestParams.pageRequested = null;
		viewServiceRequestParams.pageSize = null;
		viewServiceRequestParams.processLockInfo = true;

		var viewRequestDeferred = ViewServiceClient.getViewContents(viewServiceRequestParams);
		viewRequestDeferred.then(dojo.hitch(this, function (resp) {
			var viewServiceResults = ViewServiceClient.parseViewContentsResponse(resp, this.projectURI, {}, false);
			viewDeferred.callback(viewServiceResults);
			return resp;
		}));
		
		return viewDeferred;
	},
	
	_startDropUpload: function(event){
		dojo.stopEvent(event);
		this._dropMessageBox.close();
		var filesToUpload = [];
		if (event.dataTransfer.files){
			for (var i = 0; i < event.dataTransfer.files.length; i++){
				if (event.dataTransfer.files[i].size > 0){
					filesToUpload.push(event.dataTransfer.files[i]);
				}
			}
		}
		if (filesToUpload.length > 0){
			// Create upload form
			this._uploadArtifact(filesToUpload);
		}
	},
	
	navigateAwayFunction: function(arg) {
		return this._resultSetGridView.clickNavigateAwayEvent(arg);
	},

	_resizeComboButtonWidth: function(/*Int?*/widthToUse) {
		if (widthToUse) {
			this._lastComboButtonWidth = widthToUse;
		}
		if (this._lastComboButtonWidth
			&& dojo.isFunction(this._comboButtonWidget.resizeToFitInWidth))
		{
			this._comboButtonWidget.resizeToFitInWidth(
				this._lastComboButtonWidth
			);
		}
	},

	_handleLeftSidebarResizeEvents: function() {
		this._leftSidebarContentPane.connect(
			this._leftSidebarContentPane,
			"resize",
			dojo.hitch(this, function(resultSize) {
				if (resultSize) {
					var height = resultSize.h;
					this._filterSectionsContainer.setHeight(
						height
						- this._filterSectionsAboveGapHeight
						- FILTER_SECTIONS_CONTAINER_TOP_PADDING
						- FILTER_SECTIONS_CONTAINER_BOTTOM_PADDING
					);
				}
				this._resizeComboButtonWidth(this._createNewAritfactButtonContainerDiv.clientWidth);
			})
		);
	},

	_refreshResource: function(eventparams) {
		// No need to do a refresh if there is a refresh pending as refresh resource will be handle later.
		if (com.ibm.rdm.web.project.EditManager.isRefreshPending) {
			return;
		}
		
		//No need to do a refresh in the case of an inline edit.
		//Refresh is already done through _viewResourceInGrid when save begins
		if (!eventparams.notifierParams.inlineEdit){
			var resourcesChanged = null;
			var resourceURI = eventparams.notifierParams.resourceURI;
			if (!resourceURI && eventparams.notifierParams.resourceURIs) {
				resourcesChanged = eventparams.notifierParams.resourceURIs;
			} else {
				resourcesChanged = [resourceURI];
			}
			
			if (eventparams.notifierParams.resources) {
				this._resultSetGridView.refreshResources(eventparams.notifierParams.resources, eventparams.notifierParams.noFocus, eventparams.notifierParams.isDirty);
			}
			else if (resourcesChanged) {
				// we only want to omit  lock information from the view request if
				// we are passed a boolean value of true for "lockInfoNotIndexed" in
				// the event parameter.
				var includeLockInfo = true,
					lockInfoNotInIndex = ((typeof eventparams.notifierParams.lockInfoNotIndexed === "boolean")
									&& eventparams.notifierParams.lockInfoNotIndexed);
									
				if (lockInfoNotInIndex) {
					includeLockInfo = false;
				} 
													
				this._resultSetGridView.refreshArtifacts(resourcesChanged, includeLockInfo);
			}
		}
	},
	
	_viewResourceInGrid: function(eventparams) {
		//We don't want to refresh if the edit is started from the sidebar.
		if (!eventparams.notifierParams.isForSelection) {
			this._resultSetGridView.refreshResources(
				eventparams.notifierParams.resources,
				eventparams.notifierParams.noFocus,
				eventparams.notifierParams.isDirty
			);
		}
	},

	startup: function() {
		this.inherited(arguments);
		this._borderContainer.startup();
		// Add an identifying css classname to the splitter used by this widget so
		// that it can be interrogated for in a dojo.query(...) call.  We're making
		// sure _not_ to add this classname in the Splitter class itself, as that
		// class should be generic (i.e. in the future we may be using it for other
		// purposes than just the splitter used for the left hand sidebar's filtering
		// sections).
		var splitterArray = dojo.query("div.rdmSplitter", this.domNode),
			splitterNode = splitterArray[0];
		if (splitterNode) {
			dojo.addClass(splitterNode, Constants.LEFT_SIDE_FILTERS_SIDEBAR_SPLITTER_CSS_CLASSNAME);
		}
	},
	
	postMixInProperties: function() {
		this._messages = dojo.i18n.getLocalization("com.ibm.rdm.web.project", "DashboardTabPage");
		dojo.forEach(
			[
				"name",
				"lastModifiedBy",
				"lastModifiedDate"
			],
			function(prop){ this[prop] = this._messages[prop]; }, this);
	},

	initIfNeeded: function() {
		// summary:
		//		Initialize the dashboard sections and results view when the
		//		tab container containing this page is first selected.
		// description:
		//		We use this function, rather than a 'startup' function, as startup
		//		is automatically called by the tab container when content is
		//		added to one of its content panes.  By using a separate function
		//		like this we can avoid needlessly initializing the content until
		//		it's actually needed.
		if (this._sectionsAndResultsSetViewAlreadyStarted) {
			return;
		}
		var defArray = [];
		// Tags will be populated when the section is expanded or saved filter includes a tag.
		// Do so to improve performance.
		if (this._attributesSection) {
			defArray.push(this._attributesSection.startup());
		}
		defArray.push(this._resultSetGridView.startup());
		var isIgnoreLocalStorage = !!this._ignoreLocalStorage;
		//Ensure we ignore local storage only once
		delete this._ignoreLocalStorage;
		
		var localStorageFiltersNeedToBeApplied = (
			this._savedFiltersSection && this._savedFiltersSection.initialStateNeedsToBeApplied && !isIgnoreLocalStorage
		);
		if (this._foldersSection) {
			// we need to wait until folders section is populated 
			// so that we could get our hands on the ROOT element 
			// and make it a default selection
			this._foldersSection.startup();
			if (!this.filterId && !localStorageFiltersNeedToBeApplied) {
				this._foldersSection._folderStore._foldersDeferred.addCallback(
						this, function() {
							this._populateContents();
						});
			} else{
				defArray.push(this._foldersSection._folderStore._foldersDeferred);
			}
		}
		else {
			if (!this.filterId && !localStorageFiltersNeedToBeApplied) {
				if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
					if (this.moduleStructure.isLoaded) {
						this._populateContents();
					} else {
						
						var tmpCon = dojo.connect(this.moduleStructure, "onLoad", this, function () {
							dojo.disconnect(tmpCon);
							StatusDisplay.hideStatusMessage();								
							this._populateContents();
							
						});
						this._connections.push(tmpCon);
					}
				}
				else{
					this._populateContents();
				}
			}
		}
		if (this._tagsSection &&
			(this.filterId || localStorageFiltersNeedToBeApplied)
			) {
			defArray.push(this._tagsSection.startup());
		}
		if (this._savedFiltersSection &&
			(this.filterId || localStorageFiltersNeedToBeApplied)
			) {
			defArray.push(this._savedFiltersSection.startup());
		}

		var startDefList = new dojo.DeferredList(defArray);
		
		startDefList.addCallback(this, function(){
			var isViewSelected = false;
			if (this.filterId) {
				this._selectInitialSavedFilter();
				isViewSelected = true;
			}
			else if (localStorageFiltersNeedToBeApplied) {
				isViewSelected = this._savedFiltersSection.selectInitialFiltersIfAppropriate();
			}
			if (!isViewSelected) {
				this._savedFiltersSection.selectAPreferredView();
			}
			if (isIgnoreLocalStorage) {
				//We should ensure the folder section is expanded
				this._foldersSection.expandFolderSection();
			}
			this._filterSectionsContainer.startup();
		});
		
		this._sectionsAndResultsSetViewAlreadyStarted = true;
	},

	uninitialize: function() {
		this._beingDestroyed = true;

		if (!this.dashboardToolbar._beingDestroyed){
			this.dashboardToolbar.destroyRecursive();
		}
		
		if (this._borderContainer) {
			this._borderContainer.destroyRecursive();
		}
		this.removeListeners();
		
		dojo.forEach(this._connections, function (con) {
			dojo.disconnect(con);
		});
		
		dojo.unsubscribe(this._createArtifactsMenuHashListener);
		
		dojo.forEach(this._toDestroy, function(object){
			if (object.destroyRecursive && !object._beingDestroyed){
				object.destroyRecursive();
			}
			else if (object.destroy && !object._beingDestroyed){
				object.destroy();
			}
			delete (object);
		});
		
	},
	
	addListeners: function() {
		var isScrollPreservationOperationInProgress = false,
			isRowEditInProgress = false,
			isViewChangeInProgress = false;
		if (!this._listeners) {
			this._listeners = [];
			//Need to refresh entire page, as the basis that the filter may have changed.
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [
							//The ResultSetGrid needs to react to these too.
							com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_CREATED,
							com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_CHANGED,
							com.ibm.rdm.web.notifications.EventTopics.OBJECT_TYPE_DELETED,
							com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_DEFINITION_CREATED,
							com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_DEFINITION_CHANGED,
							com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_DEFINITION_DELETED,
							com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_TYPE_CREATED,
							com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_TYPE_CHANGED,
							com.ibm.rdm.web.notifications.EventTopics.ATTRIBUTE_TYPE_DELETED,
							com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_ADDED,
							com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_REMOVED,
							com.ibm.rdm.web.notifications.EventTopics.LINK_TYPE_UPDATED
							],
				callbackFunction: dojo.hitch(this, this.handleRefresh),
				callbackScope: this,
				projectURI: this.projectURI
			}));
			
			//Need only refresh the contents of the page, as the filter definition won't have changed, but the results of the query may have.
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [
							com.ibm.rdm.web.notifications.EventTopics.TAG_EDITED,
							com.ibm.rdm.web.notifications.EventTopics.TAG_DELETED,
							com.ibm.rdm.web.notifications.EventTopics.PAGE_DEFINITION_CHANGE,
							com.ibm.rdm.web.notifications.EventTopics.LINK_CONSTRAINTS_UPDATED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_MOVED
							],
				callbackFunction: dojo.hitch(this, this.refresh),
				callbackScope: this,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI
			}));
	
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CREATED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_COPIED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_MOVED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_DELETED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CHANGED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_RENAMED,
							com.ibm.rdm.web.notifications.EventTopics.MODULE_STRUCTURE_CHANGED
							],
				callbackFunction: dojo.hitch(this, this._expirePageCache),
				callbackScope: this,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI
			}));
			
			// Artifact saved doesn't set a resourceUriScope, so listen to these events
			// unscoped and expire the cache
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [
							com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED
							],
				callbackFunction: dojo.hitch(this, this._expirePageCache),
				callbackScope: this,
				projectURI: this.projectURI
			}));
			
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [
							com.ibm.rdm.web.notifications.EventTopics.PAGE_NUMBER_CHANGE
							],
				callbackFunction: dojo.hitch(this, this.changePage),
				callbackScope: this,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI
			}));
			
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CREATED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCE_COPIED,
							com.ibm.rdm.web.notifications.EventTopics.RESOURCES_COPIED
							],
				callbackFunction: dojo.hitch(this, this._addNewResourceOrResourcesToGrid),
				callbackScope: this,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI
			}));
			
			//Only the resource contents have changed. (This MAY result with it not being in the filter anymore, but
			//we'll let the user explicitly refresh to get that.)
			var listener3Topics = [
				com.ibm.rdm.web.notifications.EventTopics.RESOURCE_CHANGED,
				com.ibm.rdm.web.notifications.EventTopics.RESOURCE_RENAMED,
				com.ibm.rdm.web.notifications.EventTopics.RESOURCE_PROCESS_AREA_CHANGED,
				com.ibm.rdm.web.notifications.EventTopics.TAG_ARTIFACTS_UPDATED,
				com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SAVED
				];
			//Collections get these notifications, AND don't specify scope so they can get ones for edits to items in their collection.
			var resourceScope = null;
			if (this.viewType != DashboardConstants.VIEW_TYPES.COLLECTION &&
				this.viewType != DashboardConstants.VIEW_TYPES.MODULE){
				resourceScope = this.resourceURI;
			}
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: listener3Topics,
				callbackFunction: dojo.hitch(this, this._refreshResource),
				callbackScope: this,
				projectURI: this.projectURI,
				resourceUriScope: resourceScope
			}));
			
			this._listeners.push(ChangeNotifier.addListener({
				eventTopics: [com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_VIEW_MODE,
							com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_EDIT_MODE],
				callbackFunction: dojo.hitch(this, this._viewResourceInGrid),
				callbackScope: this,
				projectURI: this.projectURI,
				resourceUriScope: resourceScope
			}));
			
			this._listeners.push(ChangeNotifier.addListener({
				eventTopic: [com.ibm.rdm.web.notifications.EventTopics.ARTIFACT_SHOW_BASE_PROPERTIES],
				callbackFunction: this._toggleShowBaseProperties,
				callbackScope: this,
				resourceURIs: this.resourceURI,
				projectURI: this.projectURI
			}));

			if (this.viewType == DashboardConstants.VIEW_TYPES.MODULE) {
				this._listeners.push(ChangeNotifier.addListener({
					eventTopics: [com.ibm.rdm.web.notifications.EventTopics.MODULE_STRUCTURE_CHANGED],
					callbackFunction: function() {
						if (!isScrollPreservationOperationInProgress) {
							// We need to reset the grid's lastTopVisibleItem back to null in order to
							// avoid odd scrolling issues for Control-Enter (new row) and expand/collapse
							// (see Defect 102592 and Defect 102677).
							this._resultSetGridView.grid.set("lastTopVisibleItem", null);
							isScrollPreservationOperationInProgress = true;
						}
						this.reapplySelectedArtifacts();
					},
					callbackScope: this,
					projectURI: this.projectURI
				}));
			}

			if(this.dragDropArgs && this.dragDropArgs.onDragEnd) {
				this._listeners.push(ChangeNotifier.addListener({
					eventTopics: [com.ibm.rdm.web.notifications.EventTopics.DRAG_ENDED],
					callbackFunction: this.dragDropArgs.onDragEnd,
					callbackScope: this
				}));
			}
		}

		var focusRowInfo,
			topVisibleItem,
			ignoreHeightEventsTimeout = null;

		var performAppropriateScrolling = dojo.hitch(this, function(){
			// Note: In the case of using a shortcut to toggle the sidebars (ALT+SHIFT+M),
			// if a row currently has focus, we take care here to make sure that the end
			// result of toggling the sidebars is that this focus row will appear at the
			// same viewport vertical offset that it had _before_ the shortcut was invoked.
			// If there is no "focus row", then we use the normal "make sure that the same
			// top row is shown" processing.
			var focusKey = focusRowInfo ? focusRowInfo.key : null,
				rowViewportTopOffset = focusRowInfo ? focusRowInfo.rowViewportTopOffset : undefined,
				itemToScrollIntoView = focusKey || topVisibleItem;
			if (itemToScrollIntoView) {
				var row = this._resultSetGridView.grid.getRowByKey(itemToScrollIntoView);
				if (row && row.node) {
					// Scroll the item back to the view
					this._resultSetGridView.grid.module.scrollNodePosition(
						row.node,
						itemToScrollIntoView === topVisibleItem,
						false,
						rowViewportTopOffset
					);
				}
			}
		});
		var scrollAfterCenterContentWidthRemainsUnchanged = dojo.hitch(this, function(){
			// Note: When sidebars are toggled via a shortcut, after the toggling has
			// completed, we need to perform appropriate scrolling.  However, we can't
			// do that until the content area resizing has completed (and that resizing
			// is timer based [in ResultSetGridView]) so in the following we just wait
			// for the resizing to "settle down" (due to sidebar animation) and _then_
			// we perform the appropriate scrolling.
			var originalFocusRowInfo = focusRowInfo,
				originalTopVisibleItem = topVisibleItem,
				lastWidth = dojo.position(this._centerContent.domNode).w;
			var handle = window.setInterval(
				dojo.hitch(this, function(){
					var width = dojo.position(this._centerContent.domNode).w;
					if (width !== lastWidth) {
						lastWidth = width;
					} else {
						window.clearInterval(handle);
						// We use a timeout here so that we can have the normal processing of
						// GRID_PRE_PAGE_HEIGHT_RECALCULATE and GRID_PAGE_HEIGHT_CHANGE events
						// and then _after_ these events have been processed we reset 'focusRowInfo'
						// and 'topVisibleItem' to the values they were originally when
						// scrollAfterCenterContentWidthRemainsUnchanged was originally called.
						// This is needed due to the fact that these values may have been reset
						// via the GRID_PRE_PAGE_HEIGHT_RECALCULATE and GRID_PAGE_HEIGHT_CHANGE
						// events that have been processed since this function was originally called.
						if (ignoreHeightEventsTimeout) {
							window.clearTimeout(ignoreHeightEventsTimeout);
						}
						ignoreHeightEventsTimeout = window.setTimeout(
							function(){
								focusRowInfo = originalFocusRowInfo;
								topVisibleItem = originalTopVisibleItem;
								performAppropriateScrolling();
								focusRowInfo = null;
							},
							500
						);
					}
				}),
				200
			);
		});

		ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.ABOUT_TO_TOGGLE_SIDEBARS,
			callbackFunction: function(event) {
				if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE && this._isEventForThisLayout(event)) {
					focusRowInfo = this._resultSetGridView.grid.getLastFocusRowInfo();
					if (!focusRowInfo) {
						this._resultSetGridView.grid.getLastTopVisibleItem();
						topVisibleItem = this._resultSetGridView.grid.lastTopVisibleItem;
					}
					scrollAfterCenterContentWidthRemainsUnchanged();
				}
			},
			callbackScope: this
		});
		
		ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.GRID_PRE_PAGE_HEIGHT_RECALCULATE,
			callbackFunction: function() {
				if (!isScrollPreservationOperationInProgress && !isRowEditInProgress && !isViewChangeInProgress) {
					// Get the current top visible item and scroll it back to the view later if necessary
					this._resultSetGridView.grid.getLastTopVisibleItem();
					topVisibleItem = this._resultSetGridView.grid.lastTopVisibleItem;
					isScrollPreservationOperationInProgress = true;
				}
			},
			callbackScope: this
		});

		ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.EDIT_STARTED,
			callbackFunction: function() {
				isRowEditInProgress = true;
			},
			callbackScope: this
		});
		ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.EDIT_FINISHED,
			callbackFunction: function() {
				isRowEditInProgress = false;
			},
			callbackScope: this
		});

		ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.ABOUT_TO_CHANGE_VIEW,
			callbackFunction: function() {
				isViewChangeInProgress = true;
				if (!isScrollPreservationOperationInProgress && !isRowEditInProgress) {
					// Get the current top visible item and scroll it back to the view later if necessary
					this._resultSetGridView.grid.getLastTopVisibleItem();
					topVisibleItem = this._resultSetGridView.grid.lastTopVisibleItem;
					isScrollPreservationOperationInProgress = true;
				}
			},
			callbackScope: this
		});

		ChangeNotifier.addListener({
			eventTopics: [
				com.ibm.rdm.web.notifications.EventTopics.MODULE_GRID_RECONCILED,
				com.ibm.rdm.web.notifications.EventTopics.RESET_GOTO_ITEM_AT_IMG_LOADED
			],
			callbackFunction: function() {
				isScrollPreservationOperationInProgress = false;
				isViewChangeInProgress = false;
			},
			callbackScope: this
		});

		ChangeNotifier.addListener({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.GRID_PAGE_HEIGHT_CHANGE,
			callbackFunction: function() {
				performAppropriateScrolling();
			},
			callbackScope: this
		});
	},

	_isEventForThisLayout: function(notifierEvent) {
		if (!this._parentSidebarLayoutId) {
			var parentSidebarLayout = viewerutils.getAncestorSidebarLayoutCommon(this.domNode);
			if (parentSidebarLayout) {
				this._parentSidebarLayoutId = parentSidebarLayout.id;
			}
		}

		return this._parentSidebarLayoutId === notifierEvent.notifierParams.sidebarLayoutCommonId;
	},
	
	_enableOrDisableFisheye: function() {
		// summary:
		//		Either turns on or off the fisheye control.  This function
		//		is only called the columns change or a view is changed and
		//		the view type is "MODULE".  We check to see whether the
		//		module content colulmn is on display, fisheye on if yes
		//		off if no.
		var gridModel = this._resultSetGridView.grid.gridmodel,
						isContentCellVisible = false;
			
		isContentCellVisible = gridModel.isVisible(gridModel.getPrimaryRowTypeId(), 
				ArtifactConstants.MODULE_CONTENT_COL);
			
		
		if (!isContentCellVisible) {
			this._resultSetGridView.grid.disableFisheye();
		} else {
			this._resultSetGridView.grid.enableFisheye();
		}
		
	},
	
	removeListeners: function() {
		if (this._listeners) {
			ChangeNotifier.removeListeners(this._listeners);
		}
		
		this._listeners = null;
	},
	
	resize: function(args) {
		var headerMarginBox = dojo.marginBox(this._headerDiv),
			topOffset = headerMarginBox.t + headerMarginBox.h;

		// Rather than try to account for the shenanigans that occur in
		// DashboardPagePage.css to allow for either the presence or absence
		// of the paging widget, it's more straight-forward to update this
		// code here whenever those CSS rules change (note: the CSS file has
		// a comment in it about what .js files should be updated when the
		// rules are updated).  This was done in support of Task 85662.
		if (!this._filterSectionsAboveGapHeight) {
			if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
				this._filterSectionsAboveGapHeight = 63;
			}
			else if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
				this._filterSectionsAboveGapHeight = 32;
			}
			else if (this._headerDiv) {
				this._filterSectionsAboveGapHeight = dojo.marginBox(this._headerDiv).h;
			}
		}
		if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
			topOffset -= 3;		// TODO avoid this
			args.h += 15;		// TODO avoid this
		}
		else if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			topOffset += -6;	// TODO avoid this
			args.h += -6;		// TODO avoid this
		}
		else if (this.viewType === DashboardConstants.VIEW_TYPES.ARTIFACTS
				 || this.viewType === DashboardConstants.VIEW_TYPES.COLLECTIONS
				 || this.viewType === DashboardConstants.VIEW_TYPES.MODULES) {
			if (this.baselineURI) {
				if (dojo.isIE) {
					args.h += 78;		// TODO avoid this
				} else {
					args.h += 77;		// TODO avoid this
				}
			}
			else if (dojo.isIE) {
				args.h += -2;		// TODO avoid this
			}
		}

		if (this.skipped) {
			args = {
				h: args.h - topOffset + 6, // TODO avoid the 6
				w: args.w
			};
			return this._borderContainer.resize(args);
		} else {
			// this nonsense is only required for IE7, for some reason without it the
			// border container does not resize properly.
			this.skipped = true;
		}
	},
	
	ensureInCache: function(uris, callbackFn) {
		//Ensures the given URIs are in the data cache
		var missing = this._resultSetGridView.missingFromCache(uris);
		
		if (missing.length > 0) {
		
			var deferred = this.getAdditionalArtifactRows(missing);
		
			deferred.then(
				dojo.hitch(this, function(viewServiceResults){
					
					dojo.forEach(viewServiceResults.resources, function(resource) {
						this._resultSetGridView.addResourceToDataCache(resource);
					}, this);
					
					callbackFn();
				})
			);
		} else {
			callbackFn();
		}
	},

	// Note by SPC on 5/5/2015: This method should be refactored, but we're now in the RC phases
	// of 6.0 now so I don't want to do that (I've moved this 'if' block verbatim into this method
	// to address Defect 97080).  This method, however, should not be attempting to muck with the
	// internals of another class (as it is currently doing) ...
	prepareRestoreValues: function() {
		// summary:
		//		Get the top and bottom visible items, collapsed and expanded sections and 
		//		the current selected items for restoring after module refresh.

		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			this._resultSetGridView.grid.module.moduleStructure = this.moduleStructure;
			this._resultSetGridView.grid.prepareRestoreValues(true);
			this._resultSetGridView.grid.isRefresh = true;
		}
	},

	handleRefresh: function() {
		// summary:
		//		This function is called whenever the user clicks on the "global
		//		refresh" button, or an event happens that requires the whole
		//		dashboard to be refreshed.
		if (!this._refreshInProgress) {
			this._showAsBusy(true);
			//Clear the Type Cache
			TypeServiceUtil.clearCache();
			
			LinkTypeUtils.getLinkingPreferences().clearLinkTypePreferencesForProject(this.projectURI);
			this._resultSetGridView.typeCache.loadTypeSystem(this.projectURI, this.baselineURI, true, dojo.hitch(this, function () {

				this._resultSetGridView.handleRefresh();
			
				//Reset this project member's user data
				com.ibm.rdm.web.server.client.utils.UserCache.invalidateProjectMembersCache(this.projectURI);

				// Clear the artifact types cache.
				ArtifactTemplateUtil.setProjectArtifactListingInformationAsDirty(this.projectURI);
				
				if (this._tagsSection.getSelectedTags().length > 0
					|| this._attributesSection.isAtLeastOneAttributeApplied()
					|| (this._foldersSection
						&& this._foldersSection.getSelectedFolders().length > 0)
					|| this._savedFiltersSection.getSelectedSavedFilters().length > 0) {
					// First ask all filter sections to update themselves.  Only
					// AFTER they have all updated do we then ask to populate the
					// results area.  The reason we defer updating the results area
					// until after all filters have been updated is to account for
					// the fact that one of the selected items from these filters
					// MAY have been deleted on the server (e.g. a selected folder
					// may have been deleted, in which case the query we issue to
					// populate the results should NOT include an "and" clause for
					// this folder).
					var numOutstandingRefreshOperations = (this._foldersSection ? 4 : 3);
					var self = this;
					var onResponseHandled = function(response) {
						self._showAsBusy(false);
						return response;
					};
					var handleFilterSectionRefreshHasCompleted = function() {
						numOutstandingRefreshOperations--;
						if (numOutstandingRefreshOperations === 0) {
							if (!self._beingDestroyed) {
								if (self._savedFiltersSection.getSelectedSavedFilters().length > 0) {
									self._savedFiltersSection.reApplyFilters(onResponseHandled);
								}
								else {
									self._populateContents(onResponseHandled);
								}
							}
						}
					};
					this._tagsSection.refresh(handleFilterSectionRefreshHasCompleted);
					this._attributesSection.refresh(handleFilterSectionRefreshHasCompleted);
					if (this._foldersSection) {
						this._foldersSection.refreshWithNoInitialFocus(handleFilterSectionRefreshHasCompleted);
					}
					this._savedFiltersSection.refresh(handleFilterSectionRefreshHasCompleted);
				} else {
					// No tags or filters have been specified ... issue the result
					// set refresh as well as all filter section refresh requests
					// concurrently.
					var numOutstandingRefreshOperations = (this._foldersSection ? 4 : 3);
					var self = this;
					var onResponseHandled = function() {
						self._showAsBusy(false);
					};
					var handleFilterSectionOrResultSetRefreshHasCompleted = function(response) {
						numOutstandingRefreshOperations--;
						if (numOutstandingRefreshOperations === 0) {
							onResponseHandled();
						}
						return response;
					};

					if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
						this._resultSetGridView.grid.hardClear();
						if (this.moduleStructure.isLoaded) {
							this._resultSetGridView.resetPageToDisplay();
							this._populateContents(handleFilterSectionOrResultSetRefreshHasCompleted);
						} else {
							// wait for the structure to load before populating the results. It'll have been
							// load()'ed by the ModuleArtifactWidget.
							var tmpCon = dojo.connect(this.moduleStructure, "onLoad", this, function(){
								this._resultSetGridView.resetPageToDisplay();
								dojo.disconnect(tmpCon);
								StatusDisplay.hideStatusMessage();
								this._populateContents(handleFilterSectionOrResultSetRefreshHasCompleted);
							});
							this._connections.push(tmpCon);
						}
					}
					else {
						self._populateContents(handleFilterSectionOrResultSetRefreshHasCompleted);
					}
					
					
					this._tagsSection.refresh(handleFilterSectionOrResultSetRefreshHasCompleted);
					this._attributesSection.refresh(handleFilterSectionOrResultSetRefreshHasCompleted);
					if (this._foldersSection) {
						this._foldersSection.refresh(handleFilterSectionOrResultSetRefreshHasCompleted);
					}
					this._savedFiltersSection.refresh(handleFilterSectionOrResultSetRefreshHasCompleted);
				}
				this._populateCreateArtifactsMenu();
				this.enableOrDisableCreateButton();
			}));
		}
	},
	
	getAdditionalArtifactRows: function (uris) {
		// summmary: Gets row details for additional URIs, looking like the current grid settings
		//	uris: an array of URIs
		//	returns callback which calls back with view response data - has an array of resources and also link data if applicable
		return this._performViewRequestOnURIs(uris);
	},
	
	filtersChangedRefresh: function() {
		// summary:
		//		This function is called by the filter sections whenever selection
		//		change events occur, and resets the page number to 1.
		this._filterSectionsContainer.showSelectedViewFilterAsDirty();
		this._cancelOutstandingDeferreds();
		this._resultSetGridView.resetPageToDisplay();
		this.recordFilterChange();
		this.reloadModuleViewShape = true;
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			this._resultSetGridView.grid.module.moduleStructure = this.moduleStructure;
			this._resultSetGridView.grid.prepareRestoreValues(true);
			this._resultSetGridView.grid.isRefresh = true;
			// Clear the grid for the new content
			this._resultSetGridView.grid.hardClear();
		}
		this.refresh();
		this.reloadModuleViewShape = false;
	},
	
	reapplySelectedArtifacts: function() {
		// Re-select the selected artifacts if any to the filtered view
		if (this._resultSetGridView.grid.module.selectedArtifactsUri && 
			this._resultSetGridView.grid.module.selectedArtifactsUri.length > 0) {
			while (this._resultSetGridView.grid.module.selectedArtifactsUri.length > 0) {
				var uri = this._resultSetGridView.grid.module.selectedArtifactsUri.pop();
				this._resultSetGridView.grid.addToSelection([uri]);
			}
		}
		// Scroll the last top visible item that saved during operation.
		if (this._resultSetGridView.grid.lastTopVisibleItem) {
			this._resultSetGridView.grid.scrollIntoView(this._resultSetGridView.grid.lastTopVisibleItem);
			var row = this._resultSetGridView.grid.getRowByKey(this._resultSetGridView.grid.lastTopVisibleItem);
			if (row && row.node) {
				this._resultSetGridView.grid.module.scrollNodePosition(row.node, true);
			}
		}
	},
	
	changePage: function() {
		this.refresh(null, true);
	},
	
	refresh: function(notifier, pageChangeOnly, /*Callback?*/onComplete) {
		// summary:
		//		This function is called by the filter sections whenever selection
		//		change events occur, or when we need to move to and fro in the page list.
		//		It just requeries and refreshes the ResultSetGrid.
		
		//When in filter edit mode - do nothing - just return
		if (this.filterEditMode){
			return;
		}
		var self = this;
		var continueRefresh = function(){
			if (self._sectionsAndResultsSetViewAlreadyStarted
				&& !self._populationInProgress
				) {
				var onResponseHandled = function(response) {
					if (notifier && notifier.notifierParams && notifier.notifierParams.columnsChanged) {
						if (self._resultSetGridView.grid.virtualScrolling) {
							ChangeNotifier.notifyListeners({
								eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_COLUMN_CHANGE
							});
						}
					}
					self._showAsBusy(false);
					if (onComplete) {
						onComplete();
					}
					return response;
				};
				
				self._showAsBusy(true);
				
				if (self.viewType === DashboardConstants.VIEW_TYPES.MODULE && self.reloadModuleViewShape) {
					// wait for the structure to load before populating the results.
					var viewServiceRequestParams = self._getViewServiceRequestParams();
					
					self.moduleStructure.setViewShapeQueryParams(viewServiceRequestParams);
			
					self.moduleStructure.load({
						// tell anyone interested that we're also going
						// to load the grid contents, so the grid (which will
						// find out about the structure load) should not attempt
						// to reconcile it's content.
						gridContentLoad: true
					}).then(function() {
						self._showAsBusy(false);
						StatusDisplay.hideStatusMessage();
						self._populateContents(onResponseHandled);
						self.reloadModuleViewShape = false;
					});				
				
				} else {
					self._populateContents(onResponseHandled, pageChangeOnly);
				}
			}	
		};
		
		if (this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION && this.resourceViewer && this.resourceViewer.isDirty()) {
	
			var confirmForm;
			var onCancel = function(){
				confirmForm.hide();
			};
			var onClose = function(){
				if (!confirmForm.confirmed) {
					self._attributesSection.unselectAll(true);
					self._savedFiltersSection.unselectAll();
					self._tagsSection.setSelectedOperatorAndTags(com.ibm.rdm.web.query.ViewServiceClient.TAG_OPERATORS.IsAnyOf, null);
				}
			};
			var onOk = function(){
				confirmForm.hide();
				var saveDeferred = self.resourceViewer.onSave(false);
				saveDeferred.addCallback(self, function(saveResponse){
					StatusDisplay.hideStatusMessage();
					continueRefresh();
				});
			};
			
			confirmForm = new com.ibm.rdm.web.common.MessageForm({
				confirmContent: this._messages.collectionFilterSave,
				dialogTitle: this._messages.saveRequired,
				dialogStyle: com.ibm.rdm.web.common.MessageForm.DIALOG_TYPES.OkCancel,
				dialogWidth: "300px",
				onOk: onOk,
				onCancel: onCancel,
				onDialogClose: onClose
			});
			this._toDestroy.push(confirmForm);
			
			confirmForm.show();
		}
		else{
			continueRefresh.call();
		}
	},

	hasStarted: function() {
		return this._started;
	},
	
	destroyOrShowCreateFirstArtifactHelper: function () {
		// summary:
		//		This function will first check whether the user has modify lock permissions and
		//		then call its implementation function _destroyOrShowCreateFirstArtifactHelperImpl to
		//		determine whether to destroy or create the widget to help module users
		//		more intuitively create the first item.
		//		This function is hooked onto the module structure loading and changing (onLoad, onChange)
		
		// does user have create permissions ?
		this._isCreateAllowed().then(
				dojo.hitch(this, function(isCreateAllowed){
					this._destroyOrShowCreateFirstArtifactHelperImpl(isCreateAllowed);
				})
		);
	},
	
	_destroyOrShowCreateFirstArtifactHelperImpl: function (isCreateAllowed) {
		// summary:
		//		Either destroys or creates the widget to help module users
		//		more intuitively create the first item.
		
		var anyArtifactsInModule = (this.moduleStructure.artifacts.length > 0), // are there any items in the module ?
			filterOn = this.moduleStructure.hasViewFiltersApplied(); // could that be because a filter is applied ?  

		// destroy the widget if we have one and the module is either not empty or there is a filter applied - or in a baseline
		if (this._firstInModuleHelper && (anyArtifactsInModule || filterOn || !isCreateAllowed || this.baselineURI || this.resourceViewer.isInHistoryMode())) {
			this._firstInModuleHelper.destroyRecursive();
			delete this._firstInModuleHelper;
		} else if (!this._firstInModuleHelper && !anyArtifactsInModule && !filterOn && isCreateAllowed && !this.baselineURI && !this.resourceViewer.isInHistoryMode()) {
			// create it if there is not one and the module is empty and there is no filter and not in baseline
			var root = this.moduleStructure.compositeRootURI,
				args = {},
				where = com.ibm.rdm.web.model.resources.modules.ModuleStructure.BELOW,
				commands = this._resultSetGridView.commands;
			args[root.toString()] = "";
			var setFocusToGridWhenReconcileOccurs = dojo.hitch(this, function(){
				var reconciledListener = ChangeNotifier.addListener({
					eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_GRID_RECONCILED,
					callbackFunction: function(){
						commands.simulateTabIntoGrid();
						ChangeNotifier.removeListener(reconciledListener);
					},
					callbackScope: this
				});
			});
			this._firstInModuleHelper = new com.ibm.rdm.web.project.FirstArtifactInModuleHelper({
				projectURI: this.projectURI,
				moduleArtifactWidget: this.resourceViewer,
				onPaste: dojo.hitch(this, function(){
					setFocusToGridWhenReconcileOccurs();
					commands.executeModulePaste(args, where);
				}),
				onAddNew: dojo.hitch(this, function(){
					// Note: Adding a new artifact results in opening the newly
					// created artifact in edit mode so there's no need to use
					// 'setFocusToGridWhenReconcileOccurs'.
					commands.createFirstArtifactInModule();
				}), 
				onAddExisting: dojo.hitch(this, function(){
					commands.executeAddExisting(args, where).then(
						setFocusToGridWhenReconcileOccurs
					);
				}),
				pasteEnabled: commands._isUnderCopy() && commands._isPasteEnabledWithoutConsideringTeamOperations(args, 1),
				dropNode: this._resultSetGridView.grid.moduleContentPane,
				onDropArtifact: dojo.hitch(this, function(dropEvent){
					var currentConfigurationURI = VvcUtils.getCurrentConfigurationUri();
						
					if (dropEvent.projectURI !== this.projectURI || dropEvent.configurationURI !== currentConfigurationURI) {
						com.ibm.rdm.web.common.MessageHandler.showWarning(7684);
						return;
					}
					setFocusToGridWhenReconcileOccurs();
					// If we have a moduleURI we are obviously dropping cross module. 
					// Execute paste special and prompt user for more options.
					var command = (dropEvent.moduleUri ? "executeModulePasteSpecial" : "executeModulePaste");
					commands[command](args, where, {uris: dropEvent.dragURIs, moduleURI: dropEvent.moduleUri});
				}),
				onPasteSpecial: dojo.hitch(this, function(){
					setFocusToGridWhenReconcileOccurs();
					commands.executeModulePasteSpecial(args, where);
				})
			});
			dojo.place(this._firstInModuleHelper.domNode, this._resultSetGridView.grid.module.domNode, "first");
		}	
	},
	
	enableOrDisableCreateButton: function () {
		// summary:
		//		Enables or disables the big Create artifact button based on whether or not a
		//		filter or sort has been applied to the artifacts in the module to be consistent 
		//		with its corresponding popup menu options.  Also, if it's being viewed as part of
		//		a baseline or history, disable it.
		//		This function is hooked onto the module structure loading and changing (onLoad, onChange)			
		
		this._isCreateAllowed().then(
			dojo.hitch(this, function(isCreateAllowed){
				this.setCreateDisabled(!isCreateAllowed);
			})
		);
	},
	
	viewHasBeenRestored: function(args) {
		// summary:
		//		Notification that the view has been restored, allowing contained widgets
		//		to restore their view state.
		this._resultSetGridView.viewHasBeenRestored();
		if (args && args.filterId && this._savedFiltersSection){
			if (this.filterId != args.filterId){
				this.filterId = args.filterId;
				this._selectInitialSavedFilter();
			}
		} 
		else if (args && args.folderId && this._foldersSection){
			//Clear the other sections to restore folders
			this._savedFiltersSection && this._savedFiltersSection.clearSelection();
			this._attributesSection && this._attributesSection.unselectAll();
			this._tagsSection && this._tagsSection.clearSelection();

			if (this.folderId != args.folderId){
				this.folderId = args.folderId;
				this._foldersSection.selectFoldersById([args.folderId]).then(dojo.hitch(this, function(){
					this.filtersChangedRefresh();
				}));
			}
			else {
				var currentlySelectedFolder = this._foldersSection.getSelectedFolders();
				if (currentlySelectedFolder.length === 0 || (currentlySelectedFolder.length === 1 && currentlySelectedFolder[0].search(args.folderId) === -1)) {
					this._foldersSection.selectFoldersById([args.folderId]).then(dojo.hitch(this, function(){
						this.filtersChangedRefresh();
					}));
				}
			}
			this._foldersSection.expandFolderSection();
		}
		
		
		
		if (this._firstInModuleHelper) {
			var root = this.moduleStructure.compositeRootURI,
				args = {},
				enablePaste = false;
											
			args[root.toString()] = "";
			enablePaste = this._resultSetGridView.commands._isPasteEnabledWithoutConsideringTeamOperations(args, 1);
			this._firstInModuleHelper.setCanPaste(enablePaste);
		}
		// Make sure RecentlyViewedSection.foldersSection is correct for the current project
		RecentlyViewedSection.setFoldersSection(this._foldersSection);
	},
	
	getResultSetGridView: function() {
		return this._resultSetGridView;
	},
	
	setFilterEditMode: function(filterEditMode){
		this.filterEditMode = filterEditMode;
	},
	
	getFilterEditMode: function(){
		return this.filterEditMode;
	},
	
	_removeArtifactFormatConditionInfos: function(attributeConditionInfos) {
		// summary:
		//		If the current page represents either Modules or Collections, this method
		//		is called to make sure that the ConditionInfos that get resurrected
		//		DO NOT contain "Artifact Format" filters.  We do this due to the fact that
		//		these pages ALREADY add such a filter, but without showing it explicitly to
		//		the user (for example, for the Modules page, we don't show an "Artifact 
		//		Format is any of Module" filter, but we DO make sure that any view queries
		//		that go out contain such a filter).

		var i;
		for (i = 0; i < attributeConditionInfos.length; i++) {
			var conditionInfo = attributeConditionInfos[i];
			if (conditionInfo.attributeType === RRMTypes.ATTRIBUTE_TYPES.ArtifactFormatsType) {
				attributeConditionInfos.splice(i, 1);
				i--;
			}
		}
	},

	setSavedFilterValues: function(savedFilter, /*Callback?*/onComplete) {
		com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
			eventTopic: com.ibm.rdm.web.notifications.EventTopics.ABOUT_TO_CHANGE_VIEW,
			resourceUriScope: this.resourceURI,
			projectURI: this.projectURI
		});
		// Fix for defect 80825 - Loading module view shouln't change position.
		// Get the top and bottom visible items, collapsed and expanded sections and 
		// the current selected items for restoring after changing module view.
		// Note: We're bowing out of the following 'if' statement if (!this._refreshInProgress)
		// to avoid the following symptom: if the user selects a "Show 3 Levels" view and then
		// a "Show 1 Level" view, the end result would be that we still show with 3 levels
		// expanded (as the captured expanded rows would be re-instated as expanded).
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE && !this._refreshInProgress) {
			var avoidCapturingExpansionStates = !!savedFilter.hierarchyLevel;
			this._resultSetGridView.grid.module.moduleStructure = this.moduleStructure;
			this._resultSetGridView.grid.prepareRestoreValues(true, avoidCapturingExpansionStates);
			this._resultSetGridView.grid.isRefresh = true;
		}

		if (savedFilter.attributes
			&& !this._refreshInProgress
			&& (this.viewType === DashboardConstants.VIEW_TYPES.MODULES
				|| this.viewType === DashboardConstants.VIEW_TYPES.COLLECTIONS))
		{
			this._removeArtifactFormatConditionInfos(savedFilter.attributes);
		}
		
		//Reset the page number to 1
		this._resultSetGridView.resetPageToDisplay();
		this._resultSetGridView.showRestoringConfigurationMessage();
		
		var filterSectionsDeferredsCount = 0;
		var initialLoadSectionFiltersDeferredList = [];
		
		//set sorting and grouping and columns and expansion etc
		var savedFilterSetConfigurationDeferred = null;
		if (savedFilter.orderBy || savedFilter.groupBy || savedFilter.columns || savedFilter.displayedLinks || savedFilter.expansionRules){
			savedFilterSetConfigurationDeferred = new dojo.Deferred();
			var orderBy = null;

			dojo.forEach(savedFilter.orderBy, function(thisOrder){
				if (thisOrder.sortType){
					orderBy = thisOrder;
				}
			});
			
			this._resultSetGridView.setCurrentConfiguration({
				isSetFilter: true,
				columns: savedFilter.columns,
				displayedLinks: savedFilter.displayedLinks,
				sortBy: orderBy,
				groupBy: savedFilter.groupBy,
				expansionLevel: savedFilter.expansionLevel,
				expansionRules: savedFilter.expansionRules,
				hierarchyLevel: savedFilter.hierarchyLevel,
				onComplete: function(){
					savedFilterSetConfigurationDeferred.callback();
				}
			});
		}
		else{
			//Reset grid to 'default'
			this._resultSetGridView.setCurrentConfiguration(this._defaultConfiguration);
		}
		
		// process tags
		if (this._tagsSection) {
			var tagOperator = savedFilter.tagOperator;
			this._tagsSection.setSelectedOperatorAndTagsNoRefresh(tagOperator, null);
			if (savedFilter.tagURIs && savedFilter.tagURIs.length > 0) {
				if (!this._tagsSection.isLoaded()) {
					var deferred = this._tagsSection.startup();
					deferred.addCallback(this, function(response) {
						this._tagsSection.setSelectedOperatorAndTagsNoRefresh(
							tagOperator, savedFilter.tagURIs);
					});
					deferred.addErrback(this, function(error) {
						com.ibm.rdm.web.common.MessageHandler.showError(7236);
					});
					initialLoadSectionFiltersDeferredList.push(deferred);
					
				} else {
					this._tagsSection.setSelectedOperatorAndTagsNoRefresh(
						tagOperator, savedFilter.tagURIs);
				}
			}
		}

		this._filterSectionsContainer.setIgnoreFilterSectionHeightChangeRequests(true);

		// process attributes
		if (this._attributesSection) {
			this._attributesSection.unselectAll(true);
			// search by name
			if (savedFilter.search) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection._filterByNameSection.setAppliedConditionInfo(savedFilter.search)
				);
			}
			// users
			if (savedFilter.users) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection._filterByUserSection.setAppliedConditionInfo(savedFilter.users)
				);
			}
			// artifact format
			if (savedFilter.artifactFormat) {
				this._attributesSection._filterByArtifactFormatSection.setAppliedConditionInfo(savedFilter.artifactFormat);
			}
			// date range
			if (savedFilter.dateRange) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection._filterByDateSection.setAppliedConditionInfo(savedFilter.dateRange)
				);
			}
			// where used
			if (savedFilter.whereUsedConditionInfo
				&& this.viewType === DashboardConstants.VIEW_TYPES.ARTIFACTS
				) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection.setAppliedWhereUsedConditionInfo(
						savedFilter.whereUsedConditionInfo
					)
				);
			}
			// artifact types
			if (savedFilter.artifactTypeConditionInfo) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection._filterByArtifactTypeSection.setAppliedConditionInfo(savedFilter.artifactTypeConditionInfo)
				);
			}
			// attribute groups
			if (this._attributesSection && savedFilter.attributes && savedFilter.attributes.length > 0) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection._filterByAttributeValueSection.setAppliedAttributeValuesInfo(savedFilter.attributes));
			}
			// calm filters
			if (savedFilter.calm && savedFilter.calm.length > 0 && this._attributesSection._filterByLifecycleStatusSection) {
				this._attributesSection._filterByLifecycleStatusSection.setFilterValue(savedFilter.calm);
			}
			// links
			if (savedFilter.linkedArtifactConditionInfos && savedFilter.linkedArtifactConditionInfos.length > 0) {
				initialLoadSectionFiltersDeferredList.push(
					this._attributesSection._filterByLinkedArtifactSection.setAppliedAttributeValuesInfo(savedFilter.linkedArtifactConditionInfos));				
			}
		}
		
		// process folders
		if (this._foldersSection && savedFilter.folderURIs && savedFilter.folderURIs.length > 0) {
			this._foldersSection.unselectAll(true);
			initialLoadSectionFiltersDeferredList.push(this._foldersSection.selectFoldersByURI(savedFilter.folderURIs));
		}
		else if (this._foldersSection) {
			this._foldersSection.unselectAll();
		}
		
		//process base properties
		var isModule = (this.viewType === DashboardConstants.VIEW_TYPES.MODULE);
		if(isModule && savedFilter.displayBaseProperties) {
			this.showBaseProperties = (savedFilter.displayBaseProperties === "true");
			if (this.resourceViewer) {
				this.resourceViewer.setShowBaseProperties(savedFilter.displayBaseProperties);
			}
		}
		
		//add callbacks
		var checkIfAllFilterSectionsHaveLoaded = dojo.hitch(this, function(){
			filterSectionsDeferredsCount--;
			if (filterSectionsDeferredsCount <= 0) {
				if (this._tagsSection) {
					this._tagsSection._filterSelectionHasChanged();
					this._tagsSection.resetRefresh();
				}
				if (this._attributesSection) {
					this._attributesSection._filterSelectionHasChanged();
				}
				if (this._foldersSection) {
					this._foldersSection._filterSelectionHasChanged();
				}
				this._savedFiltersSection._filterSelectionHasChanged();
				this.reloadModuleViewShape = true;
				if (savedFilterSetConfigurationDeferred) {
					savedFilterSetConfigurationDeferred.then(
						dojo.hitch(this, function(){
							this.refresh(savedFilter, false, onComplete);
						})
					);
				} else {
					this.refresh(savedFilter, false, onComplete);
				}
				this._filterSectionsContainer.setIgnoreFilterSectionHeightChangeRequests(false);
				this._attributesSection.savedFiltersHaveLoaded();
				this._filterSectionsContainer.filterSectionsSelectionsHaveChanged();
			}
		});
		filterSectionsDeferredsCount = initialLoadSectionFiltersDeferredList.length;
		if (filterSectionsDeferredsCount === 0) {
			checkIfAllFilterSectionsHaveLoaded();
		}
		else {
			for (var i = 0; i<initialLoadSectionFiltersDeferredList.length; i++) {
				initialLoadSectionFiltersDeferredList[i].addBoth(
					this, checkIfAllFilterSectionsHaveLoaded);
			}
		}
	},
	
	//Returns the RDF for what is currently displayed in the grid
	getCurrentViewPostData: function(/*Optional*/args){
		if (args.gridColumns) {
			args.gridColumns = this._resultSetGridView.getCurrentConfiguration();
		}
		
		var currentParams = this._getViewServiceRequestParams(true, true);
		
		currentParams.clmFilters = null;
		if (args.calmFilters && this._attributesSection.isLifecycleStatusFilterApplied()) {
			currentParams.clmFilters = this._attributesSection.getAppliedCalmFilters();
		}
		
		//Add in the autoExpand params
		if (args.gridColumns.expansionRules) {
			currentParams.expansionRules = args.gridColumns.expansionRules;
		}

		return ViewServiceClient.composeViewsPostData(currentParams, args);
	},

	getCurrentViewAsJson: function() {
		// summary:
		//		Return an object that represents the same shape of object that
		//		the SavedFilterUtils.parseFilterFromJson() method would return.
		//		The returned object should account for all currently active
		//		filters.

		var savedViewJson = this._getViewServiceRequestParams(true, true),
			gridConfiguration = this._resultSetGridView.getCurrentConfiguration(true),
			property;

		savedViewJson.columns = gridConfiguration.columns;
		savedViewJson.displayedLinks = gridConfiguration.displayedLinks;
		savedViewJson.groupBy = gridConfiguration.groupBy;
		savedViewJson.expansionLevel = gridConfiguration.expansionLevel;
		savedViewJson.expansionRules = gridConfiguration.expansionRules;
		savedViewJson.hierarchyLevel = gridConfiguration.hierarchyLevel;

		var orderByAttributes = this._resultSetGridView.getOrderByAttributes();
		if (orderByAttributes.length > 0) {
			savedViewJson.orderBy = [];
			var i;
			for (i = 0; i < orderByAttributes.length; i++) {
				var orderBy = orderByAttributes[i];
				// If grid has order by some group setting, orderBy looks something like:
				// [{
				//     def: "http://www.ibm.com/xmlns/rdm/rdf/ofType",
				//     order: "d",
				//     type: "g"
				// }]
				// And if we look at a saved filter with order by we need:
				// groupBy: {
				//     groupType: "custom",
				//     groupURI: "http://www.ibm.com/xmlns/rdm/rdf/ofType"
				// }
				// orderBy: [{
				//     def: "http://www.ibm.com/xmlns/rdm/rdf/ofType",
				//     groupType: "custom",
				//     order: "d"
				// }]
				if (orderBy.type === "g") {
					var groupURI = orderBy.def;
					savedViewJson.groupBy = {
						groupType: "custom",
						groupURI: groupURI
					};
					savedViewJson.orderBy.push({
						def: groupURI,
						groupType: "custom",
						order: orderBy.order
					});
				}
				// If grid has order by a column sort, orderBy looks something like:
				// [{
				//     def: "https://scudmore:9444/rdm/types/_l63QIfV7EeO9yc-YdYHtuA",
				//     order: "a",
				//     type: "s"
				// }]
				// And if we look at a saved filter with a sort column we need:
				// orderBy: [{
				//     def: "https://scudmore:9444/rdm/types/_l63QIfV7EeO9yc-YdYHtuA",
				//     order: "a",
				//     sortType: "custom"
				// }]
				else if (orderBy.type === "s") {
					savedViewJson.orderBy.push({
						def: orderBy.def,
						order: orderBy.order,
						sortType: "custom"
					});
				}
			}
		}

		if (this._attributesSection.isLifecycleStatusFilterApplied()) {
			savedViewJson.calm = this._attributesSection.getAppliedCalmFilters();
		}

		var attributeConditionInfos = savedViewJson.attributeConditionInfos;
		if (attributeConditionInfos) {
			// Unfortunately we have to do a little "massaging of the data" here in order to have
			// the following work from the "Filter by Attribute" filter section: "Name",
			// "Modified on", "Modified by" and "More attributes".
			var properties = 
				ViewServiceClient.getSetAttributeConditionInfosProperties(
					attributeConditionInfos,
					this.projectURI,
					this.viewType === DashboardConstants.VIEW_TYPES.MODULE
				);
			savedViewJson.attributeConditionInfos = properties.attributeConditionInfos;
			if (properties.search) {
				savedViewJson.search = properties.search;
			}
			if (properties.users) {
				savedViewJson.users = properties.users;
			}
			if (properties.dateRange) {
				savedViewJson.dateRange = properties.dateRange;
			}
			if (properties.attributes) {
				savedViewJson.attributes = properties.attributes;
			}
		}

		return savedViewJson;
	},

	applySnapshot: function(newSnapshot) {
		this.resourceViewer._collectionSnapshotInfoNode.innerHTML = "";
		this.resourceViewer._collectionSnapshotInfoNode.style.display = "none";
		if (newSnapshot) {
			this.resourceViewer.associatedSnapshotURI = newSnapshot;
			var projectSnapshotsDeferred = ProjectCache.getProjectSnapshot(newSnapshot);
			projectSnapshotsDeferred.addCallback(this, function(projectSnapshot){
				if (projectSnapshot) {
					this.resourceViewer._collectionSnapshotInfoNode.style.display = "";
					var snapshotImageNode = document.createElement("IMG");
					snapshotImageNode.setAttribute("src", dojo.moduleUrl("com.ibm.rdm.web", "history/images/baseline_obj.gif").toString());
					snapshotImageNode.setAttribute("class", "img");
					this.resourceViewer._collectionSnapshotInfoNode.appendChild(snapshotImageNode);
					var resourceLinkNode = document.createElement("A");
					resourceLinkNode.appendChild(document.createTextNode(this._messages.snapshotInfoLabel + projectSnapshot.name));
					resourceLinkNode.setAttribute("href", "#action=com.ibm.rdm.web.pages.showProjectHistory&projectURI=" +
					encodeURIComponent(this.projectURI) +
					"&baselineURI=" +
					encodeURIComponent(projectSnapshot.resourceURI));
					this.resourceViewer._collectionSnapshotInfoNode.appendChild(resourceLinkNode);
				}
			});
		}
	},
	
	getSelectedFolder: function() {
		if (this._foldersSection) {
			var selectedFolders = this._foldersSection.getSelectedFolders();
			if (selectedFolders.length > 0) {
				return selectedFolders[0];
			}
		}
		return null;
	},
	
	setCreateDisabled: function(disabled){
		this._comboButtonWidget.setDisabled(disabled);
	},
	getCreateDisabled: function(){
		return this._comboButtonWidget.disabled;
	},
	
	getCurrentViewServiceRequestParams: function(/*Optional*/ getEvenIfNoFiltersApplied){
		return this._getViewServiceRequestParams(getEvenIfNoFiltersApplied);
	},
	
	///////////////////////////////////////////////////////////////////////////
	// Private API

	_cancelOutstandingDeferreds: function() {
		if (this._deferredArray) {
			for (var i = 0; i < this._deferredArray.length; i++) {
				var deferred = this._deferredArray[i];
				if (deferred.fired == -1) {
					deferred.cancel();
				}
			}
		}
		this._deferredArray = [];
	},

	_populateContents: function(onResponseHandled, pageChangeOnly) {
		//console.log("DTP _populateContents");
		if (this._populationInProgress) {
			return;
		}
		var self = this;
		this._populationInProgress = true;
		
		this._resultSetGridView.showLoadingArtifactsMessage();
		if (!this._savedFiltersSection.currentlySelectedKeys || 
				!(this._savedFiltersSection.currentlySelectedKeys.length > 0)){
			this._savedFiltersSection.unselectAll();
		}
		var queryInfo = null;
		
		
		//Decide when to show artifacts
		var showArtifacts = this._filtersHaveBeenChanged			//Either the filters have been changed
								|| this.viewType == DashboardConstants.VIEW_TYPES.MODULE      //Or we are displaying a module
								|| this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION  //Or we are displaying a collection
								|| this.viewType == DashboardConstants.VIEW_TYPES.COLLECTIONS  //Or we are displaying all collections
								|| this.viewType == DashboardConstants.VIEW_TYPES.MODULES;  //Or we are displaying all modules
		
		var viewServiceRequestParams = this._getViewServiceRequestParams(showArtifacts);	//If we are showing artifacts, get the parms even if no filter
		
		if (viewServiceRequestParams) {
			if (self.moduleStructure) {
				self.moduleStructure.setViewShapeQueryParams(viewServiceRequestParams);
			}
	
			this._showAsBusy(true);
			this._resultSetGridView.resetNewlyCreatedResources();
			viewServiceRequestParams.processLockInfo = true;
			if (viewServiceRequestParams.pageRequested && viewServiceRequestParams.pageRequested > 1) {
				viewServiceRequestParams.forceNoCount = true;
				//We need to preserve pages etc
				viewServiceRequestParams.currentPageDetails = {
					lastPage: this._resultSetGridView.getCurrentMaxPage(),
					currPage: viewServiceRequestParams.pageRequested,
					count: this.totalArtifactCount
				};
			}
			var viewRequestDeferred = this._getViewContents(viewServiceRequestParams, pageChangeOnly);
			this._deferredArray[0] = viewRequestDeferred;
			viewRequestDeferred.addCallback(this, this._handleViewContentsResponse);
			if (onResponseHandled) {
				viewRequestDeferred.addBoth(onResponseHandled);
			}
			viewRequestDeferred.addBoth(function() {
				self._showAsBusy(false);
				self._populationInProgress = false;
				
				// Send a notification that the module contents has been populated.  Fixes
				// Clicking on 'Include links, tags and comments from base artifacts' option twice displays the comments for base artifacts (74678)
				if (self.viewType == DashboardConstants.VIEW_TYPES.MODULE) {
					com.ibm.rdm.web.notifications.ChangeNotifier.notifyListeners({
						eventTopic: com.ibm.rdm.web.notifications.EventTopics.MODULE_CONTENTS_POPULATED,
						resourceUriScope: self.resourceURI,
						projectURI: self.projectURI
					});
				}
				
				/*if (self.moduleStructure) {
					self.moduleStructure.setViewShapeQueryParams(viewServiceRequestParams);
					// reload
					// TODO : only load if the view shape has changed
					if (self.reloadModuleViewShape) {
						self.moduleStructure.load();
						self.reloadModuleViewShape = false;
					}
				}*/
			});
			
			// Check to see if we need to fetch link validity rollup information from Foundation
			if (LinkValidityUtils.isLinkValidityEnabledForProject(this.projectURI)) {
				var columns = this._resultSetGridView.getCurrentConfiguration().columns;
				for (var i = 0; i < columns.length; i++) {
					if (columns[i].colURI === ArtifactConstants.LINK_VALIDITY_COL) {
						// Link validity is enabled, and the validity column is present. Load the rollup info
						//	after viewRequestDeferred is resolved.
						viewRequestDeferred.then(dojo.hitch(this, function() {
							var dataCache = this._resultSetGridView.dataCache,
							postData = [];
							var resources = dataCache.getArrayListOfResources();
							dojo.forEach(resources, function(resource) {
								postData.push({
									conceptUri: resource.resourceURI
								});
							});
							
							if (postData.length) {
								dataCache.linkValidityRollupDeferred = LinkValidityUtils.getValidityRollupData(postData, true).
									then(function(results) {
										// Create a map from the results.
										var rollupMap = {};
										dojo.forEach(results, function(result) {
											rollupMap[result.conceptUri] = result;
										});
										return rollupMap;
									});
							} else {
								// No resources to show. Resolve the deferred as an empty map.
								dataCache.linkValidityRollupDeferred = new dojo.Deferred();
								dataCache.linkValidityRollupDeferred.callback({});
							}
						}));
						break;
					}
				}
			}
		}
		else {
			this._resultSetGridView.showFilterNeededMessage();
			if (onResponseHandled) {
				onResponseHandled();
			}
			this._populationInProgress = false;
		}
		
		
	},
	
	recordFilterChange: function () {
		// summary:
		//		record the fact a filter has been cleared

		//91953: This behaviour has been removed
		//this._filtersHaveBeenChanged = true;
	},
	
	_expirePageCache: function() {
		this._pageCache = {};
	},
	
	_prefetchPage: function(pageNumber) {
		var nextDeferred = this._pageCache[pageNumber];
		//Only fire off the prefetch if the pageModel actually contains the page in question
		if (!nextDeferred && this._resultSetGridView.grid.pageModel.getPages()[pageNumber]) {
			var viewServiceRequestParams = this._getViewServiceRequestParams(false, false, pageNumber, true);
			if (viewServiceRequestParams) {
				nextDeferred = ViewServiceClient.getViewContents(viewServiceRequestParams);
				this._pageCache[viewServiceRequestParams.currentPage] = nextDeferred;
			}
		}
	},
	
	_getViewContents: function(viewServiceRequestParams, pageChangeOnly) {
		var deferred = pageChangeOnly && viewServiceRequestParams.currentPage && this._pageCache[viewServiceRequestParams.currentPage];
		if (!deferred) {
			if (!pageChangeOnly) {
				this._expirePageCache();
			}
			deferred = ViewServiceClient.getViewContents(viewServiceRequestParams);
			this._pageCache[viewServiceRequestParams.currentPage] = deferred;
		}
		if (this.viewType == DashboardConstants.VIEW_TYPES.MODULE) {
			// Prefetch the next and previous pages
			this._prefetchPage(viewServiceRequestParams.currentPage + 1);
			if (viewServiceRequestParams.currentPage > 1) {
				this._prefetchPage(viewServiceRequestParams.currentPage - 1);
			}
		}
		return deferred;
	},
	
	_selectInitialSavedFilter: function(){
		if (this.filterId){
			this._savedFiltersSection.clearSelection();
			this._savedFiltersSection.selectFilter(com.ibm.rdm.web.FRONTING_SERVICE_VIEWS + "/" + this.filterId);
			this.filterId = null;
		}
	},
	
	_toggleShowBaseProperties: function() {
	},
	
	clearSelectedSavedFilter: function(){
		this._savedFiltersSection.clearSelection();
	},
	
	getAppliedArtifactTypes: function() {
		//Return an array of the Artifact Types shown in the filter area.
		var artifacts = [];
		var typeConditions = this._attributesSection.getAppliedArtifactTypeConditionInfo();
		
		if (typeConditions && typeConditions.attributeValues && 
			typeConditions.attributeValues.length > 0 && typeConditions.attributeValues[0] == "is") {
			for (var i = 1; i<typeConditions.attributeValues.length; i++) {
				artifacts.push(typeConditions.attributeValues[i]);
			}
		}
		return artifacts;
	},

	_getViewServiceRequestParams: function(/*Optional*/ getEvenIfNoFiltersApplied, /*Optional*/isForSavedFilter, /*Optional*/pageToFetch, /*Optional*/isPrefetch) {
		// summary:
		//		Get the params to pass to the ViewServiceClient's
		//		performViewRequest function, or null if no filters
		//		have been specified.
		var viewServiceRequestParams = null;
		var selectedTagResources = (
			this._tagsSection ? 
			this._tagsSection.getSelectedTags():
			[]
		);
		var selectedFolderResources = (
			this._foldersSection ?
			this._foldersSection.getSelectedFolders() :
			[]
		);
		var artifactTypeConditionInfo = this._attributesSection.getAppliedArtifactTypeConditionInfo();
		var isAtLeastOneAttributeApplied = (
			this._attributesSection ?
			this._attributesSection.isAtLeastOneAttributeApplied():
			false
		);
		
		isForSavedFilter = isForSavedFilter || false;
			
		if (selectedTagResources.length > 0
			|| isAtLeastOneAttributeApplied
			|| artifactTypeConditionInfo
			|| selectedFolderResources.length > 0
			|| this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION
			|| this.viewType == DashboardConstants.VIEW_TYPES.MODULE
			|| this.viewType == DashboardConstants.VIEW_TYPES.COLLECTIONS
			|| this.viewType == DashboardConstants.VIEW_TYPES.MODULES
			|| getEvenIfNoFiltersApplied
			) {
			var attributeConditionInfos = this._getAttributeConditionInfosForViewRequest();
			var artifactFormatInstancesConditionInfo =
				this._attributesSection.getAppliedWhereUsedConditionInfo();
			var linkedArtifactConditionInfos =
				this._getLinkArtifactConditionInfosForViewRequest();
			
			var collectionArtifacts = null;
			if ((this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION) &&
					this.resourceViewer &&
					(this.resourceViewer.viewType == com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewType.ShowArtifactHistory)
					&& !this.baselineURI){
						var collectionObject = this.resourceViewer.getResourceObject();
						if (collectionObject && collectionObject.getArtifactURIs){
							collectionArtifacts = collectionObject.getArtifactURIs();
						}
						else{
							collectionArtifacts = [];
						}
			}
			//Special case to handle empty collection, forcing view service to return 0 results where it would normally show all in project
			if (collectionArtifacts && collectionArtifacts.length == 0){
				collectionArtifacts.push(this.projectURI);
			}
			
			var collectionURI = (
				(this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION && !collectionArtifacts) ?
				this.resourceURI :
				null
			);
			
			var moduleURI = (
				(this.viewType == DashboardConstants.VIEW_TYPES.MODULE) ?
				this.resourceURI :
				null
			);
			
			
			var viewServiceRequestBaseline = this.baselineURI;
			var tagOperator = this._tagsSection.getSelectedOperator();
			
			//Get the columns required
			var columns = this._resultSetGridView.getCurrentConfiguration().columns;
			var pageSize = this._resultSetGridView.getPageSize();
			var pageToDisplay = pageToFetch || this._resultSetGridView.getPageToDisplay();
			var pageOffset = this._resultSetGridView.getPageOffset();
			var useInQuery = false,
				urisOnPage = null;
			// if we are displaying a module, get the URI's for the page we are
			// after, and use those to drive the query.
			if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE && !isForSavedFilter) {
				urisOnPage = this._resultSetGridView.getPageURIList(pageToFetch, isPrefetch);
				useInQuery = true;
			}
			else if (collectionArtifacts) {
				urisOnPage = collectionArtifacts;
			}
			
			var clmFilters = null;
			if (this._attributesSection.isLifecycleStatusFilterApplied()) {
				clmFilters = this._attributesSection.getAppliedCalmFilters();
			}
			
			this._disableModuleReuseMode = false;
			var orderByAttributes = this._resultSetGridView.getOrderByAttributes();
	
			var requestedAttributeUris = this._determineDesiredCols(columns, orderByAttributes);
			// We need the modifiedOn for module find/replace to test whether or not the resource is up-to-date
			// when performing a replace operation.
			if (moduleURI) {
				if (dojo.indexOf(requestedAttributeUris, RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ModifiedOn)) {
					requestedAttributeUris.push(RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ModifiedOn);
				}
			}
			
			var suspicionProfileURIs = this._getSuspicionProfileURIsForViewRequest();
						
			var globalConfigurationUri = VvcUtils.getGlobalConfigurationUri();
			
			viewServiceRequestParams = {
				currentPage: pageToDisplay,
				projectURI: this.projectURI,
				globalConfigurationUri: globalConfigurationUri,
				baselineURI: viewServiceRequestBaseline,
				collectionURI: collectionURI,
				moduleURI: moduleURI,
				folderURIs: selectedFolderResources,
				tagOperator: tagOperator,
				tagURIs: selectedTagResources,
				suspicionProfileURIs: suspicionProfileURIs,
				artifactTypeConditionInfo: artifactTypeConditionInfo,
				whereUsedConditionInfo: artifactFormatInstancesConditionInfo,
				attributeConditionInfos: attributeConditionInfos,
				linkedArtifactConditionInfos: linkedArtifactConditionInfos,
				//Identify the query order and the page number.
				orderBy: orderByAttributes,
				pageRequested: useInQuery ? null : pageToDisplay,
				pageSize: useInQuery ? null : pageSize,
				artifactUris: urisOnPage,
				requestedAttributeUris: requestedAttributeUris,
				capQueryExecutionTime: (this.viewType == DashboardConstants.VIEW_TYPES.MODULE) ? false:true,
				disableModuleReuseMode:this._disableModuleReuseMode,
				disableModulefactBasePropertiesUnion:(this.showBaseProperties)?false:true,
				displayBaseProperties: this.showBaseProperties,
				isCoreView: (this.viewType !== DashboardConstants.VIEW_TYPES.MODULE),
				clmFilters: clmFilters,
				offset: pageOffset
			};
			
			var isAllArtifactsView = false;
			//When we have no filters applied in the Artifacts view, we don't want to count
			//var isAllArtifactsView = this.viewType === DashboardConstants.VIEW_TYPES.ARTIFACTS &&
			//	!isForSavedFilter &&
			//	selectedTagResources.length === 0 &&
			//	selectedFolderResources.length === 0 &&
			//	!isAtLeastOneAttributeApplied;
			
			if (moduleURI || isAllArtifactsView) {
				/* WI 50002, remove the count=true argument for modules, it slows the query down and we don't need it */
				/* WI 85479 All artifacts does not count the artifacts */
				viewServiceRequestParams.forceNoCount = true;
			}
			if (dojo.indexOf(requestedAttributeUris, RRMTypes.getPrimaryTextURI(this.projectURI)) !== -1){
				// If primary text is currently displayed we need to fetch large.
				viewServiceRequestParams.fetchLarge = true;
			}

		}
		return viewServiceRequestParams;
	},
	
	determineDesiredCols: function(columns){
		if (!columns){
			columns = this._resultSetGridView.getCurrentConfiguration().columns;
		}
		
		var orderByAttributes = this._resultSetGridView.getOrderByAttributes();
		return this._determineDesiredCols(columns, orderByAttributes);
	},
	

						
	getDisplayedColumnIDs: function() {
		var columns = this._resultSetGridView.getCurrentConfiguration().columns;

		var requestedAttributeUris = [];

		for ( var i = 0; i < columns.length; i++) {
			var col = columns[i];
			if (col.colType == "s") {

				switch (col.colURI) {
				case "id-col":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Identifier)));
				break;
				case "name":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Title)));
				break;
				case "format":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ArtifactFormat)));
				break;
				case "mod-date":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ModifiedOn)));
				break;
				case "mod-user":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Contributor)));
				break;
				case "creator":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Creator)));
				break;
				case "create_date_col":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Created)));
				break;
				case "description":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Description)));
				break;
				case "alternateSpelling":
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.AlternateSpelling)));
				break;
				case ArtifactConstants.MODULE_CONTENT_COL:
					var primaryTextURI = RRMTypes.getPrimaryTextURI(this.projectURI);
					requestedAttributeUris.push(queryutils.getLastPathSegment(primaryTextURI));
					requestedAttributeUris.push(queryutils.getLastPathSegment(RRMTypes
						.getWellKnownAttributeURI(this.projectURI,
							RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.Title)));
				break;
				}
			}
			else if (col.colType == "a") {
				requestedAttributeUris.push(queryutils.getLastPathSegment(col.colURI));
			}
		}

		return requestedAttributeUris;
	},
	
	getOrderByAttributes: function(){
		this._resultSetGridView.getOrderByAttributes();
	},
	
	_determineDesiredCols: function(columns, orderByAttributes) {
		// summary:
		//		Sets the columns that are required.
		
		var requestedAttributeUris = [];
		
		//Add mandatory attributes
		requestedAttributeUris.push(RRMTypes.WELL_KNOWN_OBJECT_TYPE, RRMTypes.RDF_PROCESS_AREA,
				RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ArtifactFormat,
				RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.WrappedResourceURI,
				RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.WrappedResourceMimeType,
				RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Identifier,
				RRMTypes.WELL_KNOWN_HAS_GENERATED_TITLE);

		//add MANDATORY module attributes
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			requestedAttributeUris.push(RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.BoundArtifact);
		}
		
		//If we are in a module and a baseline, get the revision for wrapped artifacts
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE && this.baselineURI) {
			requestedAttributeUris.push(RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.WrappedResourceRevisionURI);
		}
		
		for (var i = 0; i < columns.length; i++) {
			var col = columns[i];
			if (col.colType == "s") {
				switch (col.colURI) {
					case "lockedBy":
						requestedAttributeUris.push([RRMTypes.RDF_LOCK, RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Creator]);
						break;
					case "lockedOn":
						requestedAttributeUris.push([RRMTypes.RDF_LOCK, RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Created]);
						break;
					case "tags":
						var tagUri = "http://com.ibm.rdm/navigation#tag";
						requestedAttributeUris.push(tagUri);
						requestedAttributeUris.push([tagUri, "http://purl.org/dc/terms/title"]);
						requestedAttributeUris.push([tagUri, "http://com.ibm.rdm/navigation#scope"]);
						if((this.viewType === DashboardConstants.VIEW_TYPES.MODULE) && (!this._disableModuleReuseMode)){
							//The subject attribute can only be passed if the reuse query parameter is true (i.e = &reuse=true)
							if(this.showBaseProperties){								
								requestedAttributeUris.push([tagUri, "http://www.w3.org/1999/02/22-rdf-syntax-ns#subject"]);
							}
						}										
						break;
					case ArtifactConstants.MODULE_CONTENT_COL:
						var primaryTextURI = RRMTypes.getPrimaryTextURI(this.projectURI);
						if (dojo.indexOf(requestedAttributeUris, primaryTextURI) === -1){
							requestedAttributeUris.push(primaryTextURI);
						}
						if (dojo.indexOf(requestedAttributeUris, RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Title) === -1){
							requestedAttributeUris.push(RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.Title);
						}
						break;
					case ArtifactConstants.COMMENTS_COL:
						requestedAttributeUris.push(RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.UnresolvedCommentCount,
								RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.ResolvedCommentCount,
								RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.RecentCommentCount);
						break;
					case ArtifactConstants.SUSPICION_COL:
						var profileURIs = this._getSuspicionProfileURIsForViewRequest();
						if (profileURIs.length > 0) {
							requestedAttributeUris.push(com.ibm.rdm.web.suspicion.model.types.SUSPECT_ENTRIES);
						}
						break;
					case ArtifactConstants.LINK_VALIDITY_COL:
						requestedAttributeUris.push(RRMTypes.LINK_VALIDITY);
						break;
					case ArtifactConstants.TITLE_COL:
						if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
							// asking for primary text is costly, so we only add this when we need to (currently, just for modules)
							var primaryTextURI = RRMTypes.getPrimaryTextURI(this.projectURI);
							if (dojo.indexOf(requestedAttributeUris, primaryTextURI) === -1) {
								requestedAttributeUris.push(primaryTextURI);
							}
						}
						// IMPORTANT: this case purposely falls through to default and therefore must be immediately before default
					default:
						var coluri = com.ibm.rdm.web.model.types.GridColumnTypes.COLUMN_TO_URI[col.colURI];
						if (coluri && dojo.indexOf(requestedAttributeUris, coluri) === -1){
							requestedAttributeUris.push(coluri);
						}
						break;
				}
			} else if (col.colType == "a") {
				requestedAttributeUris.push(col.colURI);
			}
		}
		
		//Add in the orderByAttributes (includes grouped by ones) to ensure they are returned as well
		if (orderByAttributes) {
			for (var i = 0; i < orderByAttributes.length; i++) {
				var orderByUri = orderByAttributes[i].def;
				var wellKnownObj = RRMTypes.getWellKnownAttributeObjectFromURI(orderByUri, this.projectURI);
				if (wellKnownObj){
					orderByUri = wellKnownObj.sameAs;
				}
				if (dojo.indexOf(requestedAttributeUris, orderByUri) < 0) {
					requestedAttributeUris.push(orderByUri);
				}
			}
		}
		
		return requestedAttributeUris;
	},
	
	_getSuspicionProfileURIsForViewRequest: function() {
		return SuspectLinksUtil.getSuspicionProfileURIsPreference(this.projectURI);
	},

	_getAttributeConditionInfosForViewRequest: function() {
		// summary:
		//		Return an array that will represent the "attributes" property
		//		that will be passed in a call to the ViewServiceClient's
		//		performViewRequest function.
		var attributeConditionInfos = [];
		// Add an attribute for the "Name" filter, if needed.
		var nameAttributeConditionInfo =
			this._attributesSection.getAppliedArtifactNameAttributeConditionInfo();
		if (nameAttributeConditionInfo) {
			attributeConditionInfos.push(nameAttributeConditionInfo);
		}
		// Add an attribute for the "Last modified on" filter, if needed.
		var lastModifiedOnAttributeConditionInfo =
			this._attributesSection.getAppliedLastModifiedOnAttributeConditionInfo();
		if (lastModifiedOnAttributeConditionInfo) {
			attributeConditionInfos.push(lastModifiedOnAttributeConditionInfo);
		}
		// Add an attribute for the "Last modified by" filter, if needed.
		var usersAttributeConditionInfo =
			this._attributesSection.getAppliedUsersAttributeConditionInfo();
		if (usersAttributeConditionInfo) {
			attributeConditionInfos.push(usersAttributeConditionInfo);
		}

		// Add an attribute for the "Artifact format" filter, if needed.
		var artifactFormatURIs = this._attributesSection.getAppliedArtifactFormats();
		if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTIONS){
			if (!artifactFormatURIs) {
				artifactFormatURIs = [];
			}
			artifactFormatURIs.push("is");
			artifactFormatURIs.push(RRMTypes.getArtifactFormats(this.projectURI)["Collection"]);
		} else if (this.viewType === DashboardConstants.VIEW_TYPES.MODULES){
			if (!artifactFormatURIs) {
				artifactFormatURIs = [];
			}
			artifactFormatURIs.push("is");
			var uris = RRMTypes.getArtifactFormats(this.projectURI)["Module"];
			artifactFormatURIs.push(uris);
		}
		
		if (artifactFormatURIs && artifactFormatURIs.length > 0) {
			var attributeURI =
				RRMTypes.getWellKnownAttributeURI(this.projectURI, RRMTypes.WELL_KNOWN_ATTRIBUTE_NAMES.ArtifactFormat);
			attributeConditionInfos.push({
				attributeDefinitionURI: attributeURI,
				attributeType: RRMTypes.ATTRIBUTE_TYPES.ArtifactFormatsType,
				attributeValues: artifactFormatURIs,
				isEnum: true
			});
		}
		// Add attributes for the "More attributes" filters, if needed.
		var otherAttributeConditionInfos = this._attributesSection.getAppliedAttributeConditionInfos();
		if (otherAttributeConditionInfos) {
			attributeConditionInfos = attributeConditionInfos.concat(otherAttributeConditionInfos);
		}
		return attributeConditionInfos;
	},

	_getLinkArtifactConditionInfosForViewRequest: function() {
		return this._attributesSection.getAppliedLinkedArtifactConditionInfos();
	},

	_showAsBusy: function(isBusy) {
		// summary:
		//		Push or pop the cursor's busy state.  When pushed (i.e. 'isBusy'
		//		is true) for the first time we show the busy cursor.  When popped
		//		(i.e. 'isBusy' is false) for the last time we reset the cursor to
		//		its original appearance.

		if (isBusy) {
	
			if (this._busyCursorTally === 0) {
				this._toggleRefreshInProgress();
			}
			this._busyCursorTally++;
		} else {
			this._busyCursorTally--;
			if (this._busyCursorTally === 0) {
				this._toggleRefreshInProgress();
			}
		}
		
		this._busyCursorTally = Math.max(this._busyCursorTally, 0);
		
	},

	_toggleRefreshInProgress: function() {
		if (this._refreshInProgress) {
			this._refreshInProgress = false;
			if (this.domNode) {
				this.domNode.style.cursor = "";
			}
			if (this._foldersSection) {
				this._foldersSection.showAsBusy(false);
			}
		} else {
			this._refreshInProgress = true;
			if (this.domNode) {
				this.domNode.style.cursor = "progress";
			}
			if (this._foldersSection) {
				this._foldersSection.showAsBusy(true);
			}
		}
	},

	_populateArtifact: function (artifact, snapshotURI) {
		if (snapshotURI) {
			artifact.inSnapshot = true;
			artifact.isCollectionArtifactAssociatedWithSnapshot = true;
			artifact.projectSnapshotURI = snapshotURI;
		}
		if (artifact && !artifact.getResourceURI) {
			artifact.getResourceURI = function(){
				return artifact.resourceURI;
			};
			artifact.getRevisionDate = function(){
				return artifact.lastModifiedDate;
			};
			artifact.getID = function(){
				return artifact.identifier;
			};
			artifact.getEntityType = function(){
				return artifact.type;
			};
			artifact.getDisplayTitle = function(){
				return artifact.name;
			};
			artifact.getLastModifiedBy = function(){
				return artifact.lastModifiedBy;
			};
			artifact.getAttributes = function(){
				return null;
			};
			artifact.getTypes = function(){
				return null;
			};
			artifact.getMimeType = function(){
				return artifact.type;
			};
			artifact.getSnapshotURI = function(){
				return artifact.projectSnapshotURI;
			};
			artifact.getRevision = function(){
				return artifact.etag;
			};
		}
		if (!artifact) {
			console.error("Artifact is null - and that is invalid!");
			console.trace();
		}
	
	},
	
	_handleMultiFetchSuccessResponse: function(response, currPage, lastPage, nextPage, nextPageOffset, count) {
		// summary:
		//		Handles the details coming from the ViewService, the contents of a collection, or a Project.multifetch.
		// currPage:
		//		The current page of results.
		// lastPage:
		//		The last page of results.
		// nextPage:
		//		The next page of results.
		// nextPageOffset:
		//		The offset the view service needs to use to get the next page.
		
		this._currPage = currPage;
		this._lastPage = lastPage;
		
		//WI27624 - will need to clean up here
		var snapshotURI = null;
		if (this.baselineURI) {
			snapshotURI = this.baselineURI;
		}
		else if ((this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION) && this.resourceViewer && 
				this.resourceViewer.associatedSnapshotURI) {
			snapshotURI = this.resourceViewer.associatedSnapshotURI;
		}

		dojo.forEach(response, dojo.hitch(this, function (artifact) {
			this._populateArtifact(artifact, snapshotURI);
		}));		

		this._setResults(response, this._currPage, this._lastPage, nextPage, nextPageOffset, count);
		return response;
	},

	_handleViewContentsResponse: function(response) {

		var snapshotURI = null;
		//Figure out if we need to filter by a baseline
		if (this.baselineURI) {
			snapshotURI = this.baselineURI;
		}
		else if ((this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION) && this.resourceViewer && 
				this.resourceViewer.associatedSnapshotURI) {
			snapshotURI = this.resourceViewer.associatedSnapshotURI;
		}

		var result = ViewServiceClient.parseViewContentsResponse(response, this.projectURI, {}, false);
		var resources = result.resources;

		var currPage, lastPage, nextPage, nextPageOffset;
		
		if (response.correlationData && response.correlationData.currentPageDetails) {
			var details = response.correlationData.currentPageDetails;
			currPage = details.currPage;
			lastPage = details.lastPage;
			this.totalArtifactCount = details.count || 0;
		} else {
			currPage = result.currPage;
			lastPage = result.lastPage;
			this.totalArtifactCount = result.count || 0;
		}
		nextPage = result.nextPage;
		nextPageOffset = result.nextPageOffset;
		
		//Execute a the Query if a collection needs different resource
		var self = this;
		
		//The resources is missing results that we expected because collection has an associated Snapshot
		//or because a revision other than head is selected. In this case we must manually fetch the resources.
		//This is a hack for 29580 for RMWeb3 Beta1.
		//In the future the view service *must* support this complexity around collections
		if (this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION &&
			this.resourceViewer && 
			this.resourceViewer.getResourceObject().getSnapshot &&
			this.resourceViewer.getResourceObject().getSnapshot())
		{
			var params = this.resourceViewer.getResourceObject().getArtifactURIs();
			var toFetch = [];
			var liveFetch = [];
			var resourceMap = {};
			
			resources = [];
			for (var param in params){
				toFetch.push({
					resourceURI: params[param],
					projectSnapshotURI: snapshotURI
				});
			}
			var allArtifactsFinished = function(){
				self._handleMultiFetchSuccessResponse(resources, currPage, currPage, nextPage, nextPageOffset, this.totalArtifactCount);
			};
			//Perform fetch to manually grab the collection's artifacts
			ResourceManager.getMultiple(toFetch, function(artifactResponse) {
				
				for (var artifact in artifactResponse) {
						resources.push(artifactResponse[artifact]);
						resourceMap[artifactResponse[artifact].resourceURI] = artifactResponse[artifact];
				}
				
				//Go through the original params, figure out which ones were not returned as being in a snapshot
				//if any
				for (var param in params) {
					if (!resourceMap[params[param]]) {
						liveFetch.push({
							resourceURI: params[param]
						});
					}
				}
				//What was returned with the provided snapshot is less than what the collection has
				//This indicates that some artifacts did not exist at the time of the snapshot
				if (liveFetch.length > 0) {
					ResourceManager.getMultiple(liveFetch, function(liveResponse){
						
						//Add the ones we got from the live request to the mix
						for (var artifact in liveResponse) {
							liveResponse[artifact].setTitle(liveResponse[artifact].getTitle() + self._messages.notInSnapshot);
							liveResponse[artifact].isNotInSnapshot = true;
							resources.push(liveResponse[artifact]);
						}
						
						//Check to see if any artifacts were not retrieved from the live fetch - meaning they were at some
						//point deleted. We should then find its most recent revision and grab that for display in the
						//Collection
						if (liveResponse.length < liveFetch.length){
							var deletedFetch = [];
							var deletedURIs = [];
							
							//Make a map of the liveFetch to make simpler.
							var liveMap = {};
							for (var artifact in liveResponse) {
								liveMap[liveResponse[artifact].resourceURI] = liveResponse[artifact];
							}
							
							for (var liveEntry in liveFetch) {
								if (!liveMap[liveFetch[liveEntry].resourceURI]) {
									deletedURIs.push(liveFetch[liveEntry].resourceURI);
								}
							}
							
							for (var deletedURI in deletedURIs){
								RevisionsCache.getRevisions(
										deletedURIs[deletedURI]).addCallback(this, function(revisionsResponse){
									
									deletedFetch.push({
										resourceURI: deletedURIs[deletedURI],
										revision: revisionsResponse.doc.getRevisionInfos()[0].revisionId
									});
									
									//When we have grabbed all the revision data we need from all of the
									//Aritfacts that were missing from the live fetch, we will do a third multiple
									//artifact get using ResourceManager.
									if (deletedFetch.length == deletedURIs.length){
										ResourceManager.getMultiple(deletedFetch, function(deletedResponse){
											for (var artifact in deletedResponse) {
												deletedResponse[artifact].setTitle(deletedResponse[artifact].getTitle() + 
													self._messages.notInSnapshot);
												deletedResponse[artifact].isNotInSnapshot = true;
												resources.push(deletedResponse[artifact]);
											}
											allArtifactsFinished.call();
										});
									}
									
								});
							}
						}
						else{
							allArtifactsFinished.call();
						}
					});
				}
				else {
					allArtifactsFinished.call();
				}
			});
			
		} else {
			self._handleMultiFetchSuccessResponse(resources, currPage, lastPage, nextPage, nextPageOffset, this.totalArtifactCount);	
		}
	},

	_setResults: function(results, currPage, lastPage, nextPage, nextPageOffset, count) {
		domutils.createDefaultCursor();
		this._resultSetGridView.setCLMFilters(this._attributesSection.isLifecycleStatusFilterApplied() ? this._attributesSection.getAppliedCalmFilters() : null);
		
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			
			// we need to sort the results into the order specified by the module structure.
			var moduleStructure = this.moduleStructure;
			
			results.sort(function (a, b) {
				var entryA = moduleStructure.getArtifactByURI(a.resourceURI),
					entryB = moduleStructure.getArtifactByURI(b.resourceURI);
					
				return moduleStructure.indexOf(entryA) - moduleStructure.indexOf(entryB);
			});
			
		}
		else if (results.length > 0 && this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION && this.resourceViewer) {
			// Remove any collection resources that may have made their want into the collection
			var filteredResults = this.resourceViewer.cleanCollectionContents(results);
			var numDiff = results.length - filteredResults.length;
			if (numDiff > 0) {
				results = filteredResults;
				count -= numDiff;
				count = count.toString();
			}
		}
		
		this._resultSetGridView.setPagedResults(results, currPage, lastPage, nextPage, nextPageOffset, count);
		this._resultSetGridView.showArtifacts();
		if (this.loadCompleteCallback){
			this.loadCompleteCallback.call(this.loadCompleteScope);
		}
	},
	
	createArtifact: function(createArgs, event){
		var continueWithSave = dojo.hitch(this, function(args) {
			var doNotOneClick = false;
			if (!event){
				doNotOneClick = true;
			}
			return this._createArtifact(args, doNotOneClick);
		});
		return continueWithSave(createArgs);
	},
	
	_createArtifact: function(args, /*Boolean?*/doNotCreateUsingOneClickCreate) {
		// summary:
		//		Create an artifact via either one-click create or via the Create
		//		Artifact dialog.
		// args:
		//		An object containing the following properties:
		//		- typeURI
		//		- artifactFormat
		//		- isMoreOption
		//		- relativeSiblingURI
		//		- where
		//		- onDialogClose
		// doNotCreateUsingOneClickCreate:
		//		Optional, but if passed as true it's an indicator that we know
		//		we need to bypass the currently enabled one-click create as we
		//		know that the user cannot create an artifact of the specified
		//		type in the specified folder (and therefore we need to invoke
		//		the Create Artifact dialog).
		var selectedFolder = null,
			moduleContextURI = null,
			isModule = this.viewType === DashboardConstants.VIEW_TYPES.MODULE,
			isCollection = this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION,
			isCollectionOrModule = isModule || isCollection,
			isAnyUnderEdit = com.ibm.rdm.web.project.EditManager.isAnyUnderEdit(this.projectURI),
			lastSelectedObjectType = ResourceUtil.getLastSelectedObjectType(this.projectURI);

		if (!args){
			args = {};
		}
		
		if (isAnyUnderEdit){
			com.ibm.rdm.web.project.EditManager.saveAll(
				this.projectURI,
				// Note: We want to pass 'true' as the value for this second 'noFocus'
				// param if know we're about to set focus to a field in a create
				// artifact dialog that we're about to open (below in this same function).
				// Passing this param as 'true' informs this called function that it
				// should NOT attempt to set focus in the grid.
				doNotCreateUsingOneClickCreate
			);
			this._resultSetGridView.clearSelection();
			args.wasEditing = isAnyUnderEdit;
		}	
		
		this.isAddToCollectionButtonActive = false;
		this.isAddToModuleButtonActive = false;
		
		var typeURI = (args && args.typeURI) ? args.typeURI : lastSelectedObjectType.typeURI;
		var artifactFormat = args && args.artifactFormat ? args.artifactFormat : null;
		
		if (this._foldersSection){
			selectedFolder = this._foldersSection.getSelectedFolders()[0];
		} else if (isCollection){
			selectedFolder = this.resourceViewer.parentResourceURI;
			if (!this.resourceViewer.isEdit()){
				this.resourceViewer.onEdit();
			}
		} else if (isModule){
			var assetFolderLoc = this.resourceViewer.getResourceObject().getAssetFolderURI();
			selectedFolder = (assetFolderLoc)?assetFolderLoc:null;
			moduleContextURI = args.moduleContextURI ? args.moduleContextURI : this.resourceViewer.getResourceObject().getCompositeRootURI();
			this.setCreateDisabled(true);
			var projArtifactFormats = RRMTypes.getArtifactFormats(this.projectURI);
			args.artifactFormat = projArtifactFormats.Text;
			
			if(lastSelectedObjectType.formatURI && lastSelectedObjectType.formatURI === projArtifactFormats.Module) {
				// We are in a module and the last selected type has a default format of module... bad combination.
				// Null out the typeURI which will allow the creation to proceed.
				typeURI = null;
			}
		}
			
		ResourceUtil.setLastSelectedObjectType(this.projectURI, typeURI, artifactFormat);
		this.updateCreateButtonLabel(typeURI);
		
		if (doNotCreateUsingOneClickCreate || !this.isOneClickCreateEnabled()
				|| args.isMoreOption || !typeURI) {
			var creationDeferred = new dojo.Deferred();
			var newArtifactDialog = new com.ibm.rdm.web.project.NewArtifactForm({
				artifactFormat: artifactFormat,
				typeURI: typeURI,
				resourceURI: this.resourceURI,
				where: args.where,
				relativeSiblingURI: args.relativeSiblingURI,
				projectURI: this.projectURI,
				folderURI: selectedFolder,
				projectDashboardTab: this,
				hideOpen: isCollectionOrModule,
				restrictFormats: isCollectionOrModule,
				isMoreOption: args.isMoreOption,
				moduleContextURI: moduleContextURI,
				disableFormatsDropdown: false,
				objectTypeFilter: this._getObjectTypeFilter(),
				folderBased: true,
				context: com.ibm.rdm.web.project.NewArtifactForm.context.NEW_ARTIFACT
			});
			this._toDestroy.push(newArtifactDialog);
			
			newArtifactDialog.show(args.onDialogClose);

			if (moduleContextURI){
				this.connect(newArtifactDialog, "onDialogClose", dojo.hitch(this, function(){
					this.setCreateDisabled(false);
					//Ensure that if a temp lock has been taken, we release it.
					//Note if that it was explicitly taken, this implicit release will not release it.
					if (this._tempLockObtained) {
						LockManager.releaseLockedResource(this._tempLockObtained);
						delete this._tempLockObtained;
					}
					if (creationDeferred.fired === -1){	
						creationDeferred.callback();
					}
				}));
			}
			var con = dojo.connect(newArtifactDialog, "onCreate", this, function (artifact, openArtifactInEditMode){
				dojo.disconnect(con);
				var inModule = (this.viewType === DashboardConstants.VIEW_TYPES.MODULE);
				if (inModule) {
					this.setCreateDisabled(false);
				}
				
				if (!args.moduleContextURI && (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION || this.viewType === DashboardConstants.VIEW_TYPES.MODULE)) {
					this.resourceViewer.addArtifacts([artifact], true);
				}
				if (openArtifactInEditMode) {
					ResourceLinksHandler.showArtifactInEditMode(artifact.getResourceURI());
				}
				else if (args.wasEditing){
					var editURIs = {};
					editURIs[artifact.getResourceURI()] = true;
					this._resultSetGridView.editRow(editURIs, inModule);
				}
				creationDeferred.callback(artifact);
			});
			this._connections.push(con);
			return creationDeferred;
		}
		else {
			return this._createOneClickArtifact(
				selectedFolder, moduleContextURI, typeURI, args
			);
		}
	},

	_createOneClickArtifact: function(folderURI, moduleContextURI, artifactTypeURI,
									originalCreateArtifactArgs)
	{
		// summary:
		//		Attempt to create an artifact using one-click create.  If not
		//		possible (due to create permission issues) instead invoke the
		//		Create Artifact dialog.
		
		var creationDeferred = new dojo.Deferred();
		
		var createOneClickResource = dojo.hitch(this, function(objectType) {
			var artifactFormatURI = objectType.getDefaultFormat();
			var artifactTemplateURI =
				ResourceUtil.getLastSelectedArtifactTemplateForObjectTypeAndArtifactFormat(
					artifactTypeURI, artifactFormatURI, this.projectURI
				);
			//54637: Newly created requirements in module should have no name and no content
			var newArtifactTitle =
				moduleContextURI ? "" : this._messages["new"] + " " + objectType.getTitle();
			
			var deferred = ResourceUtil.createResource({
				format: artifactFormatURI,
				projectURI: this.projectURI,
				resourceUriScope: this.resourceURI,
				folderURI: (moduleContextURI ? null : folderURI),//Only add to folder if no module
				typeURI: artifactTypeURI,
				artifactTemplateURI: artifactTemplateURI,
				primaryText: "",
				title: newArtifactTitle,
				description: "",
				enableEditInGrid: true,
				moduleContextURI: moduleContextURI,
				isHeading: moduleContextURI && objectType.isModuleHeading()
			});
			
			deferred.then(
				dojo.hitch(this, function(response){
					creationDeferred.callback(true);
					StatusDisplay.hideStatusMessage();
					this.setCreateDisabled(false);
					//Ensure that if a temp lock has been taken, we release it.
					//Note if that it was explicitly taken, this implicit release will not release it.
					if (this._tempLockObtained) {
						LockManager.releaseLockedResource(this._tempLockObtained);
						delete this._tempLockObtained;
					}
					if (originalCreateArtifactArgs.wasEditing){
						var editURIs = {};
						editURIs[response.getResourceURI()] = true;
						var inModule = (this.viewType === DashboardConstants.VIEW_TYPES.MODULE);
						this._resultSetGridView.editRow(editURIs, inModule);
					}
					return response;
				})
			);
		});
		var performPermissionCheckAndCreateResource = dojo.hitch(
			this,
			function(objectType) {
				var canCreateArtifactDeferred =
					ProcessOperationsCache.isCreateInstanceOfArtifactTypeAllowed(
						this.projectURI, folderURI, artifactTypeURI
					);
				canCreateArtifactDeferred.addCallback(this, function(isCreateInstanceOfArtifactTypeAllowed){
					if (isCreateInstanceOfArtifactTypeAllowed) {
						// We know that the user is authorized to create an artifact
						// of the specified type in the specified folder.  Use one-
						// click create to do so.
						StatusDisplay.showStatusMessage(this._messages.creatingArtifact);
						createOneClickResource(objectType);
					} else {
						// We've determined that the user is not authorized to create
						// an artifact of the specified type in the specified folder.
						// Call _createArtifact back in order to have the Create
						// Artifact dialog appear (which will alert the user to the
						// issue, but also enable the user to specify a different
						// folder or artifact type to get around the issue).
						this._createArtifact(
							originalCreateArtifactArgs,
							true // Pass doNotCreateUsingOneClickCreate as true ...
						);
					}
					return isCreateInstanceOfArtifactTypeAllowed;
				});
			}
		);
		var objectTypeDeferred = com.ibm.rdm.web.model.types.TypesManager.getObjectType({
			projectURI: this.projectURI,
			typeURI: artifactTypeURI,
			projectSnapshotURI: this.baselineURI
		});
		objectTypeDeferred.addBoth(this, function(objectType){
			if (objectType) {
				if (!folderURI && !moduleContextURI) {
					// Use the root folder if there is no folder specified and
					// we're not in a module.
					ProjectCache.getRootFolder(this.projectURI).addBoth(this, function(rootFolderURI){
						folderURI = rootFolderURI;
						performPermissionCheckAndCreateResource(objectType);
						return rootFolderURI;
					});
				}
				else if (moduleContextURI) {
					// If we ARE in a module we use the module's asset folder.
					folderURI = this.resourceViewer.getResourceObject().getAssetFolderURI();
					performPermissionCheckAndCreateResource(objectType);
				}
				else if (folderURI) {
					performPermissionCheckAndCreateResource(objectType);
				}
			}
			return objectType;
		});
		return creationDeferred;
	},
	
	_getFormatFilter: function(format){
		if (format && format === "Collection"){
			return dojo.hitch(this, function(formatURI){
				return (formatURI.indexOf("Collection") !== -1);
			});
		}
		else if (format && format === "Module"){
			return dojo.hitch(this, function(formatURI){
				return (formatURI.indexOf("Collection") === -1);
			});
			
		}
	},
	
	_getObjectTypeFilter: function() {
		if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
			return function(objectType) {
				var collectionFormat = RRMTypes.getArtifactFormats(this.projectURI)['Collection'];
				return objectType.getDefaultFormat() != collectionFormat;
			};
		}
		
		return null;
	},

	_createModule: function() {
		this._createArtifactImpl("Module");
	},
	
	_createCollection: function() {
		this._createArtifactImpl("Collection");
	},
	
	_createArtifactImpl: function (format) {
		var creationDeferred = new dojo.Deferred();
		var selectedFolder = null;
		if (this._foldersSection){
			selectedFolder = this._foldersSection.getSelectedFolders()[0];
		}
		var context = com.ibm.rdm.web.project.NewArtifactForm.context.NEW_ARTIFACT;
		if(format === "Module"){
			context = com.ibm.rdm.web.project.NewArtifactForm.context.MODULE;
		}else if(format === "Collection"){
			context = com.ibm.rdm.web.project.NewArtifactForm.context.COLLECTION;
		}
		var newArtifactDialog = new com.ibm.rdm.web.project.NewArtifactForm({
			artifactFormat: RRMTypes.getArtifactFormats(this.projectURI)[format],
			typeURI: null,
			formatsFilter: this._getFormatFilter(format),
			disableFormatsDropdown: true,
			projectURI: this.projectURI,
			resourceURI: this.resourceURI,
			folderURI: selectedFolder,
			folderBased: true,
			context: context,
			forceFormat: true
		});
		this._toDestroy.push(newArtifactDialog);
		
		newArtifactDialog.show();
		var con = dojo.connect(newArtifactDialog, "onCreate", this, function (artifact, openArtifactInEditMode){
			creationDeferred.callback(true);
			dojo.disconnect(con);
			if (openArtifactInEditMode) {
				ResourceLinksHandler.showArtifactInEditMode(artifact.getResourceURI());
			}
		});
		this._connections.push(con);
		return creationDeferred;
	},
	
	_uploadArtifact: function(filesToUpload, /*String?*/where, /*String?*/relativeSiblingURI) {
		var creationDeferred = new dojo.Deferred();
		var selectedFolder = null;
		var onCancel = function(){};
		if (!where) {
			where = com.ibm.rdm.web.model.resources.modules.ModuleStructure.LAST;
		}
		if (this._foldersSection){
			selectedFolder = this._foldersSection.getSelectedFolders()[0];
		}
		if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
			if (!this.resourceViewer.isEdit()) {
				this.resourceViewer.onEdit();
			}
		}
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			var modURI = this.moduleStructure.moduleURI;
			var assetFolderLoc = this.resourceViewer.getResourceObject().getAssetFolderURI();
			selectedFolder = (assetFolderLoc) ? assetFolderLoc : null;
			onCancel = function() {
				LockManager.releaseLockedResource(modURI);
				creationDeferred.callback(true);
			};
		}
		var uploadArtifactDialog = new com.ibm.rdm.web.project.UploadArtifactForm({
			artifactFormat: MimeTypes.getArtifactFormat(MimeTypes.WRAPPER_RESOURCE_NAME, this.projectURI),
			projectURI: this.projectURI,
			resourceURI: this.resourceURI,
			folderURI: selectedFolder,
			projectDashboardTab: this,
			hideOpen: ((this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION || this.viewType === DashboardConstants.VIEW_TYPES.MODULE || filesToUpload) ? true : false),
			filesToUpload: filesToUpload,
			quickUpload: this.isOneClickCreateEnabled(),
			typeURI: ResourceUtil.getLastSelectedObjectType(this.projectURI).typeURI,
			onCancel: onCancel,
			onDialogClose: onCancel,
			folderBased: true,
			context: com.ibm.rdm.web.project.NewArtifactForm.context.FILE_UPLOAD
		});
		this._toDestroy.push(uploadArtifactDialog);

		uploadArtifactDialog.show();
		var con = dojo.connect(uploadArtifactDialog, "onCreate", this, function (artifact, openArtifactInEditMode){
			try {				
				creationDeferred.callback(true);
			} catch (e) {
				// The deferred may have been resolved elsewhere. That is fine.
			}
			dojo.disconnect(con);
			if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
				this.resourceViewer.addArtifacts(dojo.isArray(artifact) ? artifact : [artifact], false);
			} else if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
				this.getResultSetGridView().getCommands().addExistingArtifacts(relativeSiblingURI, artifact, where);
				LockManager.releaseLockedResource(this.moduleStructure.moduleURI);
			}
			if (openArtifactInEditMode) {
				var artifactToOpen = dojo.isArray(artifact) ? artifact[0] : artifact;
				ResourceLinksHandler.showArtifactInEditMode(artifactToOpen.getResourceURI());
			}
		});
		this._connections.push(con);
		return creationDeferred;
	},
	
	_invokeImport: function() {
		var selectedFilterFolder = this.getSelectedFolder();
		var wizard = new com.ibm.rdm.web.external.ImportWizard({
			projectURI: this.projectURI,
			folderURI: selectedFilterFolder
		});
		this._toDestroy.push(wizard);
		
		wizard.show();
		wizard.addWizardSteps(com.ibm.rdm.web.external.ImportWizard.wizardType.HOME_PAGE);
		wizard.selectFirstOption();
	},

	_createComboButton: function(){
		var isArtifacts = this.viewType == DashboardConstants.VIEW_TYPES.ARTIFACTS,
			isCollection = this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION,
			isModule = this.viewType === DashboardConstants.VIEW_TYPES.MODULE;
		
		if (this._comboButtonWidget) {
			this._comboButtonWidget.destroyRecursive();
			this._comboButtonWidget = null;
		}
		if (isModule) {
			this._comboButtonWidget = new com.ibm.rdm.web.project.ModuleComboButton({
				projectURI: this.projectURI,
				moduleArtifactTypeURI: this.getArtifactTypeURI(),
				moduleStructure: this.moduleStructure,
				commands: this._resultSetGridView.commands,
				iconClass: "createButton",
				dashboadTabPageMessages: this._messages,
				onCreateArtifactOfTypeAndHeadingness: dojo.hitch(
					this, this._onCreateArtifactOfTypeAndHeadingnessInModule
				),
				onCreateOtherArtifactType: dojo.hitch(
					this, this._onCreateOtherArtifactTypeInModule
				),
				onUploadArtifact: dojo.hitch(
					this, this._onUploadArtifactToModule
				),
				onAddExistingArtifact: dojo.hitch(
					this, this._onAddExistingArtifactToModule
				)
			});
		}
		else if (isArtifacts || isCollection) {
			if(isCollection) {
				this.isAddToCollectionButtonActive = true;
			}
			this._comboButtonWidget = new com.ibm.rdm.web.project._DashboardTabPageComboButton({
				isCollection: isCollection,
				label: this._messages.createArtifact,
				isOneClickCreate: this.isOneClickCreateEnabled(),
				iconClass: "createButton",
				disabled: true,
				onClick: dojo.hitch(this, function(event){
					dojo.stopEvent(event);
					if(this.isAddToCollectionButtonActive || this.isAddToModuleButtonActive) {
						this.onAddArtifacts(); 
					}
					else { 
						this.createArtifact(null, event);
					}
				}),
				messages: this._messages
			});
		}
		else if (this.viewType == DashboardConstants.VIEW_TYPES.COLLECTIONS) {
			this._comboButtonWidget = new dijit.form.Button({
				label: this._messages.collection,
				disabled: true,
				iconClass: "createButton",
				onClick: dojo.hitch(this, function(){
					this._createCollection();
				})
			});
			this._comboButtonWidget.set("title", this._messages.collectionTitle);
			dojo.addClass(this._comboButtonWidget.domNode, "rdmCreateModuleOrCollectionButton");
			dojo.addClass(this._createNewAritfactButtonContainerDiv, "collectionsOrModules");
		}
		else if (this.viewType == DashboardConstants.VIEW_TYPES.MODULES) {
			this._comboButtonWidget = new dijit.form.Button({
				label: this._messages.createModuleButtonLabel,
				disabled: true,
				iconClass: "createButton",
				onClick: dojo.hitch(this, function(){
					this._createModule();
				})
			});
			this._comboButtonWidget.set("title", this._messages.createModuleButtonTooltip);
			dojo.addClass(this._comboButtonWidget.domNode, "rdmCreateModuleOrCollectionButton");
			dojo.addClass(this._createNewAritfactButtonContainerDiv, "collectionsOrModules");
		}
		this._toDestroy.push(this._comboButtonWidget);
		this._createNewAritfactButtonContainerDiv.appendChild(this._comboButtonWidget.domNode);

		if (!isModule) {
			this._populateCreateArtifactsMenu();
		}

		this._isCreateAllowed().then(
			dojo.hitch(this, function(isCreateAllowed){
				this.setCreateDisabled(!isCreateAllowed);
			})
		);
	},

	_isCreateAllowed: function() {
		var isCreateAllowedDeferred = new dojo.Deferred();
		var projectOperations = null;
		var modifyArtifactPermissions = null;
		var projectOperationsDeferred = ProjectCache.getProjectPermissions(this.projectURI);
		var getModifyArtifactPermissionsDeferred = null;
		projectOperationsDeferred.addCallback(this, function(operations){
			projectOperations = operations;
			return operations;
		});
		if (this.resourceViewer) {
			getModifyArtifactPermissionsDeferred =
				this.resourceViewer.getModifyArtifactPermissions().addCallback(
					this,
					function(permissions){
						modifyArtifactPermissions = permissions;
						return permissions;
					}
				);
		}
		var deferredArray = [projectOperationsDeferred];
		if (getModifyArtifactPermissionsDeferred) {
			deferredArray.push(getModifyArtifactPermissionsDeferred);
		}
		var deferredList = new dojo.DeferredList(deferredArray);
		deferredList.addCallback(this, function(){
			VvcUtils.isChangeSetWorkflowEnabledOnCurrentConfiguration().then(dojo.hitch(this, function(workflowEnabled) {
				var isCreateAllowed = (
						projectOperations.item(ProjectCache.MODIFY_RESOURCE)
						&& !VvcUtils.isCurrentConfigurationSnapshot()
						&& !workflowEnabled
						&& (modifyArtifactPermissions ? modifyArtifactPermissions.isModifyContentAllowed() : true)
						&& !this.baselineURI
						&& !this.isInReviewMode
						&& !(this.resourceViewer && this.resourceViewer.isInHistoryMode())
						&& (((this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION
							|| this.viewType === DashboardConstants.VIEW_TYPES.MODULE)
							&& this.resourceViewer
							&& this.resourceViewer.viewType !== com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewType.ShowArtifactHistory)
							||
							this.viewType !== DashboardConstants.VIEW_TYPES.COLLECTION
						)
						&& (this.moduleStructure ? !this.moduleStructure.hasViewFiltersApplied() : true)
						&& (this.moduleStructure ? !this.moduleStructure.isSortApplied() : true)
					);
					this.isCreateAllowed = isCreateAllowed;
					isCreateAllowedDeferred.resolve(isCreateAllowed);
			}));
			
		});
		return isCreateAllowedDeferred;
	},
	
	_createObjectTypeMenuItem: function(objectType){
		var iconClass = ArtifactIcons.getSmallImageClass(this.projectURI, objectType.getResourceURI());
						
						
		return {
			label: domutils.getXMLEncodedText(objectType.getTitle()),
			callback: dojo.hitch(this, function(){
				this._verifyModuleLock(dojo.hitch(this, function() {		
					var continueWithSave = dojo.hitch(this, function() {
						return this._createArtifact({
							typeURI: objectType.getResourceURI()
						});
					});
					return continueWithSave();
				}));
			}),
			iconClass: iconClass
		};
	},
	
	_createObjectTypeMoreMenuItem: function(){
		return {
			label: this._messages.more,
			callback: dojo.hitch(this, function(){
				this._verifyModuleLock(dojo.hitch(this, function() {		
					var continueWithSave = dojo.hitch(this, function() {
						return this._createArtifact({
							artifactFormat: RRMTypes.getArtifactFormats(this.projectURI).Text,
							isMoreOption: true
						});
					});
					if (this.moduleStructure && dojo.isFunction(this.moduleStructure.checkLatest)){
						var latestDeferred = new dojo.Deferred();
						this.moduleStructure.checkLatest(latestDeferred).then(dojo.hitch(this, function(shouldContinue){
							if (shouldContinue){
								continueWithSave().then(dojo.hitch(this, function(saveResp){
									latestDeferred.callback(saveResp);
								}));
							}
							else{
								latestDeferred.callback();
							}
						}));
						return latestDeferred;
					}
					else{
						return continueWithSave();
					}
				}));
			})
		};
	},
	
	_getModuleProcessAreaURI: function() {
		// summary:
		//		Returns the process area URI for the current module/collection.
		
		return this.resourceViewer && this.resourceViewer.getResourceObject && this.resourceViewer.getResourceObject().getProcessAreaURI();
	},

	_createUploadArtifactMenuItem: function(){
		return {
			label: this._messages["uploadArtifact"],
			callback: dojo.hitch(this, function(){
				this._verifyModuleLock(dojo.hitch(this, function() {		
					var continueWithSave = dojo.hitch(this, function() {
						return this._uploadArtifact();
					});
					if (this.moduleStructure && dojo.isFunction(this.moduleStructure.checkLatest)){
						var latestDeferred = new dojo.Deferred();
						this.moduleStructure.checkLatest(latestDeferred).then(dojo.hitch(this, function(shouldContinue){
							if (shouldContinue){
								continueWithSave().then(dojo.hitch(this, function(saveResp){
									latestDeferred.callback(saveResp);
								}));
							}
							else{
								latestDeferred.callback();
							}
						}));
						return latestDeferred;
					}
					else{
						return continueWithSave();
					}
				}));		
			}),
			iconClass: MimeTypeRegistry.getImageClass(MimeTypes.getArtifactFormat(MimeTypes.WRAPPER_RESOURCE_NAME, 
																						this.projectURI), this.projectURI)
		};
	},
	
	_createImportArtifactMenuItem: function() {
		return {
			label: this._messages["import"],
			iconClass: "importIcon",
			callback: dojo.hitch(this, function(){
				this._verifyModuleLock(dojo.hitch(this, function() {		
					this._invokeImport();
				}));
			})
		};
	},
	
	_createAddToCollectionMenuItem: function() {
		return {
			label: this._messages["addAnArtifact"],
			iconClass: "add-to-collection-menu-item",
			callback: dojo.hitch(this, function() { 
				this.isAddToCollectionButtonActive = true;
				this.updateCreateButtonLabel();
				this.onAddArtifacts(); 
			})
		};
	},
	
	_verifyModuleLock: function(lockOkCallback) {
		
		if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			//If we are in a module, we need to get a lock
			var lockObtainedFn = dojo.hitch(this, function() {
				
				//We have the lock - either explicitly from before, or temporarily for this operation. Thats ok - we only release it later if it is temporary.
				this._tempLockObtained = this.resourceURI;
				lockOkCallback();
			});
			
			var lockFailedFn = function() {};
			
			//Refresh the lock to ensure we are uptodate
			LockManager.refreshLockStatus(this.resourceURI).addBoth(dojo.hitch(this, function(lockStatus) {
				//Obtain implicit lock on module, with override if necessary.
				LockManager.obtainImplicitLock(LockManager.MSG_LOCK, lockObtainedFn, lockFailedFn, this.resourceURI, this.projectURI, this._getModuleProcessAreaURI(), ProcessOperationsCache);
			}));
		} else {
			//Not in module - no lock required
			lockOkCallback();
		}
	},

	_populateCreateArtifactsMenu: function(){
		if (this.viewType == DashboardConstants.VIEW_TYPES.ARTIFACTS ||
			this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION ||
			this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
			var createArtifactMenuItems = [];

			// Collections editor contains a general 'Add an artifact' button 
			if(this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION) {
				createArtifactMenuItems.push(this._createAddToCollectionMenuItem());
			}
			
			var objectTypesDeferred = com.ibm.rdm.web.model.types.TypesManager.getObjectTypesForProject({projectURI: this.projectURI, projectSnapshotURI: this.baselineURI});
			objectTypesDeferred.addCallback(this, function(objectTypesInfo){
				if(objectTypesInfo.length > 0){
					// The top section of the menu holds artifact types that have
					// anything except "Glossary", "Term" and "Collection" as their default format
					var objectTypes = dojo.filter(objectTypesInfo, dojo.hitch(this, function(item){
						return item.getDefaultFormat() !== MimeTypes.getArtifactFormat(MimeTypes.GLOSSARY_NAME, this.projectURI)
							&& item.getDefaultFormat() !== MimeTypes.getArtifactFormat(MimeTypes.TERM_NAME, this.projectURI)
							&& item.getDefaultFormat() !== MimeTypes.getArtifactFormat(MimeTypes.COLLECTION_NAME, this.projectURI)
							&& item.getDefaultFormat() !== MimeTypes.getArtifactFormat(MimeTypes.WRAPPER_RESOURCE_NAME, this.projectURI);
					}));
					
					//do not allow creating modules and collections in modules
					if(this.viewType == DashboardConstants.VIEW_TYPES.MODULE) {
						objectTypes = dojo.filter(objectTypesInfo, dojo.hitch(this, function(item){
							return (
								item.getDefaultFormat() != MimeTypes.getArtifactFormat(MimeTypes.MODULE_NAME, this.projectURI) &&
								item.getDefaultFormat() != MimeTypes.getArtifactFormat(MimeTypes.COLLECTION_NAME, this.projectURI)
							);
						}));
					}
	
					var MAX_OBJECT_TYPE_MENU_ITEMS = 9;
					for (var i = 0; i < objectTypes.length && i < MAX_OBJECT_TYPE_MENU_ITEMS; i++){ 
						createArtifactMenuItems.push(this._createObjectTypeMenuItem(objectTypes[i]));
					}
					if (objectTypes.length > MAX_OBJECT_TYPE_MENU_ITEMS) {
						createArtifactMenuItems.push(this._createObjectTypeMoreMenuItem());
					}
					
					var isOneClickCreateEnabled = this.isOneClickCreateEnabled();
					this._comboButtonWidget.set("isOneClickCreateEnabled", isOneClickCreateEnabled);
					createArtifactMenuItems.push({	
						label: '<input type="checkbox" ' + ((isOneClickCreateEnabled)?"checked":"") + '/> ' + this._messages.oneClickCreate,
						callback: dojo.hitch(this, function(){
							isOneClickCreateEnabled = !isOneClickCreateEnabled;
							this._comboButtonWidget.set("isOneClickCreate", isOneClickCreateEnabled);
							this._comboButtonWidget.set("dropDownValues", createArtifactMenuItems);
							com.ibm.rdm.web.util.storage.set({
								"key" : ONE_CLICK_COOKIE,
								"data" : isOneClickCreateEnabled,
								"cookieFallback" : true,
								"cookieData" : {expires:999}
							});
							window.setTimeout(dojo.hitch(this, function(){
								this._populateCreateArtifactsMenu();
							}), 200);
						}),
						iconUrl: null
					});
					
					//TODO: remove this once supported
					if(this.viewType !== DashboardConstants.VIEW_TYPES.MODULE && this.viewType !== DashboardConstants.VIEW_TYPES.COLLECTION) {
						createArtifactMenuItems.push(this._createImportArtifactMenuItem());
					}
					createArtifactMenuItems.push(this._createUploadArtifactMenuItem());

					this._comboButtonWidget.set("dropDownValues", createArtifactMenuItems);

					if (objectTypes.length > 0) {
						this.updateCreateButtonLabel(
							ResourceUtil.getLastSelectedObjectType(this.projectURI).typeURI
							|| objectTypes[0].getResourceURI()
						);
					} else {
						this.updateCreateButtonLabel();
					}
				}
				return objectTypesInfo;
			});
			objectTypesDeferred.addErrback(this, function(errback){
				// TODO:
				//		handle this error
				return errback;
			});
		}
	},
	
	updateCreateButtonLabel: function(/*String?*/objectTypeURI) {
		var isArtifacts = (this.viewType == DashboardConstants.VIEW_TYPES.ARTIFACTS);
		var isCollection = (this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION);
		var isModule = (this.viewType == DashboardConstants.VIEW_TYPES.MODULE);
		var lastSelectedObjectTypeURI = objectTypeURI;

		if (isModule) {
			this.isAddToModuleButtonActive = true;
			if (objectTypeURI) {
				this._comboButtonWidget.resetArtifactTypeToCreate(objectTypeURI);
				this._resizeComboButtonWidth();
			}
		}
		else if(this.isAddToCollectionButtonActive) {
			this._updateCreateButtonLabelTextToAddArtifact();
			this._updateCreateButtonIcon();
		}
		else if(this.isAddToModuleButtonActive) {
			this._updateCreateButtonLabelTextToAddArtifact();
			this._updateCreateButtonIcon();
		}
		else if(isCollection || isArtifacts) {
			if(!lastSelectedObjectTypeURI) {
				lastSelectedObjectTypeURI = ResourceUtil.getLastSelectedObjectType(this.projectURI).typeURI;
			}
			if (lastSelectedObjectTypeURI) {
				var objectTypeDeferred = com.ibm.rdm.web.model.types.TypesManager.getObjectType({
					projectURI: this.projectURI,
					typeURI: lastSelectedObjectTypeURI,
					projectSnapshotURI: this.baselineURI
				});
				objectTypeDeferred.addBoth(this, function(objectType){
					if(objectType && isModule && objectType.getDefaultFormat() && objectType.getDefaultFormat().indexOf("Text") === -1) { //TODO: in beta1 we only only allow text artifacts in modules
						this.isAddToModuleButtonActive = true;
						this._updateCreateButtonLabelTextToAddArtifact();
						this._updateCreateButtonIcon();
					}
					else if(objectType && ((isCollection && objectType.getDefaultFormat() && objectType.getDefaultFormat().indexOf("Collection") === -1)|| !isCollection)) { //Do not allow the create button to set to a collection
						ResourceUtil.setLastSelectedObjectType(this.projectURI, lastSelectedObjectTypeURI, objectType.getDefaultFormat());
						this._updateCreateButtonLabelText(objectType.getTitle());
						this._updateCreateButtonIcon(objectType.getResourceURI());
					}
					else {
						this._setDefaultLastSelectedObjectType();
					}
				});
			}
			else {
				this._setDefaultLastSelectedObjectType();
			}
		}
	},
	
	_setDefaultLastSelectedObjectType: function() {
		var objectTypesDeferred = com.ibm.rdm.web.model.types.TypesManager.getObjectTypesForProject({projectURI: this.projectURI, projectSnapshotURI: this.baselineURI});
		objectTypesDeferred.addBoth(this, function(objectTypes){
			if(objectTypes && objectTypes.length > 0){
				ResourceUtil.setLastSelectedObjectType(this.projectURI, objectTypes[0].getResourceURI(), objectTypes[0].getDefaultFormat());
				this._updateCreateButtonLabelText(objectTypes[0].getTitle());
			}
		});
	},
	
	isOneClickCreateEnabled: function() {
		var isOneClickCreateEnabled = com.ibm.rdm.web.util.storage.get({
			"key" : ONE_CLICK_COOKIE,
			"cookieFallback" : true
		});
		if(typeof isOneClickCreateEnabled === "boolean") {
			return isOneClickCreateEnabled;
		}
		isOneClickCreateEnabled = (isOneClickCreateEnabled=="true")?true:false;
		return isOneClickCreateEnabled;
	},
	
	_updateCreateButtonLabelText: function(objectTypeTitle) {
		var labelText = dojo.string.substitute(
			this._messages.createNewArtifactButtonLabel,
			[domutils.getHTMLEncodedText(objectTypeTitle)]
		);
		var tooltipText = dojo.string.substitute(
			this._messages.createNewArtifactButtonTooltip,
			[objectTypeTitle]
		);
		this._comboButtonWidget.set("title", tooltipText);
		this._comboButtonWidget.set("label", labelText);
		this._resizeComboButtonWidth();
	},
	
	_updateCreateButtonLabelTextToAddArtifact: function() {
		var labelText = dojo.string.substitute(this._messages.addArtifactButtonLabel, [this._messages["artifact"]]);
		var tooltipText =  this._messages["addArtifact"];
		this._comboButtonWidget.set("title", tooltipText);
		this._comboButtonWidget.set("label", labelText);
	},
	
	/**
	 * We no longer update the button icon, but keep everything together
	 */
	_updateCreateButtonIcon: function(/*String?*/objectTypeURI) {
		// At some point we may decide to resurrect the ability of the Create button to show
		// an icon for the associated last selected type ... so we'll just comment this code
		// out for now ...
		/*
		if (objectTypeURI) {
			var objectTypeDeferred = com.ibm.rdm.web.model.types.TypesManager.getObjectType({
				projectURI: this.projectURI,
				typeURI: objectTypeURI,
				projectSnapshotURI: this.baselineURI
			});
			objectTypeDeferred.addBoth(this, function(objectType){
				var iconReference = objectType.getIconReference(),
					iconType = (
						iconReference ?
						IconManager.getSmallImageClass(iconReference) :
						MimeTypeRegistry.getImageClass(
							objectType.getDefaultFormat(), this.projectURI
						)
					);
				this._comboButtonWidget.set("iconClass", iconType);
			});
			this._comboButtonWidget.set("isObjectTypeIcon", true);
		} else {
			if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTIONS) {
				this._comboButtonWidget.set("iconClass", "collectionIconNode");
			}
			else if (this.viewType === DashboardConstants.VIEW_TYPES.MODULES) {
				this._comboButtonWidget.set("iconClass", "moduleIconNode");
			}
			else if (this.viewType === DashboardConstants.VIEW_TYPES.COLLECTION) {
				this._comboButtonWidget.set("iconClass", "add-to-collection-menu-item");
			}
			this._comboButtonWidget.set("isObjectTypeIcon", false);
		}
		*/
	},

	_performViewQueriesAndAddResultsToGrid: function(notifierParams, resourceObjects,
													 enableEditInGrid, enableFocusInGrid) {
		// summary:
		//		Issue appropriate view queries needed to add a new grid row for every
		//		newly created artifact represented by the passed resourceObjects.
		// description:
		//		Ideally, we'd issue a single view query to get the results needed to
		//		appropriately create new rows in the grid for every artifact represented
		//		by the passed resourceObjects.  Occasionally, however, the view query comes
		//		back without all the needed results (for the newly created artifacts that 
		//		haven't been indexed yet).  In this case we use a scheme of waiting and
		//		then reissuing the query, repetitively, until either all results are known
		//		or we've exceeded a max number of retries.

		var resourceObject = resourceObjects[0],
			maxRetries = 20,
			numRowsAdded = 0,
			numRowsToAdd = resourceObjects.length,
			retryCount = 0,
			mapArtifactUriToViewResultsKnown = {},
			resourceURIs = (
				notifierParams.eventTopic === com.ibm.rdm.web.notifications.EventTopics.RESOURCES_COPIED ?
				// Handle the case of RESOURCES_COPIED.
				dojo.map(notifierParams.resourceObjects, function(resourceObject){
					return resourceObject.resourceURI;
				}) :
				// Handle the case of RESOURCE_CREATED or RESOURCE_COPIED.
				[resourceObject.resourceURI]
			);
		var issueViewQueryAndAddResultRows = dojo.hitch(this, function(resourceURIs){
			var processedArtifactURIs = [];
			// make sure we ask whether this artifact is a heading, it will have been set (or should have been)
			// based on whether the artifact type has the module heading role.
			return this._performViewRequestOnURIs(resourceURIs, [RRMTypes.WELL_KNOWN_IS_HEADING]).then(
				dojo.hitch(this, function(viewServiceResults){
					var resource,
						i;
					for (i = 0; i < viewServiceResults.resources.length; i++) {
						resource = viewServiceResults.resources[i];
						if (resource) {
							processedArtifactURIs.push(resource.getResourceURI());
							this._resultSetGridView.addResult(
								resource, enableEditInGrid, enableFocusInGrid,
								notifierParams.where,
								notifierParams.relativeSiblingURI
							);
						}
					}
					return processedArtifactURIs;
				})
			);
		});
		var updateMappingsAndGetArtifactUrisToRequeryFor = dojo.hitch(this, function(newlyProcessedArtifactURIs){
			// Run through the newlyProcessedArtifactURIs to add appropriate new entries
			// to mapArtifactUriToViewResultsKnown and return an array containing
			// all the artifact URIs that we still need to requery for (i.e. via a
			// new view request).
			var missingArifactURIs = [],
				i;
			for (i = 0; i < newlyProcessedArtifactURIs.length; i++) {
				mapArtifactUriToViewResultsKnown[newlyProcessedArtifactURIs[i]] = true;
			}
			for (i = 0; i < resourceURIs.length; i++) {
				var resourceURI = resourceURIs[i];
				if (!mapArtifactUriToViewResultsKnown[resourceURI]) {
					missingArifactURIs.push(resourceURI);
				}
			}
			return missingArifactURIs;
		});
		var reissueViewQueriesUntilAllResultsAreKnown = dojo.hitch(this, function(artifactUrisWithMissingViewResults){
			// Keep reissuing view queries until we receive appropriate results for all of
			// the passed resource URIs.
			retryCount++;
			issueViewQueryAndAddResultRows(artifactUrisWithMissingViewResults).then(
				dojo.hitch(this, function(processedResourceURIs){
					numRowsAdded += processedResourceURIs.length;
					if (numRowsToAdd !== numRowsAdded && retryCount < maxRetries) {
						artifactUrisWithMissingViewResults =
							updateMappingsAndGetArtifactUrisToRequeryFor(processedResourceURIs);
						// Wait a second and issue a new query for those resources
						// we failed to get results back for.
						setTimeout(
							function(){
								reissueViewQueriesUntilAllResultsAreKnown(artifactUrisWithMissingViewResults);
							},
							1000
						);
					}
				}),
				dojo.hitch(this, function(error){
					com.ibm.rdm.web.common.MessageHandler.showError(7611);
				})
			);
		});
		reissueViewQueriesUntilAllResultsAreKnown(resourceURIs);
	},
	
	_addNewResourceOrResourcesToGrid: function(args) {
		//34649: Artifacts with type other than collection are shown in the collection viewer
		if (this.viewType == DashboardConstants.VIEW_TYPES.COLLECTIONS && args.notifierParams.resourceObject.getEntityType() != RRMTypes.getArtifactFormats(this.projectURI).Collection) {
			//ignore adding other artifacts to collections tab
			return;
		}
		if (this.viewType == DashboardConstants.VIEW_TYPES.COLLECTION && args.notifierParams.resourceObject.getEntityType() == RRMTypes.getArtifactFormats(this.projectURI).Collection) {
			//ignore adding collections to collection
			return;
		}
		if (this.resourceViewer && this.resourceViewer.viewType == com.ibm.rdm.web.artifact.AbstractResourceArtifactWidget.viewType.ShowArtifactHistory) {
			//history
			return;
		}
		// WI 63897.  ResourceUtil.createRequirement() fires a ChangeNotifier event informing interested
		// parties (of which this class is a member) that a new requirement was created.  This used to happen
		// after the creation deferred was fired, it now happens before - which seems correct. This line used
		// to ask "is the big blue button disabled?" which is still was since it hadn't been renabled
		// to check whether or not it should ignore the creation event.
		//
		// These creation events are too coarse - this statement and the 3 above are filtering out events
		// we are not interested in receiving. 
		if (this.baselineURI) {
			//snapshot or else...
			return;
		}
		if ((args.notifierParams.eventTopic === com.ibm.rdm.web.notifications.EventTopics.RESOURCE_COPIED
			 || args.notifierParams.eventTopic === com.ibm.rdm.web.notifications.EventTopics.RESOURCES_COPIED)
			&& this._foldersSection
			) {
			// Avoid adding a new row to the grid if the this is a copy artifact
			// situation and there currently exists a folder filter where the
			// selected folder is not the same as the folder selected by the user in
			// the CopyFolderPicker.
			var selectedFilterFolder = this.getSelectedFolder();
			if (selectedFilterFolder
				&& selectedFilterFolder !== com.ibm.rdm.web.picker.CopyFolderPicker.getLastSelectedFolder()
				) {
				return;
			}
		}
		// Note: for RESOURCE_CREATED and RESOURCE_COPIED args.notifierParams.resourceObject will
		// be set, but for RESOURCES_COPIED args.notifierParams.resourceObjects will bet set.
		// We do this so that we can, ideally, issue a _single_ call to _performViewRequestOnURIs
		// within the _performViewQueriesAndAddResultsToGrid method that's found in the 'if'
		// 'if' statement that follows this 'var' statement.  In other words rather than
		// issue a separate view request for each copied artifact, we instead want to issue a
		// single view request that mentions all of the newly created (i.e. copied) artifacts.
		var enableEditInGrid = args.notifierParams.enableEditInGrid || false,
			enableFocusInGrid = args.notifierParams.enableFocusInGrid || false,
			notifierParams = args.notifierParams,
			resourceObject = notifierParams.resourceObject || notifierParams.resourceObjects[0],
			resourceObjects = notifierParams.resourceObjects || [resourceObject],
			i;
		if (resourceObject.declaredClass.indexOf("PartialRequirement") === -1){
			// Avoid doing anything if we're attempting to add a modulefact to
			// the "Artifacts" view (see Defect 73181) ...
			if (! (
					this.viewType == DashboardConstants.VIEW_TYPES.ARTIFACTS
					&& resourceObject.isInModule()
				))
			{
				this._performViewQueriesAndAddResultsToGrid(
					notifierParams,
					resourceObjects,
					enableEditInGrid,
					enableFocusInGrid
				);
			}
		} else {
			// Note: We don't need to worry about the case of RESOURCES_COPIED here (as
			// resourceObject.declaredClass is always "PartialRequirement" in the case
			// of a RESOURCES_COPIED event).
			this._resultSetGridView.addResult(
				notifierParams.resourceObject, enableEditInGrid, enableFocusInGrid
			);
		}
	},

	updateBaselineInformation: function(baselineURI){
		this.baselineURI = baselineURI;
		this._resultSetGridView.setBaseline(baselineURI);
		this._savedFiltersSection.setBaseline(baselineURI);
	},
	
	enableFilterSection: function (enable) {

		if (!enable) {
			if (this.filterSectionOverlay) {
				this.filterSectionOverlay.show();
			} else {
				var filterSection = this._filterSectionsContainerDiv;
				var cbb = dojo.marginBox(this._comboButtonWidget.domNode),
					mb = dojo.marginBox(filterSection),
					style = {
						position: "absolute",
						height: mb.h+5+"px",
						width: "100%",
						zIndex: 999,
						backgroundColor: "white",
						opacity: "0.65",
						top: cbb.h+"px"
					};
				
				var	node = dojo.create("div", {
						style: style	
					}, filterSection);
					
							
						
				this.filterSectionOverlay = {
					hide: function () {
						dojo.style(node, "visibility", "hidden");
					},
				
					show: function () {
						dojo.style(node, "visibility", "visible");
					},
					
					getNode: function () {
						return node;
					}
				};
			}
			
		} else if (this.filterSectionOverlay){
			this.filterSectionOverlay.hide();
		}
	},
	
	_getArtifactTypeURI: function(resourceInfo) {
		var artifactTypeUris = resourceInfo.getTypes();
		// Note: we only ever have one URI found in the object returned by getTypes() ...
		for (var artifactTypeURI in artifactTypeUris) {
			return artifactTypeURI;
		}
		return null;
	},
	
	
	
	
	// DRAG AND DROP!
	configureDragDropArgs: function(dragDropArgs) {
		var dragTypes = {};
			dragTypes[DragTypes.URI_LIST] = dojo.hitch(this, this._encodeDragInternal, DragTypes.URI_LIST);
			dragTypes[DragTypes.TEXT_PLAIN] = dojo.hitch(this, this._encodeDragInternal, DragTypes.TEXT_PLAIN);
			dragTypes[DragTypes.HTML] = dojo.hitch(this, this._encodeDragInternal, DragTypes.HTML);
			
		if(dragDropArgs.isModule) {
			dragTypes[DragTypes.RRC_MODULE] = dojo.hitch(this, this._encodeDragInternal, DragTypes.RRC_MODULE);
		} else {
			dragTypes[DragTypes.RRC_ARTIFACT] = dojo.hitch(this, this._encodeDragInternal, DragTypes.RRC_ARTIFACT);
		}
		
		var defaultDragArgs = {
				dragSource: true,
				dragHandleInSelector: this.baselineURI ? false : true,
				onDragStart: dojo.hitch(this, this._onDragStart),
				onDragEnd: dojo.hitch(this, this._onDragEnd),
				onDragOver: dojo.hitch(this, this._onDragOver),
				getDragImage: dojo.hitch(this, this._getDragImage),
				dropTarget: true,
				dragTarget: true,
				isModule: false,
				onDrop: dojo.hitch(this, this._onDrop),
				dragTypes: dragTypes,
				validDropTypes: [DragTypes.RRC_MODULE, DragTypes.RRC_ARTIFACT],
				onLinkDrop: dojo.hitch(this, this._onLinkDrop),
				onDragAborted: dojo.hitch(this, function(){
					this._handleLeaveOrAbort(
						false // abort
					);
				})
			};
		return dojo.mixin(defaultDragArgs, dragDropArgs);
	},
	
	_handleLinkCreated: function(linkTypeURI, createdLink, flipLinks) {
			var artifactCommands = this._resultSetGridView.getCommands();
			artifactCommands.executePostLinkEvent(linkTypeURI, createdLink, flipLinks);
			StatusDisplay.hideStatusMessage();
			this._resultSetGridView.clearSelection();
	},
	_onDragOver: function(ev, uri, linkEvent) {
		// summary:
		//		Process the drag over event, this is delivered via the grid
		//		so comes replete with the additional useful parameter "uri"
		//		which is the uri of the grid row being dragged over.

		var bumpScroller = this._resultSetGridView.bumpScroller;

		// When we're D&D'ing artifacts we _do_ want to show visible bump scrollers
		// (as the user can scroll to the artifact he/she wants to link to), but
		// when we're D&D'ing files we _do_not_ want to show the bump scrollers as
		// their presence may give the user the false impression that he/she could
		// exactly position the placement of the dropped file.
		if (bumpScroller && !bumpScroller.isEventForFileBasedDnd(ev)) {
			dojo.addClass(this._resultSetGridView.domNode, "dragging");
			bumpScroller.showOrHideBumpers();
		}
		
		if(linkEvent) {
			dojo.addClass(this._resultSetGridView.domNode, "link-col-drag");
		} else if(dojo.hasClass(this._resultSetGridView.domNode, "link-col-drag")){
			dojo.removeClass(this._resultSetGridView.domNode, "link-col-drag");
		}
	},
	
	_onLinkDrop: function(event, targetUri, linkColID) {
		// summary:
		//		Handle a link drop event.
		var isModule = (this.viewType === DashboardConstants.VIEW_TYPES.MODULE),
			sourceEvent = event[DragTypes.RRC_MODULE] || event[DragTypes.RRC_ARTIFACT],
			dropObject = JSON.parse(sourceEvent),
			sourceUris = dropObject.dragURIs,
			linkURI,
			isObject,
			fastLink = (linkColID) ? true : false;
	
	
		// make sure we remove the dragOver class
		dojo.query(".dragOver,.link.active", this._resultSetGridView.domNode).removeClass(["dragOver", "active"]);
		if(isModule) {
			dojo.query(".dragging,.link-col-drag").removeClass(["dragging", "link-col-drag"]);
		} else {
			dojo.removeClass(this._resultSetGridView.domNode, ["dragging", "link-col-drag"]);
		}
		
		if (!sourceUris || ((sourceUris.length === 1) && (sourceUris[0] === targetUri))) {
			return;
		}
		
		// For cross project links check if are CM Enabled, and if so chack if we have a GC 
		if (this.projectURI !== dropObject.projectURI) {
			var isCMEnabled = ProjectCache.getCmState(this.projectURI);
			if ( isCMEnabled && VvcUtils.getGlobalConfigurationUri() == null ) {
				com.ibm.rdm.web.common.MessageHandler.showWarning(7387);
				return;
			}
		}
		
		if(fastLink) {
			var fullLinkURI = linkutils.getLinkUriByColId(linkColID);
			isObject = (fullLinkURI.indexOf("_OBJ") !== -1 || fullLinkURI.indexOf("_BI") !== -1);
			linkURI = fullLinkURI.substring(0, fullLinkURI.lastIndexOf("_"));
		}
		var dialog = new com.ibm.rdm.web.links.SimpleLinkDialog({
			sourceProjectURI: dropObject.projectURI,
			sourceProcessAreaURI: dropObject.projectURI, // TODO: can I use this as the process URI? Also, test.
			sourceURIs: sourceUris,
			targetProjectURI: this.projectURI,
			targetProcessAreaURI: this._getModuleProcessAreaURI(),
			targetURIs: [targetUri],
			isModule: isModule,
			isCrossWindow: dropObject.window !== com.ibm.rdm.web.windowID,
			linkTypeURI: linkURI,
			resourceIsObject: isObject,
			fastLink: fastLink,
			callBack: dojo.hitch(this, this._handleLinkCreated)
		});
		
		if(fastLink) {
			dialog.doFastLink();
			this._resultSetGridView.clearSelection();
		} else {
			dialog.show();	
		}
	},
	
	_encodeDragInternal: function(type) {
		var selection = this._resultSetGridView.grid.getSelectedRows();

		var dragURIs = [],
			dragTypeURIs = [],
			currentConfiguration = VvcUtils.getCurrentConfigurationUri();
		
		dragURIs = dojo.map(selection, function(n) { 
			return n.uri; 
		});
		if (type === DragTypes.RRC_MODULE) {
			this.moduleStructure.arraySortOnBookorder(dragURIs);
			dojo.forEach(dragURIs, function(uri) {
				// for each resource URI, add a matching type URI
				var recordInfo = this._resultSetGridView.getRecordInfo(uri);
				if (recordInfo) {
					dragTypeURIs.push(this._getArtifactTypeURI(recordInfo));
				}
			}, this);
			// TODO: 86965, add configuration
			return JSON.stringify({
				"dragURIs": dragURIs,
				"dragTypeURIs": dragTypeURIs,
				"moduleUri": this.moduleStructure.moduleURI,
				"projectURI": this.projectURI,
				"configurationURI": currentConfiguration,
				"window": com.ibm.rdm.web.windowID
			});
		} else if (type === DragTypes.RRC_ARTIFACT) {
			dojo.forEach(dragURIs, function(uri) {
				// for each resource URI, add a matching type URI
				var recordInfo = this._resultSetGridView.getRecordInfo(uri);
				if (recordInfo) {
					dragTypeURIs.push(this._getArtifactTypeURI(recordInfo));
				}
			}, this);
			return JSON.stringify({
				"dragURIs": dragURIs,
				"dragTypeURIs": dragTypeURIs,
				"projectURI": this.projectURI,
				"configurationURI": currentConfiguration,
				"window": com.ibm.rdm.web.windowID
			});
		} else if (type === DragTypes.HTML) {
			var asHTML = "";
			dojo.forEach(dragURIs, function(uri) {
				var recordInfo = this._resultSetGridView.getRecordInfo(uri);
				asHTML += "<a href='"+uri+"'>"+recordInfo.getID()+": "+recordInfo.getTitle()+"</a><br/>";
			}, this);
			return asHTML;
		} else if (type === DragTypes.TEXT_PLAIN) {
			// we need to do this to get it to allow drag between windows
			var asString = [];
			dojo.forEach(dragURIs, function(uri) {
				var recordInfo = this._resultSetGridView.getRecordInfo(uri);
				if (recordInfo) {
					asString.push(recordInfo.getID()+": "+recordInfo.getTitle());
				}
			}, this);
			return asString.join(", ");
		} else if(type === DragTypes.URI_LIST) {
			var asUriList = [];
			dojo.forEach(dragURIs, function(uri) {
				var recordInfo = this._resultSetGridView.getRecordInfo(uri);
				if (recordInfo) {
					asUriList.push(recordInfo.getResourceURI());
				}
			}, this);
			return (dojo.isFF) ? asUriList.join("\r\n") : asUriList[0];
		}
	},
	
	_getDragImage: function() {	
		var isModule = (this.viewType === DashboardConstants.VIEW_TYPES.MODULE);
		
		var selection = this._resultSetGridView.grid.getSelectedRows();
		var div = dojo.create("div",{
				"class": "dragClone"
			}),
			dragURIs = [];
		
		dragURIs = dojo.map(selection, function(n) { 
			return n.uri; 
		});
		
		var urisToClone = [];
		if(!isModule) {
			dojo.forEach(dragURIs, function(uri) {
				if (dojo.indexOf(urisToClone, uri) === -1) {
					urisToClone.push(uri);
				}
			}, this);
		} else {
			this.moduleStructure.arraySortOnBookorder(dragURIs);
			dojo.forEach(dragURIs, function(uri) {
				if (dojo.indexOf(urisToClone, uri) === -1) {
					urisToClone.push(uri);
				}
				var entry = this.moduleStructure.getArtifactByURI(uri);
					dojo.forEach(this.moduleStructure.getDescendants(entry), function(e) {
						urisToClone.push(e.uri);
					});
			}, this);
		}
		
		var cloned = 0;
		dojo.forEach(urisToClone, dojo.hitch(this, function(uri) {
			if (cloned < 4) {
				var node = (dojo.query("[objectid='"+uri+"']")[0]),
					clone = node && node.cloneNode(true);
	
				if (clone) {
					div.appendChild(clone);
					cloned++;
				} 
			}
	
		}));
		
		if (urisToClone.length > 1) {
			dojo.create("div", {
				"class": "artifactCount",
				innerHTML: dojo.string.substitute(this._messages.artifacts, [urisToClone.length])
			}, div);
		}
		
		if(!isModule) {
			// Remove everything but id and name column
			dojo.query('td[role="gridcell"]', div).forEach(function(node){
				var colid = node.getAttribute("colid");
				if(!(colid === "id-col" || colid === "name")) {
					dojo.destroy(node);
				}
			});
		}
		
		// useful for debugging
		//document.body.appendChild(div.cloneNode(true));
		
		return div;
	},
	
	_onDragStart: function() {
		// A bug in Chrome means that when manipulating the DOM from a dragStart event
		// the dragEnd event is fired immediately. We can get around this easily by 
		// doing the DOM manipulation from within a timeout function. See defect 100882.
		var that=this;
		setTimeout(function(){
			dojo.addClass(that._resultSetGridView.domNode, "dragging");
		},10);	
	},
	
	_onDragEnd: function() {
		dojo.removeClass(this._resultSetGridView.domNode, ["dragging", "link-col-drag"]);
		dojo.query("td.link-active", this._resultSetGridView.domNode).removeClass("link-active");
	},

	_onCreateArtifactOfTypeAndHeadingnessInModule: function(
		objectType, headingType, where, relativeSiblingURI)
	{
		this._resizeComboButtonWidth();
		return this._resultSetGridView.commands.createStubArtifactOfTypeAndHeadingness(
			objectType,
			(headingType === headingTypes.Heading),
			where,
			relativeSiblingURI
		);
	},

	_onCreateOtherArtifactTypeInModule: function(/*String*/where, /*String?*/relativeSiblingURI) {
		// where: 
		//     One of the values found at the end of the ModuleStructure file
		//     (BELOW, BEFORE, AFTER or LAST).
		// relativeSiblingURI:
		//     This optional param _must_ be passed if 'where' is BELOW, BEFORE or
		//     AFTER (i.e. if 'where' is LAST you don't need to pass this param).

		var moduleContextURI = (
			relativeSiblingURI ?
			this.moduleStructure.findProperParentURI(relativeSiblingURI, where) :
			null
		);
		this._resizeComboButtonWidth();
		return this._createArtifact(
			{
				artifactFormat: RRMTypes.getArtifactFormats(this.projectURI).Text,
				isMoreOption: true,
				where: where,
				relativeSiblingURI: relativeSiblingURI,
				moduleContextURI: moduleContextURI
			},
			true // doNotCreateUsingOneClickCreate
		);
	},

	_onUploadArtifactToModule: function(where, relativeSiblingURI) {
		this._resizeComboButtonWidth();
		return this._uploadArtifact(null, where, relativeSiblingURI);
	},
	
	_onAddExistingArtifactToModule: function(where, relativeSiblingURI) {
		this._resizeComboButtonWidth();
		var rowIds = {};
		if (relativeSiblingURI) {
			rowIds[relativeSiblingURI] = ArtifactConstants.RESOURCE_ROW;
		}
		return this._resultSetGridView.commands.executeAddExisting(rowIds, where);
	},

	_isNullOrEmptyArray: function(value) {
		return !value || value.length === 0;
	},

	_isUsingDefaultGridSettings: function() {
		// summary:
		//		Return true if and only if the associated result set area is currently
		//		making use of default settings (i.e. NO user customizations).
		// description:
		//		In the case of a module the settings will be considered different in the
		//		following cases:
		//		- The user has selected a sort column
		//		- The user has added, removed, or re-ordered columns
		//		- The user has changed 1 or more column widths
		//		- The user has changed the depth to display
		//		For other views (Artifacts, Collections, Modules or a particular 
		//		collection) the settings will be considered different in the
		//		following cases:
		//		- The user has selected a sort column
		//		- The user has added, removed, or re-ordered columns
		//		- The user has changed 1 or more column widths
		//		- The user has selected a "Group By" value
		//		- The user has enabled "Show Links as Tree View"

		var areColumnsTheSame = function(col1, col2) {
			return (
				col1.colType === col2.colType &&
				col1.colURI === col2.colURI &&
				col1.width == col2.width // Note: We must use "==" for that (one is a number and the other a string)
			);
		};
		var isDefaultModuleOrderBy = dojo.hitch(this, function(orderBy){
			return (
				orderBy && orderBy.length === 1
				&& orderBy[0].def === RRMTypes.WELL_KNOWN_SAME_AS_ATTRIBUTE_NAMES.BookOrder
				&& orderBy[0].order === "a"
				&& orderBy[0].type === "s"
			);
		});
		var isCustomOrderBySpecified = dojo.hitch(this, function(/*Boolean?*/isModule){
			// Note: For modules, there's a built in sorting based on book order so we
			// return true if and only if that's the currently specified sorting order.
			// For other cases (Artifacts, Collections, Modules or a particular 
			// collection) if the user has specified a particular sort column or "Group By"
			// a call to the _resultSetGridView's getOrderByAttributes() will return non-null.
			var orderBy = this._resultSetGridView.getOrderByAttributes();
			return (
				isModule ?
				!isDefaultModuleOrderBy(orderBy) :
				!this._isNullOrEmptyArray(orderBy)
			);
		});

		var gridConfiguration = this._resultSetGridView.getCurrentConfiguration(true),
			defaultColumns = this._defaultConfiguration.columns,
			currentColumns = gridConfiguration.columns,
			i;

		if (defaultColumns.length !== currentColumns.length) {
			return false;
		} else {
			for (i = 0; i < defaultColumns.length; i++) {
				if (!areColumnsTheSame(defaultColumns[i], currentColumns[i])) {
					return false;
				}
			}
			if (this.viewType === DashboardConstants.VIEW_TYPES.MODULE) {
				if (isCustomOrderBySpecified(true)
					|| gridConfiguration.hierarchyLevel)
				{
					return false;
				}
			}
			else if (
				isCustomOrderBySpecified()
				|| gridConfiguration.expansionLevel
				|| !this._isNullOrEmptyArray(gridConfiguration.displayedLinks)
				|| !this._isNullOrEmptyArray(gridConfiguration.expansionRules)
				)
			{
				return false;
			}
			return true;
		}
	}
});


// TODO Turn this into a separate class, perhaps GridAreaComboButton,
// and have that class make use of a custom dropDown (much like
// we're currently making use of a ModuleComboButton that uses
// a PreferredTypesMenu as its dropDown).
dojo.declare(
	"com.ibm.rdm.web.project._DashboardTabPageComboButton",
	com.ibm.rdm.web.common.ComboButton,
{
	isCollection: false,
	messages: null,

	// dropDownValues: Array
	//		Array of objects with: { href or callback, id, label, iconUrl }.
	dropDownValues: null,

	isOneClickCreate: false,
	isObjectTypeIcon: false,

	_iconOverlay: null,

	postCreate: function() {
		this.inherited(arguments);
		this._showOneClickCreateOverlayIfAppropriate();
	},

	onClick: function(event) {
		// summary:
		//		This is an override of a superclass method

		this.inherited("onClick", arguments);
	},

	openDropDown: function(event) {
		// summary:
		//		This is an override of a superclass method (contributed by the
		//		the _HasDropDown mixin).

		this.inherited("openDropDown", arguments);
		this._focusDropDownTimer = this.defer(
			function(){
				this.dropDown.focus();
				delete this._focusDropDownTimer;
			}
		);
	},

	loadDropDown: function(loadCallback) {
		// summary:
		//		This is an override of a superclass method (contributed by the
		//		the _HasDropDown mixin).

		this._createDrowDownMenuIfNeeded();
		loadCallback();
	},

	_createDrowDownMenuIfNeeded: function() {
		if (!this.dropDown) {
			var menu = new jazz.ui.Menu();
			this.dropDown = menu;
			var dropDownValues = this.dropDownValues;
			if (dropDownValues && dropDownValues.length > 0) {
				this._populateMenuItemsUsingDropDownValues(dropDownValues);
			} else {
				this._populateMenuWithNoArtifactTypesDefinedMenuItem();
			}
		}
	},

	_populateMenuWithNoArtifactTypesDefinedMenuItem: function() {
		var label = this.messages.noArtifactTypesDefined;
		this.dropDown.addChild(
			new com.ibm.rdm.web.project._DashboardTabPageCollectionMenuSeparator({
				label: label,
				avoidShowingWithTopSeparator: true
			})
		);
	},

	_populateMenuItemsUsingDropDownValues: function(dropDownValues) {
		var menu = this.dropDown;
		for (var i = 0; i < dropDownValues.length; i++) {
			if (dropDownValues[i].callback) {
				var id = dropDownValues[i].id;
				var item = new dijit.MenuItem({
					label: dropDownValues[i].label,
					onClick: function(event){
						this.dropDownValue.callback(event, this.dropDownValue);
					},
					dropDownValue: dropDownValues[i]
				});
			} else {
				var item = new dijit.MenuItem({label: dropDownValues[i].label, onClick: function() {location.href = this.url;}});
				item.url = this.dropDownValues[i].url;
			}
			
			// Add menu separator
			var importMenuLabel = this.messages["import"];
			var uploadMenuLabel = this.messages["uploadArtifact"];
			if (!this.isModule) {
				if (item.label == importMenuLabel) {
					menu.addChild(new dijit.MenuSeparator());
				}
			}
			else {
				if (item.label == uploadMenuLabel) {
					menu.addChild(new dijit.MenuSeparator());
				}
			}
			
			menu.addChild(item);
			if (dropDownValues[i].iconUrl) {
				item.set("iconClass", ""); //HACK to keep iconUrl working even though MenuItem doesn't support it
				item.iconNode.src = dropDownValues[i].iconUrl;
			}
			
			// This check was added to allow the use of sprites in the jazz.ui.Button
			if (dropDownValues[i].iconClass) {
				item.set("iconClass", dropDownValues[i].iconClass);
			}
			this.dropDownValues[i].menuItem = item;
		}
		if (this.isCollection) {
			menu.addChild(
				new com.ibm.rdm.web.project._DashboardTabPageCollectionMenuSeparator({
					label: this.messages.createAndAddAnArtifact
				}),
				1
			);
		}
	},

	_setDropDownValuesAttr: function(dropDownValues) {
		this.dropDownValues = dropDownValues;
		if (this.dropDown) {
			this.dropDown.destroyRecursive();
			this.dropDown = null;
		}
	},

	_setIsOneClickCreateAttr: function(value) {
		this.isOneClickCreate = value;
		this._showOneClickCreateOverlayIfAppropriate();
	},

	_setIsObjectTypeIconAttr: function(value) {
		this.isObjectTypeIcon = value;
		this._showOneClickCreateOverlayIfAppropriate();
	},

	_showOneClickCreateOverlayIfAppropriate: function() {
		if (this.isOneClickCreate && this.isObjectTypeIcon) {
			dojo.style(this.iconNode, "position", "relative");
			var moduleURL = dojo.moduleUrl("com.ibm.rdm.web", "common/images/quick_create_ovr.gif");
			if (!this._iconOverlay) {
				this._iconOverlay = dojo.create(
					"img",
					{
						src: moduleURL.toString(),
						className: "oneClickCreateOverlay"
					},
					this.iconNode,
					0
				);
			} else {
				dojo.style(this._iconOverlay, "display", "");
			}
		} else {
			if (this._iconOverlay) {
				dojo.style(this._iconOverlay, "display", "none");
			}
		}
	}
});


// TODO Rename this class when we do stuff related to the TODO for the above
// _DashboardTabPageComboButton class

// A simple subclass of dijit.MenuSeparator that provides a span to add
// a label in addition to the separator.
dojo.declare("com.ibm.rdm.web.project._DashboardTabPageCollectionMenuSeparator", 
		dijit.MenuSeparator,
{
	templateString: null, //To un-inherit from dijit Menu
	templatePath: dojo.moduleUrl("com.ibm.rdm.web", "project/templates/DashboardTabPageCollectionMenuSeparator.html"),

	label: null,
	avoidShowingWithTopSeparator: false,

	postCreate: function() {
		if (this.label) {
			this.separatorLabel.innerHTML = this.label;
		}
		if (this.avoidShowingWithTopSeparator) {
			dojo.addClass(this.domNode, "avoidShowingWithTopSeparator");
		}
	}
});


})();
