/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2012, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.explorer.web.explorer.page.SearchResults'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.explorer.web.explorer.page', 'SearchResultsMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.common.web.ui.picker", "ProductPickerMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.capability"); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util'); //$NON-NLS-1$
dojo.require('jazz.ui.StyledTable'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StyledHeader'); //$NON-NLS-1$
//dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.HoverToolbar'); //$NON-NLS-1$
//dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.table.HoverRow'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.MenuButton'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.formatting'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.picker.FilterList'); //$NON-NLS-1$
dojo.require('jazz.ui.FilterBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.HiddenResultsMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.PaginationControl_Fuzzy'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ResourceLinkBatchLoader'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ResourceLinkScrollLoader'); //$NON-NLS-1$
dojo.require('relm.app.ui.internal.application.advanced.AdvancedSettings'); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.ConfigurationUIUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.common.web.ui.ConfigurationContext"); //$NON-NLS-1$

(function(){

	function shallowEqual(left, right) {
		for (var p in left) {
			if (left[p] !== right[p]) return false;
		}

		for (p in right) {
			if (left[p] !== right[p]) return false;
		}

		return true;
	}

	// hint to dojo.parser that this attribute is a string
	jazz.ui.PaginationControl.prototype.name = ''; //$NON-NLS-1$

	var DEFAULT_ICON = dojo.moduleUrl('com.ibm.relm.common.web', 'ui/images/document.gif'); //$NON-NLS-1$ //$NON-NLS-2$
	var FILTERED_TYPES_COOKIE = 'relm-picker-filtered-types'; //$NON-NLS-1$

	var PAGE_SIZE_INDEX_KEY = 'relm.searchResults.pageSizeIndex'; //$NON-NLS-1$

//	var productapi = com.ibm.relm.ple.web.ui.productapi;
	var formatting = com.ibm.relm.common.web.ui.formatting;
//	var Goto = com.ibm.relm.ple.web.ui.Goto;

	// Start out as a flag saying this hasn't bee loaded yet.
	var AnalysisUtil = false;

	if (com.ibm.relm.common.web.capability.isAvailable("analysis")) { //$NON-NLS-1$
		jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
			// Replace the flag with the actual object once loaded.
			AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
		});
	}
	
	function startImpactAnalysis(item, event) {
		dojo.stopEvent(event);
		if (!AnalysisUtil) return;
		AnalysisUtil.createAnalysisForResource(getUriForAnalysis(item));
	}

	function getAnalysisUri(item) {
		if (!AnalysisUtil) return null;
		return AnalysisUtil.getNewAnalysisUri(getUriForAnalysis(item));
	}

	function getUriForAnalysis(item) {
		return item.conceptUri || item.uri;
	}

	function showProperties(item, ev) {
		var uri = 
			"#action=com.ibm.relm.explorer.web.showExplorer&resourceUri=" + //$NON-NLS-1$
			encodeURIComponent(item.conceptUri || item.uri);
		var context = com.ibm.relm.common.web.ui.ConfigurationContext.getGlobalConfigurationContext();
		if (context && context.configuration) {
			uri += "&configurationUri=" + encodeURIComponent(context.configuration); //$NON-NLS-1$
		}

		if(ev && ev.ctrlKey){
			window.open(uri);
		} else {
			window.location.href = uri;
		}
	}

	function findUse(item) {
		if (item.artifactType == 'Product' || item.type === 'product' || item.type === 'configVersion') { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			Goto.gotoFindUse(item.uri);
		}
		else {
			Goto.gotoFindArtifactUse(item.uri);
		}
	}

	/**
	 * Convenience method to check for multiple pages on PaginationControl.
	 * RELM specific to avoid name conflicts.
	 * @return {Boolean} true if there are multiple pages and Next or Prev is
	 *     enabled.
	 */
	jazz.ui.PaginationControl.prototype.hasMultiplePages_relm = function() {
		var multiple = this.get('total') >= this._getPageSize(); //$NON-NLS-1$
		return multiple;
	};

	dojo.declare(
		'com.ibm.relm.explorer.web.explorer.page.SearchResults', //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.explorer.web','explorer/page/templates/SearchResults.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: true,
			messages: dojo.i18n.getLocalization('com.ibm.relm.explorer.web.explorer.page', 'SearchResultsMessages'), //$NON-NLS-1$ //$NON-NLS-2$
			productPickerMessages: dojo.i18n.getLocalization('com.ibm.relm.common.web.ui.picker', 'ProductPickerMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			pageNumber: 1,

			constructor: function(args, node)
			{
				this._rowWidgets = [];
				this._productLinkHandles = [];
				var batchLoader = new com.ibm.relm.common.web.ResourceLinkBatchLoader();
				this._scrollLoader = new com.ibm.relm.common.web.ResourceLinkScrollLoader(batchLoader);
				this.timestamp = new Date().getTime();
			},

			/**
			 * Shows all filtered results. Clears the filter box.
			 */
			showAll: function() {
				this._filterBox.clear();
			},

			filterNow: function() {
				var searchString = this._filterBox.get('value'); //$NON-NLS-1$
				this.filterResults(searchString);
				this._scrollLoader.positionsDidChange();
			},

			filterResults: function(searchString) {
				var terms = null;
				if (searchString) {
					searchString = dojo.trim(searchString).toLowerCase();
					terms = searchString.split(/\s+/);
				}

				var hiddenCount = 0;
				var rows = this._resultsTbody.rows;

				for (var i = 0; i < rows.length; i++) {
					var row = rows[i];

					if (!searchString) {
						row.style.display = ''; //$NON-NLS-1$
						continue;
					}

					var textContent = row.textContent.toLowerCase();

					var matches = dojo.every(terms, function(term) {
						return textContent.search(term) !== -1;
					});

					if (matches) {
						row.style.display = ''; //$NON-NLS-1$
					}
					else {
						row.style.display = 'none'; //$NON-NLS-1$
						hiddenCount += 1;
					}
				}

				this._hiddenResultsMessage.setHiddenCount(hiddenCount);
				this.parentPage.onSubpageSizeChange();
			},

			toggleResultsArea: function(show) {
				if (show) {
					this._resultsArea.style.display = ''; //$NON-NLS-1$
				}
				else {
					this._resultsArea.style.display = 'none'; //$NON-NLS-1$
				}
			},

			willDoSearch: function() {
				dojo.empty(this._resultsTbody);
				this._destroyInRowWidgets();
				this._loadingMessage.show();
				this._hiddenResultsMessage.hide();
				this._filterList.set('enabled', false); //$NON-NLS-1$
				this._pager2.domNode.style.visibility = 'hidden'; //$NON-NLS-1$

				this.toggleResultsArea(true);
				this._scrollLoader.stopAndReset();
			},

			clearResults: function(showEmptyResults) {
				this.toggleResultsArea(showEmptyResults);
				this._filterList.set('enabled', true); //$NON-NLS-1$
				dojo.forEach([this._pager, this._pager2], function(pager) {
					pager.setEnabled(false);
					pager.setTotal(0);
					pager.domNode.style.visibility = 'hidden'; //$NON-NLS-1$
				}, this);

				dojo.empty(this._resultsTbody);
				this._destroyInRowWidgets();
				this._loadingMessage.showPlaceholder();

				this.parentPage.onSubpageSizeChange();
				this._scrollLoader.stopAndReset();
			},

			doSearch: function(searchString, fromPager) {
				if (!fromPager) this.pageNumber = 1;

				var scope = this._scopeMenu.get('currentScope'); //$NON-NLS-1$

				this.doArtifactSearch(searchString, fromPager);
			},

			doLoadTypes: function(searchString) {
				this._loadTypesXhr && this._loadTypesXhr.cancel();

				var filteredTypes = this._filterList.mergeCurrentAndSavedFilters();

				var self = this;

				this._filterList.toggleUpdating(true);

				this._loadTypesXhr = jazz.client.xhrGet({
					handleAs: 'json', //$NON-NLS-1$
					url: net.jazz.ajax._contextRoot + '/ple/lqe_full_text_search', //$NON-NLS-1$
					content: {
						q: searchString,
						typesOnly: true,
						pageNumber: this.pageNumber,
						filteredTypes: dojo.toJson(filteredTypes),
						filterProducts: this.filterProducts,
						timestamp: this.timestamp
					},

					handle: function() {
						self._filterList.toggleUpdating(false);
						self._filterList.set('enabled', true); //$NON-NLS-1$
					},

					load: function(response) {
						var allTypes = (response && response[""]) || []; //$NON-NLS-1$
						self._filterList.updateTokens(allTypes);
					},

					error: function(error, ioArgs) {
						console.error(error, ioArgs);
					}
				});
			},

			/**
			 * Runs an artifact search in LQE.
			 * 
			 * @param  {string} searchString free text search string.
			 * @param  {PaginationControl} fromPager indicates if this is a
			 *         page change or not. Not if this is null. If non-null,
			 *         this is the pager that was used to change pages and can
			 *         be used to find the current page.
			 */
			doArtifactSearch: function(searchString, fromPager) {
				this._pager.relm_toggleFuzzyPresentation(true);
				this._pager2.relm_toggleFuzzyPresentation(true);

				var self = this;

				// Restore saved filter if there are any. We won't show them
				// until after the search run, but the will still affect the results.
				// We do not want to show filter for types that aren't found
				// by the search, so we'll only show the bar after the search runs.
				var filteredTypes = this._filterList.mergeCurrentAndSavedFilters();

				// persist this for the next time the dialog shows
				window.localStorage[FILTERED_TYPES_COOKIE] =dojo.toJson(filteredTypes);

				var deferred = new dojo.Deferred();

				if (this._esarchXhr){
					this._searchXhr.cancel();
				}

				if (!fromPager && this._loadTypesXhr) {
					this._loadTypesXhr.cancel();
					this._filterList.clearTokens();
					this.timestamp = new Date().getTime();
				}

				self._pager.setEnabled(false);
				self._pager2.setEnabled(false);

				this._searchXhr = jazz.client.xhrGet({
					handleAs: 'json', //$NON-NLS-1$
					url: net.jazz.ajax._contextRoot + '/ple/lqe_full_text_search', //$NON-NLS-1$
					content: {
						q: searchString,
						pageSize: this._getSelectedPageSize(),
						pageNumber: this.pageNumber,
						filteredTypes: dojo.toJson(filteredTypes),
						filterProducts: this.filterProducts,
						decorateProductTitles: true,
						timestamp: this.timestamp
					},

					load: function(result) {
						var hits = result.hits;

						self._pager.setEnabled(true);
						self._pager2.setEnabled(true);

						if (result.totalCount && !fromPager) {
							self._pager.startPage = 0;
							self._pager2.startPage = 0;
							self._pager.setTotal(result.totalCount, result.isFuzzyTotal);
							self._pager2.setTotal(result.totalCount, result.isFuzzyTotal);
						}

						if (fromPager) {
							var startPageOffset = Math.floor(fromPager._start / fromPager._getPageSize());
							self._pager.startPage = startPageOffset;
							self._pager2.startPage = startPageOffset;
							self._pager.setTotal(result.totalCount, result.isFuzzyTotal);
							self._pager2.setTotal(result.totalCount, result.isFuzzyTotal);
							self._filterList.set('enabled', true); //$NON-NLS-1$
						}
						else {
							self._showFilters(result.types);
							self.doLoadTypes(searchString);
						}

						self._pager.domNode.style.visibility = 'visible'; //$NON-NLS-1$
						self._pager2.domNode.style.visibility = 'visible'; //$NON-NLS-1$
						self.showResults(hits);
					},

					error: function(error, ioArgs) {
						self._pager.setEnabled(false);
						self._pager2.setEnabled(false);

						// This test is needed since an xhr cancel calls the error callback.
						if (!ioArgs.xhr.responseText) { return; }
						if (error.dojoType === 'cancel') { return; } //$NON-NLS-1$

						self.messageBox.hide();
						self.clearResults(true);
						self.messageBox.showXhrError(ioArgs.xhr);
					}
				});

				return deferred;
			},

			showResults: function(hits) {
				this._loadingMessage.hide();
				this.messageBox.hide();

				if (hits.length === 0) {
					this.clearResults(true);
					return;
				}

				dojo.empty(this._resultsTbody);
				var frag = document.createDocumentFragment();

				for (var i = 0; i < hits.length; i++) {
					var item = hits[i];
					var row = this.newHoverRowForItem(item);
					dojo.place(row.domNode, frag);
				}

				this._resultsTbody.appendChild(frag);
				this._scrollLoader.start();

				this.filterNow();

				this.parentPage.onSubpageSizeChange();
			},

			/**
			 * Creates a new toolbar for items shown on the RELM Welcome page.
			 * A hover toolbar for each search results row. Aimed at artifact
			 * actions, but there are some overrides for product specific behavior.
			 *
			 * @param  {object} item item object for the artifact.
			 * @return {jazz.ui.Toolbar}      new toolbar. Must be destroyed by caller.
			 */
			_initToolbarForItem: function(toolbar, item) {
				if (com.ibm.relm.common.web.capability.isAvailable("product")) { //$NON-NLS-1$
					toolbar.addChild(new jazz.ui.toolbar.Button({
						imgClass: 'ple-icon-findUse', //$NON-NLS-1$
						title: this.messages.findUseTooltip,
						onClick: dojo.partial(findUse, item)
					}));
				}
				if (com.ibm.relm.common.web.capability.isAvailable("analysis")) { //$NON-NLS-1$
					toolbar.addChild(new jazz.ui.toolbar.Button({
						imgClass: 'ple-icon-impactAnalysis', //$NON-NLS-1$
						title: this.messages.startAnalysisTooltip,
						href: getAnalysisUri(item),
						onClick: dojo.partial(startImpactAnalysis, item)
					}));
				}
				toolbar.addChild(new jazz.ui.toolbar.Button({
					imgClass: 'ple-icon-properties', //$NON-NLS-1$
					title: this.messages.showProperties,
					onClick: dojo.partial(showProperties, item)
				}));
			},

			_showFilters: function(types)
			{
				this._filterList.clearTokens();

				for (var i = 0; i < types.length; i++)
				{
					var type = types[i];
					this._filterList.addToken(type.label, type.value, type.iconSrc, type.enabled);
				}
			},

			_initScopes: function() {
				dojo.addClass(this._scopeMenu.domNode, 'relm-SearchResults-searchBarScopes'); //$NON-NLS-1$

				var scopes =[
					{
						id: 'all', //$NON-NLS-1$
						title: this.messages.allArtifactsScopeTitle,
						label: this.messages.allArtifactsScope,
						imgClass: 'relm-SearchResults-artifactsScope', //$NON-NLS-1$
						groupName: this.messages.indexScopeGroup
					}
				];

				if (this._showProducts) {
					var productsScope = {
						id: 'newestProductsAndConfigurations', //$NON-NLS-1$
						title: this.messages.productsScopeTitle,
						label: this.messages.productsScope,
						imgClass: 'ple-icon-product', //$NON-NLS-1$
						groupName: this.messages.productsScopeGroup
					};
					scopes.push(productsScope);
				}

				this.parentPage.toggleSidebar(true);
				this._scopeMenu.set('scopes', scopes); //$NON-NLS-1$
				this._scopeMenu.set('currentScope', scopes[0]); //$NON-NLS-1$
				this._updateHint();

				var self = this;
				this._scopeMenu.watch('currentScope', function(name, oldValue, newValue) { //$NON-NLS-1$
					var isSearchingProducts = newValue.id !== 'all'; //$NON-NLS-1$

					self.parentPage.toggleSidebar(!isSearchingProducts);
					self._advancedOptionsNode.style.display = isSearchingProducts ? '' : 'none'; //$NON-NLS-1$ //$NON-NLS-2$

					self._updateHint();
					self._liveSearchBox._searchBox.placeholder = newValue.label;
					self._liveSearchBox.select();
					self._liveSearchBox.runSearch();
				});
			},

			_onClickNewestCheckbox: function(e) {
				this._liveSearchBox.runSearch();
			},

			_updateHint: function() {
				var scopeLabel = this._scopeMenu.get('currentScope').label; //$NON-NLS-1$
				var hint = dojo.replace(this.messages.currentScopeXHint, [scopeLabel]);
				this._hintNode.innerHTML = hint;
				dojo.attr(this._liveSearchBox._searchBox,'aria-label', this._scopeMenu.get('currentScope').title); //$NON-NLS-1$ //$NON-NLS-2$
			},

			_getSavedPageSizeIndex: function() {
				var index = window.localStorage[PAGE_SIZE_INDEX_KEY];

				// default to second choice (25 items)
				if (isNaN(index)) return 0;

				return parseInt(index, 10);
			},

			postCreate: function() {
				this.inherited(arguments);

				this._loadingMessage.showPlaceholder();
				this._liveSearchBox.delegate = this;

				this._pageSizeSelect.selectedIndex = this._getSavedPageSizeIndex();

				// This should be loaded by now, since RELMApplication must have started.
				this._showProducts = relm.app.ui.internal.application.advanced.AdvancedSettings.enable_products;

				dojo.toggleClass(this._searchBar, 'relm-SearchResults-searchBar-hideScopes', !this._showProducts); //$NON-NLS-1$

				this._scopeMenu.titleNode.setAttribute('aria-label', this.messages.scopeMenuAriaTitle); //$NON-NLS-1$

				// Hide pager until there are some results for a clean appearance on load
				dojo.forEach([this._pager, this._pager2], function(pager) {
					pager.domNode.style.visibility = 'hidden'; //$NON-NLS-1$
					pager.setEnabled(false);
					pager.set('increment', this._getSelectedPageSize()); //$NON-NLS-1$
					pager.onNextClick = dojo.hitch(this, this.changePage);
					pager.onPreviousClick = dojo.hitch(this, this.changePage);

					com.ibm.relm.common.web.PaginationControl_Fuzzy.decorate(pager);
				}, this);

				this._initScopes();

				this._filterList = new com.ibm.relm.common.web.ui.picker.FilterList({
					filteredTypesCookieName: FILTERED_TYPES_COOKIE
				});
				dojo.addClass(this._filterList.domNode, 'ple-FilterList-bordered'); //$NON-NLS-1$
				dojo.addClass(this._filterList.domNode, 'ple-FilterList-borderedInSidebar'); //$NON-NLS-1$

				this.sidebarWidget = this._filterList;

				this.connect(this._filterList, 'onChange', function() { //$NON-NLS-1$
					this._liveSearchBox.runSearch();
				});

				this.connect(this._hiddenResultsMessage, 'shouldShowAll', this.showAll); //$NON-NLS-1$
			},

			_onChangePageSize: function(e) {
				var pageSize = this._getSelectedPageSize();
				this._pager.set('increment', pageSize); //$NON-NLS-1$
				this._pager2.set('increment', pageSize); //$NON-NLS-1$
				window.localStorage[PAGE_SIZE_INDEX_KEY] = this._pageSizeSelect.selectedIndex;
				this._liveSearchBox.runSearch();
			},

			_getSelectedPageSize: function() {
				var index = this._pageSizeSelect.selectedIndex;
				if (index === -1) return 25;

				var size = this._pageSizeSelect.options[index].value;
				return parseInt(size, 10);
			},

			changePage: function(pager, start, end) {
				this.pageNumber = Math.floor(start / pager._getPageSize()) + 1;

				this.willDoSearch();
				var fromPager = pager;
				this.doSearch(this._liveSearchBox.getSearchString(), fromPager);
			},

			handleJazzEvent: function(jazzEvent) {
				var sameEvent = this._lastEvent && shallowEqual(jazzEvent, this._lastEvent);
				this._lastEvent = dojo.mixin({}, jazzEvent);

				var optionalSearchString = jazzEvent.q;

				this._liveSearchBox.select(optionalSearchString);

				var newScope = jazzEvent.scope;

				if (newScope === 'newestProductsAndConfigurations') { //$NON-NLS-1$
					this._newestCheckbox.checked = true;
				}
				else if (newScope === 'allProductsAndConfigurations') { //$NON-NLS-1$
					newScope = 'newestProductsAndConfigurations'; //$NON-NLS-1$
					this._newestCheckbox.checked = false;
				}

				// This causes the search to run right away since we're watching for scope changes.
				if (!this._scopeMenu.selectScopeById(newScope)) {
					var scope = this._scopeMenu.get('currentScope'); //$NON-NLS-1$
					this.parentPage.toggleSidebar(scope.id === 'all'); //$NON-NLS-1$

					// if the scope was already selected, we won't get a .watch
					// callback. Force the search in that case.
					if (!sameEvent) this._liveSearchBox.runSearch();
				}
			},

			newHoverRowForItem: function(item) {
				var row = new com.ibm.relm.common.web.ui.table.HoverRow();
				this._rowWidgets.push(row);

				var td = dojo.create('td'); //$NON-NLS-1$
				row.addCell(td);

				if (item.type === 'product' || item.type === 'configVersion') { //$NON-NLS-1$ //$NON-NLS-2$
					var classAndAlt = formatting.getIconClassAndAltTextForItem(item);
					var iconNode = dojo.create('img', { //$NON-NLS-1$
						src: this._blankGif,
						className: classAndAlt[0],
						title: classAndAlt[1],
						alt: classAndAlt[1]
					}, td );
				}
				else {

					var iconUrl = item.iconUrl || DEFAULT_ICON;

					iconNode = dojo.create('img', { //$NON-NLS-1$
						src: iconUrl,
						className: 'ple-icon', //$NON-NLS-1$
						title: item.artifactType,
						alt: item.artifactType
					}, td );
				}

				// Must create any amount of space to ensure that inline items (the icon and the text)
				// get their natural amount of space between them.
				dojo.place(document.createTextNode(' '), td); //$NON-NLS-1$

				var title;

				if (item.text) {
					title = item.text;
				}
				else {
					title = formatting.formatProductTitleForItem(item);
				}

				// The .text is already HTML escaped, so safe to use as-is in innerHTML.
				// The "graph" is the item version URI for products (and other versioned resources).
				// This is generally what we want for, say, previews. But will return
				// odd things if we get the RDF directly for it (which IA gets).
				// Use .name for products.

				var context = com.ibm.relm.common.web.ui.ConfigurationContext.getGlobalConfigurationContext();
				var uri = com.ibm.relm.common.web.ui.ConfigurationUIUtils.getConfigurationResourceUri(item.conceptUri || item.uri, context ? context.configuration : null);
				var link = dojo.create('a', { //$NON-NLS-1$
					href: uri,
					innerHTML: title,
					target: 'relm_lqe_result' //$NON-NLS-1$
				}, td);

				if (item.isForProductTree || item.type === 'product' || item.type === 'configVersion') { //$NON-NLS-1$ //$NON-NLS-2$
					var handle = dojo.connect(link, 'onclick', function(e) { //$NON-NLS-1$
						dojo.stopEvent(e);
						productapi.findPathsToProductAndShow(item.uri);
					});

					this._productLinkHandles.push(handle);
				}

				var jazzLink = new jazz.ui.ResourceLink({
					lazyFetch: true,
					retainLinkText: false,
					iconNode: iconNode
				}, link);

				this._scrollLoader.watchResourceLink(jazzLink);

				jazzLink.connect(jazzLink, '_applyTitle', dojo.hitch(this, this._setNeedsFilterNow)); //$NON-NLS-1$

				this._rowWidgets.push(jazzLink);

				this._initToolbarForItem(row.toolbar, item);

				return row;
			},

			/**
			 * Queues up a refresh of the filter text results. This is needed
			 * if OSLC previews come in later and update the titles. We then
			 * need to re-run the filter. This won't filter yet, but will wait
			 * til the next run loop so that multiple calls in the same loop
			 * only cause one filter at the end.
			 */
			_setNeedsFilterNow: function() {
				clearTimeout(this._filterTimeout);

				var self = this;
				this._filterTimeout = setTimeout(function() {
					self.filterNow();
				}, 0);
			},

			_destroyInRowWidgets: function() {
				// any widgets in rows that need to be destroy to reload the table
				dojo.forEach(this._rowWidgets, function(link) {
					link.destroyRecursive();
				});
				this._rowWidgets = [];

				// special product event listeners
				dojo.forEach(this._productLinkHandles, dojo.disconnect);
				this._productLinkHandles = [];
			},

			uninitialize: function() {
				this._destroyInRowWidgets();

				this.inherited(arguments);
			}
		}
	);

})();