/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2015. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteStepsTableView");
 
dojo.require("jazz.ui.MessageBox");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactContentProviderMixin");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestSuiteClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractExplorableTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.EditableProperty");

(function() {

var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     					= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var TestSuiteClient					= com.ibm.rqm.planning.web.client.internal.construction.TestSuiteClient;
var Constants      					= com.ibm.rqm.planning.web.client.internal.Constants;
var AbstractExplorableTableView 	= com.ibm.rqm.planning.web.ui.internal.view.table.AbstractExplorableTableView;
var EditableProperty        		= com.ibm.rqm.planning.web.ui.internal.view.table.EditableProperty;

dojo.declare("TestSuiteStepsTableView.TableProvider", 
		[com.ibm.asq.common.web.ui.internal.widgets.tableViewer.DefaultVirtualContentProvider,
         com.ibm.rqm.planning.web.ui.internal.view.table.ArtifactContentProviderMixin
         ],
{
	constructor: function(args) {
   	dojo.mixin(this, args);
		labelUnassigned: Constants.getMessage("labelUnassigned");
		labelLoading: Constants.getMessage("labelLoading");
		this.COLUMNS = {
			TESTCASE: this.toColumn(Constants.getMessage("labelTestCase"), this.insideSection ? 22 : 20, this.insideSection? false : true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'testCase', true),
			TESTSCRIPT: this.toColumn(Constants.getMessage("labelTestScript"), this.insideSection ? 25 : 22, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_ENUM, 'testScript', false),
			MACHINE: this.toColumn(Constants.getMessage("labelMachine"), 20, false, TableConstants.ALIGN_LEFT, EditableProperty.MACHINE, 'machine', false),
			TESTCELL: this.toColumn(Constants.getMessage("labelTestCell"), this.insideSection ? 13 : 10, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_TEXT, 'testCell', false),
			HEALTH: this.toColumn(Constants.getMessage("labelHealth"), this.insideSection ? 10 : 8, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, 'health', false),
			SKIPEXECUTION: this.toColumn(Constants.getMessage("lableSkipExecution"), 10, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, 'skipExecution',this.insideSection ? false : true)
		};
		this.PROFILES = {};
		this.PROFILES.ALL = [this.COLUMNS.TESTCASE,this.COLUMNS.TESTSCRIPT,this.COLUMNS.MACHINE,this.COLUMNS.TESTCELL,this.COLUMNS.HEALTH,this.COLUMNS.SKIPEXECUTION];
		this.PROFILES.INSEQUENCE = [this.COLUMNS.TESTCASE,this.COLUMNS.TESTSCRIPT,this.COLUMNS.MACHINE,this.COLUMNS.TESTCELL,this.COLUMNS.HEALTH];
		this.columnProfile = null;
  		this.columnProfileName = null;
		if(this.insideSection)
			this.setProfile("INSEQUENCE");
		else
			this.setProfile("ALL");
			    
	},
	
	toColumn: function(name, width, groupable, alignment, type, rowName, sortable) {
       return 	{
           name: name,
           width: width,
           groupable: groupable,
           alignment: alignment,
           type: type,
           rowName: rowName,
           isVisible: true,
           dbName: rowName,
           sortable: sortable
       };
	 	},
	 	
	getProfile: function() {
		return this.columnProfile;
	},

	getProfileName: function() {
		return this.columnProfileName;
	},
       
   setProfile: function(/* string */ profile) {
       if (this.PROFILES[profile]) {
           this.columnProfileName = profile;
           this.columnProfile = this.PROFILES[profile];
       }
   },
	
	getColumnIndex: function(name) {
       for (var i = 0; i < this.columnProfile.length; i++) {
           if (this.columnProfile[i].name == name) {
               return i;
           }
       }
       return -1;
   }, 
	
   getNumColumns: function(content){
       return this.columnProfile.length;
   },
   
   getColumnHeading: function(content, index){
       var column = this.columnProfile[index];
       return column.name;
   },
   
   getColumnHeadingImage: function(content, atColumnIndex){
	   var actionId = null;
	   switch(atColumnIndex) {
		   case 2:
			   actionId = Constants.getMessage("labelMachine");
			   break;
	   }
	   
	   if (actionId) {
           var img = {
               actionId: actionId,
               src: ImageCache.BULK_CHANGE,
               disabled: true
           };
           img.tooltip = Constants.getMessage("labelChangeProperties", actionId);
           return img;
       }
	   
	   return null;
   },
	
   getColumnHeadingAlignment: function(atColumnIndex){
      return this.columnProfile[atColumnIndex].alignment;
   },	
	 
   getIsColumnGroupable: function(content, atColumnIndex){
	   return this.columnProfile[atColumnIndex].groupable;   
   },
	
   getIsColumnSortable: function(content, atColumnIndex){
       var colInfo = this.columnProfile[atColumnIndex];
       return (colInfo.sortable != undefined) ? colInfo.sortable : true;
   },
	
   getIsColumnVisible: function(atColumnIndex){
	   return this.columnProfile[atColumnIndex].isVisible;
	},
	
   getColumnWidth: function(content, atColumnIndex){
     	var column = this.columnProfile[atColumnIndex];
       if (this.columnProfileName == "ALL") {
           return column.width;
       }
       //TODO - refactor into base class or create profile class
       //if using a smaller column profile, adjust widths
       var total = 0;
       for (var colName in this.columnProfile) {
           total += this.columnProfile[colName].width;
       }
       //split the difference between all columns proportionately
       var rowBuffer = 100 - total;   //percentage of width unused
       var columnBuffer = rowBuffer * (column.width / total);  //proportionately redistrubute
       return (column.width + Math.round(columnBuffer));    
   },
	
   getContentObjects: function(content){
       return content;
   },
   
	getRowDataId: function(rowData){
       return rowData.internalId+"";
   },
   
   getRowDataName: function(rowData){
		if(!rowData){
			return null;
		}
		
		var rowDataName = null;
		if(rowData.testCase){
			rowDataName = rowData.testCase.name;
		}	    	
		   return rowDataName;
   },
	
   getCellDisplayType: function(rowData, atColumnIndex){
	   var type = this.columnProfile[atColumnIndex].type;
	   var column = this.columnProfile[atColumnIndex];
	   var rowName = column.rowName;
	   if((rowName == "machine") && (!rowData.selectedScriptTypeId || 
				(rowData.selectedScriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual") ||
				(rowData.selectionCriteria == "runtime"))) {
		   type =  TableConstants.RENDER_TYPE_TEXT; 
	   }
	   
       return type;
   },

   getCellAlignment: function(rowData, atColumnIndex){
       return this.columnProfile[atColumnIndex].alignment;
   },

   getColumnIdName: function(index)
   {
       var column = this.getProfile()[index];
       return column.dbName;        
   },
   
   getCellDisplayData: function(rowData, atColumnIndex){
       var val = "";
       var column = this.columnProfile[atColumnIndex];
       var rowName = column.rowName;
       switch(rowName) {
       		case this.COLUMNS.TESTCASE.rowName: 
               val = rowData.testCase.name;//TestCase
               break;
			case this.COLUMNS.MACHINE.rowName:
				if (rowData.selectedScriptTypeId) {
					val = rowData.machine?rowData.machine.machineName:this.labelLoading;
				}else{
					val = Constants.getMessage("labelNotApplicable");
				}
				break;
			case this.COLUMNS.TESTCELL.rowName:
				if (rowData.selectedScriptTypeId) {
					val = rowData.machine?rowData.testCellName:this.labelLoading;
				}else{
					val = Constants.getMessage("labelNotApplicable");
				}
				break;
			case this.COLUMNS.SKIPEXECUTION.rowName:
				val = rowData.excludeStep ? Constants.getMessage("lableExcluded") : Constants.getMessage("lableIncluded");
				break;
       }
       return val;
   },

   getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
       var val = null;
       var column = this.columnProfile[atColumnIndex];
       var rowName = column.rowName;
       if (rowName == "testScript") {
			val = {};
			val.choices = [];
			var scripts = rowData.testCase.scripts;
			if (scripts && scripts.length > 0) {
				var len = scripts.length;
				for (var i = 0; i < len; i++) {
					if(scripts[i].archived)
						continue;
					val.choices.push({text: scripts[i].name, value: scripts[i].versionableItemId});
				}
			}
			val.choices.push({text: Constants.getMessage("labelNone"), value: "-1"});
			val.select = rowData.selectedScriptId;

		}else if((rowName == "machine") && rowData.selectedScriptTypeId && 
				(rowData.selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual")){
			var selectedConfigId = (rowData.configId && (rowData.configId != "global")) ? rowData.configId : this.tableViewer.getSuiteConfigId();
			var matvArgs = {
				rowNum: rowData.internalId,
				rowData: rowData,
				scriptType: rowData.selectedScriptTypeId,
				scriptVersionableItemId: rowData.selectedScriptId,
				lastSelectedAdapter:rowData.adapterId,
				configID: selectedConfigId
			};
			val = {
				matvArgs: matvArgs,
				dialogTitle: Constants.getMessage("labelChooseMachineForRun"),
				okCallback: this.tableViewer.matvOkCallback
			};
		
		}else if(rowName == "health"){
			val = {};
			if (rowData.selectedScriptTypeId) {
				val.image = rowData.adapterImg;
				val.tooltip = rowData.adapterStatus;
			}else{
				val.image = ImageCache.NOIMAGE;
			}
		}else if(rowName == "skipExecution"){
			val = {};
			if(rowData.excludeStep) {
				val.image = CommonImageCache.EXCLUDE_OBJ;
				val.tooltip = Constants.getMessage("lableExcluded");		
			}else {					
				val.image = ImageCache.NOIMAGE;
			}				
		}
		return val;
   }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteStepsTableView", 
		AbstractExplorableTableView,
{    
    editable: true,
    pageSize: TableConstants.MIN_PAGE_SIZE,
    
    constructor: function() {
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
        this.currentPageUnloadedSteps = [];
        this.pageFetchedData = {};
        this.cachedDataBasedOfItemIds = {};
        
        /**
         * cachedDataBasedOfItemIds
         * This will be a map of items based on the itemId of the steps eg.
         * {"_abskyu29dsm7" : stepObj, "_qxmuyr82m74_": stepObj1}
         */
	 },

    postCreate: function() {
        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
        this.skipUpdateOnQuerySelectionChanged = true;

        this.inherited("postCreate", arguments);

    	this._supportsArtifactSummary= false;
    	this._supportsComprehensive = false;
    	this._supportsHistory = false; 
    	this._supportsTableSummary =  false;
    	
        // we're showing query filters, we'll be managing our own
        // contents. Initialize the query filters first.
	        //setup search details
		this.setSearchFunction(dojo.hitch(TestSuiteClient, "getSuiteStepsPaged"));
        this.setSearchCallback(dojo.hitch(this, "refresh"));
        this.setResponseHandlerType(ServiceResponseHandler);

        if (!this.projectAreaItemId) {
        	this.projectAreaItemId = jazz.app.context.get().itemId;
        }
		this._initialize();
	},

	getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },

	_initialize: function() {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            autoSaveSettings: true,
            allowMultiSort: true,
            showViewModeControl: this.isQueryPage,
            handleVirtualSelectAll: true,            
            isInPicker: true,
            tableId: this.tableId? this.tableId : "RQM-SUITE-STEPS_DIALOG-TABLEVIEWER",
            cellRendererMap: EditableProperty.CELL_RENDERER_MAP
        });

        this.tableViewer = tableViewer;
        this._tableViewerNode.appendChild(tableViewer.domNode);
		tableViewer.showLoadingProgress();
		if (this.showQueryFilters)
			tableViewer.setContentFilterAttributeProvider(this.filterProvider);
        var content = this.results ? this.results : [];
		this.queryName = this.queryName ? this.queryName : Constants.getMessage("labelSuiteStepForDialog");
        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		  
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
		this.provider = this._constructTableContentProvider();	
        tableViewer.setContentProvider(this.provider);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		
		//add refresh action (use 'refreshQuery' api if showing filters)
        this.refreshCallback = this.showQueryFilters ? dojo.hitch(this, "refreshQuery") : this.refreshCallback;
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
			this.refreshActionNode = tableViewer.addAction("refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);    
        }
		tableViewer.setTableRowsCheckable(true, false);
        tableViewer.show();
        
		if(!this.showQueryFilters){
        	this.showInitLoadProgress = false;
			tableViewer.endLoadingProgress();
		}
		this.tableViewer = tableViewer;
		this.initRunQuery();
	},

    getTableViewer: function(){
    	return this.tableViewer;
    },
    
    getCurrentElements: function(){
    	return this.tableViewer.getContent();
    },
    
    getCachedElements: function(){
    	var cachedElements = [];
    	for(var key in this.cachedDataBasedOfItemIds){
    		cachedElements.push(this.cachedDataBasedOfItemIds[key]);
    	}
    	return cachedElements;
    },
    
    // Get element from the cache based on its internal id.
    getCachedElementForId: function(internalId) {
    	return this.cachedDataBasedOfItemIds ? this.cachedDataBasedOfItemIds["ui-item-"+internalId] : null;
    },
    
    // Update cached element list for given id
    updateCachedElementForId: function(internalId, element) {
    	if (!internalId) {
    		return;
    	}
    	this.cachedDataBasedOfItemIds["ui-item-"+internalId] = element;
    },
    
    // Add a forward reference for the element in the cache
    // The element is not loaded in the UI yet
    addForwardRefToCache: function(element) {
    	if(!element || !element.internalId || this.getCachedElementForId(element.internalId)) {
    		return;
    	}
    	if(element.scriptType)
	    	element.selectedScriptTypeId = element.scriptType;
    	element.forwardRef = true;
    	this.cachedDataBasedOfItemIds["ui-item-"+element.internalId] = element;
    },
    
    // Check if all the steps are skipped from the suite execution
    isAllStepsSkipped: function() {
    	var skippedStepsCnt = 0;
    	for(var key in this.cachedDataBasedOfItemIds){
    		if(this.cachedDataBasedOfItemIds[key].excludeStep)
    			skippedStepsCnt++;
    	}
    	
    	return (skippedStepsCnt == this.totalSize);
    },
    
    _constructTableContentProvider: function() {
        //create the table provider
        return new TestSuiteStepsTableView.TableProvider({
            tableViewer: this,
            isVirtual: this.contentIsVirtual,
            currentPageIndex: this.currentPage,
            totalPageCount: this.totalPages,
            totalContentCount: this.totalSize || -1,
            pageSize: this.pageSize || TableConstants.MIN_PAGE_SIZE,
            testSuiteId: this.testSuiteId,

            vcFetchVirtualPage: dojo.hitch(this, function(pageIndex, pageSize)
            {
                // the table provider can be recreated many times
                // we need to retain the current page size, page index, etc.
                // when it is recreated.
                if(pageSize != this.pageSize){
                	//if page size changes, clear off all the cached data
                	this.pageFetchedData = {};
                }
            	this.pageSize = pageSize;
                this.currentPage = pageIndex;
                this.runQuery(null, /*updatePageOnly*/ true);
            }),
            vcRunQuery: dojo.hitch(this, function(pageSize)
            {
                this.pageSize = pageSize;
                this.queryToken = null;
                this.runQuery(null, /*updatePageOnly*/ true);
            })
        });     
    },
	
    refresh: function(content, skipClearStatus) {
    	var cancelProgress = this.showInitLoadProgress;
        var unloadedSteps = [];
         // we don't create the table until we fetched the categories.
         // The table may not have existed at this point. The real data
         // has arrived. Always reset the init load progress flag. 
         if(this.showInitLoadProgress) {
             this.showInitLoadProgress = false;
         }
         if (this.tableViewer) {
            if(cancelProgress) {
                this.tableViewer.endLoadingProgress();
            }
			var elements = content; 
			var elementsLen = elements ? elements.length : 0;
			for(var i=0;i<elementsLen;i++){
				var ele = elements[i];
				if (!this.insideSection) {
					ele.excludeStep = false;
				}
				var cachedElement = this.cachedDataBasedOfItemIds["ui-item-"+ele.internalId];
				if(cachedElement){
					if(cachedElement.forwardRef) {
						delete cachedElement.forwardRef;
						for(var key in cachedElement) {
							ele[key] = cachedElement[key];
						}
						if(ele.testScript) {
							ele.selectedScriptId = ele.testScript.versionableItemId;
							ele.selectedScriptTypeId = ele.testScript.scriptTypeId?ele.testScript.scriptTypeId:ele.testScript.scriptType.id;
							ele.selectedScriptName = ele.testScript.name;
						}
						if(!ele.excludeStep) {
							ele.excludeStep = false;
						}
						elements[i] = ele;
						this.cachedDataBasedOfItemIds["ui-item-"+ele.internalId] = ele;
						if(!ele.adapterId) {
							unloadedSteps.push(ele);
						}
					}
					else {
						elements[i] = cachedElement;
					}
					//element information is already cached, so use that information from the uI and replace the info received from server
					continue;
				}else{
					unloadedSteps.push(ele);
				}
				if (!this.insideSection) {
					ele.excludeStep = false;
				}
				ele.selectedScriptId = -1;
				ele.selectedScriptTypeId = null;
				ele.selectedScriptName = null;
				ele.adapterId = "";
				ele.adapterImg = ImageCache.NOIMAGE;
				ele.adapterStatus = "";
				if(ele.testCase.scripts && ele.testCase.scripts.length != 0){
					//Searching the selected Test script's current state, if archived dont show.
					//remove any archived scripts and also check if the last selected script is available and if the default script is available
					var scriptsLen = ele.testCase.scripts.length;
					for(var k=0;k<scriptsLen;k++){
						var kScript = ele.testCase.scripts[k];
						if(kScript.archived){
							if(ele.testScript.versionableItemId == kScript.versionableItemId)
								ele.selectedScriptId = null;
							ele.testCase.scripts.splice(k,1);
							k-=1;
							scriptsLen-=1;
						}else if(ele.testScript && ele.testScript.versionableItemId == kScript.versionableItemId){
							ele.selectedScriptId = ele.testScript.versionableItemId;
							ele.selectedScriptTypeId = ele.testScript.scriptTypeId?ele.testScript.scriptTypeId:ele.testScript.scriptType.id;
							ele.selectedScriptName = ele.testScript.name;
							ele.adapterId = ele.adapterId ? ele.adapterId : "";
							ele.adapterImg = ImageCache.NOIMAGE;
							ele.adapterStatus = "";
							break;
						}
					}
				}
				//Add the information for element in the UI cached data field.
				this.cachedDataBasedOfItemIds["ui-item-"+ele.internalId] = ele;
            }
            // we are only updating the virtual content. The virtual
            // content provider has convenient method to do that. Call
            // it to load the virtual content. Updating a virtual page
            // is much less 'destructive' then a regular table refresh.
            // It retains the row selection states.
            if (this.updatePageOnly) {
                this.provider.loadPageContent(content);
            }
            else {
            	//This is needed only for new content and not the updatePageOnly ?????
            	this.tableViewer.setContent(content);
                this.tableViewer.refresh();
            }
		 }
		 if (this.tableViewer){
	 		 var listener = this.tableViewer.getTableListener();
			 if(listener)
				listener.rowCheckStateChanged(this.tableViewer);
		 }

		//call for adapter update
		if((unloadedSteps.length > 0) && dojo.isFunction(this.adapterSearchCallBack)){
			this.setUnloadedCurrentElements(unloadedSteps);//Required to set the content of unloaded steps before calling adataper callback
			this.adapterSearchCallBack(unloadedSteps);
			//Since skip passed could have been selected, clear off the 
			this.skipPasssedElements(unloadedSteps);
		}
		if(this.currentPage == 0 && !content ){
			//Disable the Run button on UI.
			this.disableExecution(Constants.getMessage("msgNoTestCasesFoundForSuite"),jazz.ui.MessageBox.STATUS_TYPES.ERROR);
		}
     },
     
     //From the current displayed page, set the steps for which we need load adapters
     setUnloadedCurrentElements: function(unloadedSteps){
    	 this.currentPageUnloadedSteps = unloadedSteps;
     },
     
     getUnloadedCurrentElements: function(){
    	 return this.currentPageUnloadedSteps;
     },
     
     
     _prepareQueryArgs: function(filterArgs, updatePageOnly) {
         var args = this.inherited("_prepareQueryArgs", arguments);
         if(this.testSuiteId){
        	 args.id = this.testSuiteId;
         }
         return args;
     }
     
});

})();