/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.lpa.app.ui.internal.MembersTable"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledBox"); //$NON-NLS-1$
dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.TwoStateButton"); //$NON-NLS-1$

dojo.require("com.ibm.team.lpa.app.ui.internal.MemberDetailsView"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.lpa.app.ui.internal", "MembersTableMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var Button = jazz.ui.toolbar.Button;
var HoverPopup = jazz.ui.HoverPopup;
var ResourceLink = jazz.ui.ResourceLink;
var StyledBox = jazz.ui.StyledBox;
var SB_TrimStyles = StyledBox.TrimStyles;
var ST_TrimStyles = jazz.ui.StyledTable.TrimStyles;
var Toolbar = jazz.ui.Toolbar;
var TwoStateButton = jazz.ui.toolbar.TwoStateButton;

//
// Table Row Properties
//
var ROW_BUTTONS_PROP = "_jazzRowButtons"; //$NON-NLS-1$
var ROW_USER_URI = "_jazzUserUri"; //$NON-NLS-1$
var ROW_MEMBER_DETAIL_WIDGET_PROP = "_jazzMemberDetailWidget"; //$NON-NLS-1$
var COL_CONTEXT_URI = "_jazzContextUri"; //$NON-NLS-1$
var ADD_MEMBER_BUTTON_INDEX = 0;

//
// Topics
//
var TOPIC_ADD_MEMBER = "com.ibm.team.lpa.app.ui.internal.MembersPage#addMember"; //$NON-NLS-1$
var TOPIC_DO_NOT_ADD_MEMBER = "com.ibm.team.lpa.app.ui.internal.MembersPage#removeMemberPreviewState"; //$NON-NLS-1$
var TOPIC_ADD_MEMBER_TO_DELETE_REQUEST = "com.ibm.team.lpa.app.ui.internal.MembersPage#addMemberToDelete"; //$NON-NLS-1$
var TOPIC_REMOVE_MEMBER_FROM_DELETE_REQUEST = "com.ibm.team.lpa.app.ui.internal.MembersPage#removeMemberFromDelete"; //$NON-NLS-1$
var TOPIC_REMOVE_MEMBER_FROM_ADD_REQUEST = "com.ibm.team.lpa.app.ui.internal.MembersPage#removeMemberFromAdd"; //$NON-NLS-1$

var TOPIC_DISPLAY_MEMBER_PREVIEW = "com.ibm.team.lpa.app.ui.internal.MembersTable#displayMemberPreview"; //$NON-NLS-1$
var TOPIC_REMOVE_MEMBER_PREVIEW = "com.ibm.team.lpa.app.ui.internal.MembersTable#removeMemberPreview"; //$NON-NLS-1$
var TOPIC_REFRESH_MEMBER_ROW = "com.ibm.team.lpa.app.ui.internal.MembersPage#refreshMemberRow"; //$NON-NLS-1$

//
// Static img src URLs
//
var GRAPHICS_FOLDER = "ui/graphics/"; //$NON-NLS-1$
var GRAPHICS_ICONS_FOLDER = GRAPHICS_FOLDER + "icons/"; //$NON-NLS-1$

var ADDMEMBER_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "add-member_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var TWISTIE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "expand-member-details_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var RESTORE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "restore_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var REMOVE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "remove_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var ERROR_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "error_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var MEMBER_ICON_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "member_obj.gif") //$NON-NLS-1$ //$NON-NLS-2$
var GRAY_CHECKMARK_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "gray-checkmark_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var BLACK_CHECKMARK_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "black-checkmark_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$

var ELLIPSIS_HTML =  '&#8230;'; //$NON-NLS-1$

//
// Helper to retrieve the row in which an event occured 
//
function getRow(e) {
	return getElement(e, "TR"); //$NON-NLS-1$
}

function getElement(e, tagName){
	var element= e.target || e.srcElement;
	// walk up the DOM tree until we find a row element
	while (element && element.tagName !== tagName) {
		element= element.parentNode;
	}
	return element || null;
}

dojo.declare("com.ibm.team.lpa.app.ui.internal.MembersTable", jazz.ui.StyledTable,  { //$NON-NLS-1$
	
	trim: ST_TrimStyles.PRIMARY_HEADLESS,
	
	/**
	 * {Required}
	 * 
	 * The array of project member objects to display in the table. 
	 */
	members: [],
	
	/**
	 * {Required}
	 * 
	 * A reference to the project whose members we are displaying.
	 */ 	
	project: null, 	/**Required**/
	
	/**
	 * {Required}
	 * 
	 * A callback method to refresh the members page.
	 */ 	
	_refreshCallback: null, 	/**Required**/
	
	
	/**
	 * {Optional}
	 * 
	 * The CSS class to apply to the tbody of the table
	 */
	className: "", //$NON-NLS-1$
	
	/**  
	 * {Optional} 
	 * 
	 * True to display errors in the UI, False otherwise.
	 */
	displayErrors: true, 
	
	/**  
	 * {Optional} 
	 * 
	 * Set to true if we should always display a member's details in the UI, 
	 * false if not.
	 */
	expandDetails: false,
	
	/** 
	 * {Optional}
	 * 
	 *  True if we want to the details to be displayed with Member Preview elements.
	 *  False if we should display all data about a member.
	 */ 
	isPreview: false,  
	
	/**
	 * {Optional}
	 * 
	 *  Set to true if the member should be removed from the table when a user
	 *  clicks on the "Remove Member" button.
	 */
	removeOnDelete: false,
	
	constructor: function(args){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.lpa.app.ui.internal", "MembersTableMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		
		this.members = args.members;
		this._refreshCallback = args.refreshCallback;
		
		this._simpleTbButtonMap = {}; // used to track references to the SimpleTB button widgets so we can retrieve them easily
		this._loadingPreviewRows = {}; //mutex to prevent state member state changes when loading a member preview
		
		this._membersMap = {};
		this._dirtyUsers = {};
		this._filterIndex = [];
		this._buildMembersMap();
		
		// properties used to track references that need to be destroyed on table destruction
		this._topics = []; //store references to dojo topics and connects to handle their destruction
		this._childrenWidgets = [];
		this._connectHandles = [];
		
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		this.set("handleSort", dojo.hitch(this, this._sortMembers)); //$NON-NLS-1$
		
		//create the event handlers on the table
		this._connectHandles.push(
			dojo.connect(this.domNode, "onclick", this, this._onMouseClick) //$NON-NLS-1$
		);
		
		this._topics.push(dojo.subscribe(TOPIC_DISPLAY_MEMBER_PREVIEW, this, "displayMemberPreview")); //$NON-NLS-1$
		this._topics.push(dojo.subscribe(TOPIC_REMOVE_MEMBER_PREVIEW, this, "removeMemberPreview")); //$NON-NLS-1$
		this._topics.push(dojo.subscribe(TOPIC_REFRESH_MEMBER_ROW, this, "refreshMemberRow")); //$NON-NLS-1$
		
		this._addRichHoverToColTh();
		
		//sort the initial member set
		this._sortMembers();
	},
	
	destroy: function(){
		this._destroyChildWidgets();
		
		//unsubscribe from topics
		dojo.forEach(this._topics, dojo.unsubscribe);
		
		//disconnect from events
		dojo.forEach(this._connectHandles, dojo.disconnect);
		
		if (this._topics) delete this._topics;
		if (this._childrenWidgets) delete this._childrenWidgets;
		if (this._connectHandles)  delete this._connectHandles;
		
		if (this._filterIndex) delete this._filterIndex;
		
		if (this._membersMap){
			this._destroyObjectProps(this._membersMap);
			delete this._membersMap;
		}
		
		if (this._simpleTbButtonMap){
			this._destroyObjectProps(this._simpleTbButtonMap);
			delete this._simpleTbButtonMap;
		}
		
		//run parent destroy() method
		this.inherited(arguments);
	},
	
	_destroyObjectProps: function(obj){
		for (var prop in obj) {
			delete obj[prop];
		}
	},
	
	_destroyChildWidgets: function(){
		if (this._childrenWidgets.length > 0){
			dojo.forEach(this._childrenWidgets, function(widget){
				widget.destroy();
			});
			
			this._childrenWidgets = [];
		}
	},

	/*
	 * ================
	 * Public Methods
	 * ================
	 */
	
	//
	// Refresh the members table back to its default state
	//
	refresh: function(){
		this._destroyChildWidgets();
		this._dirtyUsers = {};
		this._sortMembers();
		this._buildMembersMap();
	},
	
	//
	// Add a new member to the MembersTable.
	//
	// newMember {REQUIRED}: A member object that is returned from making a call
	//						 to LpaClient.getMembers()
	//
	addMember: function(args){
		var newMember = args.newMember;
		
		if (!this.isAlreadyMember(newMember)) {
			//add the new member to the array and private map
			var members = this.members;
			members.push(newMember);
			this._membersMap[newMember.uri] = members[members.length-1];
			
			//add new member to the table
			this._addMemberRow({
				member: newMember
			});	
		}
	},
	
	//
	// Remove a member from the table
	//
	// Params:
	//	member: {REQUIRED} The member object of the member to remove from the table
	//
	removeMember: function(member){
		var row = this._getMemberRow({
			userUri: member.uri
		});
		
		this._deleteRow(
			this._getMemberRow({
				userUri: member.uri
			})
		);
	},
	
	//
	// Set a member row to the preview state for all contexts
	//
	// Params
	// 	member {REQUIRED}: the member whose row should be updated 
	//					   and the state in which it should represent.
	//
	displayMemberPreview: function(member){
		if(!this._membersMap[member.uri]) return;
		
		var currentMemberState = this._membersMap[member.uri];
		
		currentMemberState.previewState = member;
		
		var row = this._getMemberRow({
			userUri: member.uri
		});
		
		this._setRowState({
			isPreviewState: true,
			member: member,
			row: row
		});
	},
	
	//
	// Remove the preview state for a given member's row
	//
	// Params
	//	member: {REQUIRED} the member whose row should be updated
	//
	removeMemberPreview: function(member){
		if(!this._membersMap[member.uri]) return;
		
		var nonPreviewMemberState = this._membersMap[member.uri];
		
		var row = this._getMemberRow({
			userUri: nonPreviewMemberState.uri
		});
		
		this._setRowState({
			isPreviewState: false,
			member: nonPreviewMemberState,
			row: row
		});
		
		if (nonPreviewMemberState.previewState){
			//no need to track the preview state anymore
			delete nonPreviewMemberState.previewState;
		}
		
		this.setLoadingState({
			userUri: member.uri,
			isLoading: false
		});
	},
	
	//
	// Return an index of the members in the table
	//
	// Return:
	//	An array of filter objects to be used by jazz.ui.FilterBox
	//
	getMemberIndex: function(){
		return this._filterIndex;
	},
	
	//
	// Check to see if a given member is in a "loading" state
	//
	// Params:
	//	userUri: {REQUIRED} the resource uri of the member to check
	//
	// Return:
	//	TRUE if the member is in a loading state, FALSE or NULL if not
	//
	getLoadingState: function(memberUri){
		return this._loadingPreviewRows[memberUri];
	},
	
	//
	// Set a user's loading state
	//
	// Params:
	//	userUri {REQUIRED if row not provided}: a member's resource uri
	//	row: {REQUIRED if userURI not provided}: a domNode reference to the user's row in the actual table
	//	isLoading: {REQUIRED}: Boolean, the state in which to set the user's loading state, 
	//							TRUE if loading, FALSE otherwise
	//
	setLoadingState: function(args){
		var row = args.row;
		var isLoading = args.isLoading;
		var userUri = args.userUri || row[ROW_USER_URI];
		
		this._loadingPreviewRows[userUri] = isLoading;
	},
	
	// 
	// Checks to see if a user is a member of the table
	//
	// Params:
	//	member: {REQUIRE} A member object that represents the user to check
	// Return
	//	TRUE if the given user is a member of the table, false otherwise
	// 
	isAlreadyMember: function(member){
		if (this._membersMap[member.uri]){
			var memberToCheck = this._membersMap[member.uri];
			var isNotInEachContainer = dojo.some(this.project.contexts, dojo.hitch(this, function(context){
				//this is confusing code.
				//so since we don't want to iterate over the entire array, we want to find the first occurence
				//of an when a user is NOT a member of an Artifact Container.  When the we find that the
				//user does not exist in the Container, we return true and stop the iteration
				var memberContext = memberToCheck.contextMap[context.uri];
				return (memberContext && !memberContext.isInferred) ? false : true;
			}));
			
			//return true if the user is a member of ever container, otherwise
			//we return false
			if (!isNotInEachContainer){
				return true;
			} 
		}
		
		return false;
	},
	
	/*
	 * ================
	 * Table Builder Methods
	 * ================
	 */
	
	_buildRows: function(){
		//iterate over each project member and add their member row
		var members = this.members;
		dojo.forEach(members, dojo.hitch(this, function(member){
			this._addMemberRow({
				"member": member //$NON-NLS-1$
			});
		}));
	},
	
	refreshMemberRow: function(args){
		var member = args.member;
		this._membersMap[member.uri] = member;
		var row = this._getMemberRow({
			userUri: member.uri
		});
		
		var domainCols = dojo.query(".domain-column", row); //$NON-NLS-1$
		
		var filterObj = {};
		for (var i = 0; i < this._filterIndex.length; i++){
			if (member.uri === this._filterIndex[i].uri){
				filterObj = this._filterIndex[i];
				break;
			}
		}
		filterObj.text = [ member.name.toLowerCase(), member.label.toLowerCase() ];
		
		var statusContent = [];
		
		dojo.forEach(domainCols, dojo.hitch(this, function(col){
			var contextUri = col[COL_CONTEXT_URI];
			
			var memberContext = member.contextMap[contextUri];
			
			
			if (memberContext) {
				var roleViolations = memberContext.roleViolations;
				var contextRoles = memberContext.roles; 
				
				//check that a user has membership roles and/or role violations
				var hasViolations = (roleViolations && roleViolations.length > 0);
				var hasRoles = (contextRoles && contextRoles.length > 0);
				
				if (hasRoles){
					var span = dojo.create("span", { //$NON-NLS-1$
						className: "", //$NON-NLS-1$
						innerHTML: "&nbsp;", //$NON-NLS-1$
						title: "" //$NON-NLS-1$
					}, col, "only"); //$NON-NLS-1$
					
					if (this.isPreview && memberContext.isInferred ){
						span.className = "j-hint"; //$NON-NLS-1$
						dojo.create("img", { //$NON-NLS-1$
							className: "checkmark", //$NON-NLS-1$
							src: GRAY_CHECKMARK_IMG_SRC
						}, span);
						span.title = this.messages.previewMembershipTitle;
					} else if (!memberContext.isInferred){
						if (this.displayErrors && hasViolations){
							//display error icon
							dojo.create("img", { //$NON-NLS-1$
								src: ERROR_IMG_SRC,
								className: "statusCol-img" //$NON-NLS-1$
							}, span);
							span.title = this.messages.errorTitle;
							
							//track the error messages
							for(var i=0; i < roleViolations.length; i++){
								statusContent.push(dojo.create("div", { //$NON-NLS-1$
									innerHTML: jazz.util.html.removeScript(roleViolations[i].description),
									className: "violationMsg" //$NON-NLS-1$
								}));
							}
						} else {
							//membership is ok, so display a checkmark
							dojo.create("img", { //$NON-NLS-1$
								className: "checkmark", //$NON-NLS-1$
								src: BLACK_CHECKMARK_IMG_SRC
							}, span);
							span.title = this.messages.isMemberTitle;
						}
					} else if (memberContext.isInferred) {
						isMemberOfAllContainers = false;
					}
					
					for(var j=0; j<contextRoles.length; j++) {
						//add the member's roles to the filter
						filterObj.text.push(jazz.util.html.removeScript(contextRoles[j].label.toLowerCase()));
					}
				}
			}
		}));
		
		//update the status column
		var statusCol = dojo.query(".status-column", row)[0];  //$NON-NLS-1$
		dojo.empty(statusCol);
		
		if (statusContent.length > 0){
			dojo.forEach(statusContent, dojo.hitch(this, function(msgDiv){
				dojo.place(msgDiv, statusCol);
			}));
			
			var divNode = dojo.create("div", { //$NON-NLS-1$
				innerHTML: this.messages.accessControlErrorAction
			}, statusCol);
			this._connectMemberDetailsAction(divNode, row);
		} else {
			statusCol.innerHTML = this.messages.okLabel;
		}
	},
	
	_addMemberRow: function(args){
		var member = args.member;
		
		//
		// Column Ordering:
		// ================
		//
		// | Name | User ID | {Domain} | {Domain} | ... | {Status} | Actions |
		//
		var tr = dojo.create("tr", { //$NON-NLS-1$
			className: "memberRow " + ((this.isPreview) ? "j-table-restored" : "") //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}, this.tbody);
		tr[ROW_USER_URI] = member.uri;
		
		//create the filter object here so we can access the element to filter out
		var filterObj = {
			text:[ member.name.toLowerCase(), member.label.toLowerCase() ],
			uiElement: tr,
			uri: member.uri
		};
		
		//create the Name column
		var td = dojo.create("td", {className: "left"}, tr); //$NON-NLS-1$ //$NON-NLS-2$
		var rl = new ResourceLink({
			uri: member.uri,
			label: jazz.util.html.escape(member.name),
			lazyFetch: true
		});
		dojo.place(rl.domNode, td, "only"); //$NON-NLS-1$
		
		//create the User ID column
		var td = dojo.create("td", {className: "left"}, tr); //$NON-NLS-1$ //$NON-NLS-2$
		var rl = new ResourceLink({
			uri: member.uri,
			label: jazz.util.html.escape(member.label),
			lazyFetch: true
		});
		dojo.place(rl.domNode, td, "only"); //$NON-NLS-1$
		
		var statusContent = [];
		var isMemberOfAllContainers = true;
		
		//create the membership columns for each domain
		dojo.forEach(this.project.contexts, dojo.hitch(this, function(context, index) {
			var td = dojo.create("td", { //$NON-NLS-1$
				className: "domain-column" //$NON-NLS-1$
			}, tr);
			td[COL_CONTEXT_URI] = context.uri;
			
			var memberContext = member.contextMap[context.uri];
			
			if (memberContext) {
				var roleViolations = memberContext.roleViolations;
				var contextRoles = memberContext.roles; 
				
				//check that a user has membership roles and/or role violations
				var hasViolations = (roleViolations && roleViolations.length > 0);
				var hasRoles = (contextRoles && contextRoles.length > 0);
				
				if (hasRoles){
					var span = dojo.create("span", { //$NON-NLS-1$
						className: "", //$NON-NLS-1$
						innerHTML: "&nbsp;", //$NON-NLS-1$
						title: "" //$NON-NLS-1$
					}, td);
					
					if (this.isPreview && memberContext.isInferred ){
						span.className = "j-hint"; //$NON-NLS-1$
						dojo.create("img", { //$NON-NLS-1$
							className: "checkmark", //$NON-NLS-1$
							src: GRAY_CHECKMARK_IMG_SRC
						}, span);
						span.title = this.messages.previewMembershipTitle;
					} else if (!memberContext.isInferred){
						if (this.displayErrors && hasViolations){
							//display error icon
							dojo.create("img", { //$NON-NLS-1$
								src: ERROR_IMG_SRC,
								className: "statusCol-img" //$NON-NLS-1$
							}, span);
							span.title = this.messages.errorTitle;
							
							//track the error messages
							for(var i=0; i < roleViolations.length; i++){
								statusContent.push(dojo.create("div", { //$NON-NLS-1$
									innerHTML: jazz.util.html.removeScript(roleViolations[i].description),
									className: "violationMsg" //$NON-NLS-1$
								}));
							}
						} else {
							//membership is ok, so display a checkmark
							dojo.create("img", { //$NON-NLS-1$
								className: "checkmark", //$NON-NLS-1$
								src: BLACK_CHECKMARK_IMG_SRC
							}, span);
							span.title = this.messages.isMemberTitle;
						}
					} else if (memberContext.isInferred) {
						isMemberOfAllContainers = false;
					}
					
					for(var i=0; i<contextRoles.length; i++) {
						//add the member's roles to the filter
						filterObj.text.push(jazz.util.html.removeScript(contextRoles[i].label.toLowerCase()));
					}
				}
			} else {
				isMemberOfAllContainers = false;
				dojo.create("span", { //$NON-NLS-1$
					innerHTML: "&nbsp;" //$NON-NLS-1$
				}, td);
			}
		}));
		
		//add the filter to the index
		var isInFilter = false; 
		dojo.forEach(this._filterIndex, dojo.hitch(this, function(filter, i) {
			if (filter.uri === member.uri) {
				this._filterIndex[i] = filterObj;
				isInFilter = true;
			}
		}));
		if (!isInFilter){
			this._filterIndex.push(filterObj);
		}
		//create the status column
		var statusCol = dojo.create("td", { //$NON-NLS-1$
			className: "left status-column" //$NON-NLS-1$
		}, tr);
		
		if (statusContent.length > 0){
			dojo.forEach(statusContent, dojo.hitch(this, function(msgDiv){
				dojo.place(msgDiv, statusCol);
			}));
			
			var divNode = dojo.create("div", { //$NON-NLS-1$
				innerHTML: this.messages.accessControlErrorAction
			}, statusCol);
			this._connectMemberDetailsAction(divNode, tr);
		} else {
			statusCol.innerHTML = this.messages.okLabel;
		}
		
		var actionToolbar = this._createActionButtons({
			isMemberOfAllContainers: isMemberOfAllContainers,
			row: tr
		});
		tr[ROW_BUTTONS_PROP] = actionToolbar.id;
		var actionButtons = actionToolbar.getChildren();
		
		for (var i=0; i < actionButtons.length; i++) {
			actionButtons[i].connect(actionButtons[i].focusNode, "onfocus", function(event) { //$NON-NLS-1$
				clearTimeout(tr._blurTimeout);
			});
			actionButtons[i].connect(actionButtons[i].focusNode, "onblur", function(event) { //$NON-NLS-1$
				tr._blurTimeout = setTimeout(function() {
					dojo.removeClass(tr, "focused"); //$NON-NLS-1$
				}, 0);
			});
		}
		
		var td = dojo.create("td", {className: "right"}, tr); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.place(actionToolbar.domNode, td);
		actionToolbar.connect(actionToolbar.domNode, "onfocus", function(event) { //$NON-NLS-1$
			var i;
			var actionButtons = this.getChildren();
			dojo.addClass(tr, "focused"); //$NON-NLS-1$
			for(i = 0; i < actionButtons.length; i++) {
				if (actionButtons[i].isFocusable()) { //$NON-NLS-1$
					actionButtons[i].focus();
					break;
				}
			}
			if (i === actionButtons.length) {
				dojo.removeClass(tr, "focused"); //$NON-NLS-1$
			}
		});
		
		if(this.expandDetails){
			//display user details if we are told to do so.
			this._displayUserDetails(tr);
		}
	},
	
	_createActionButtons: function(args){
		var isMemberOfAllContainers = args.isMemberOfAllContainers;
		var row = args.row;
		
		var simpleToolbar = new Toolbar();
		if (!this.isPreview && !isMemberOfAllContainers){
			dojo.addClass(simpleToolbar.domNode, "fixSimpleTbOffset"); //$NON-NLS-1$
		}
		
		var button = new Button({
			title: this.messages.addMemberAltLabel,
			imgSrc: ADDMEMBER_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				this._addMember(row);
			})
		});
		button.set("visible", !this.isPreview && !isMemberOfAllContainers); //$NON-NLS-1$
		dojo.addClass(button.focusNode, "addMember action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "addMember"] = button; //$NON-NLS-1$
		
		var button = new Button({
			title: this.messages.restoreMemberAltLabel,
			imgSrc: RESTORE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				this._restoreAddMember(row);
			})			
		});
		button.set("visible", false); //$NON-NLS-1$
		dojo.addClass(button.focusNode, "undoAddMember action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "undoAddMember"] = button; //$NON-NLS-1$
		
		var displayButtonClasses = "displayUser action"; //$NON-NLS-1$
		button = new TwoStateButton({
			title: this.messages.twistieAltLabel,
			imgSrc: TWISTIE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				this._displayUserDetails(row);
			})
		});
		button.set("visible", !this.isPreview); //$NON-NLS-1$
		dojo.addClass(button.focusNode, displayButtonClasses);
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "displayUser"] = button; //$NON-NLS-1$
		
		button = new Button({
			title: this.messages.removeMemberAltLabel,
			imgSrc: REMOVE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				if (this.removeOnDelete) {
					this._deleteRow(row);
				} else {
					this._deleteMember(row);
				}
			})
		});
		dojo.addClass(button.focusNode, "deleteMember action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "deleteMember"] = button; //$NON-NLS-1$
		
		var button = new Button({
			title: this.isPreview ? this.messages.removeMemberAltLabel : this.messages.restoreRemoveMemberAltLabel,
			imgSrc: RESTORE_IMG_SRC,
			onClick: dojo.hitch(this, function (event) {
				dojo.stopEvent(event);
				if (this.removeOnDelete) {
					this._deleteRow(row);
				} else {
					this._restoreDeleteMember(row);
				}
			})
		});
		button.set("visible", false); //$NON-NLS-1$
		dojo.addClass(button.focusNode, "undoDeleteMember action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "undoDeleteMember"] = button; //$NON-NLS-1$
		
		this._childrenWidgets.push(simpleToolbar);
		return simpleToolbar;
	},
	
	/*
	 * ================
	 * Sort Member Methods
	 * ================
	 */
	
	//
	// Sort the members table so that users with role violations appear at 
	// the top of the table, then sort by alphabetical order.
	//
	_sortMembers: function(){
		var sortProp = (this.sortBy === 0) ? "name" : "label"; //$NON-NLS-1$ //$NON-NLS-2$
		
		if (this.sortByAscending){
			//sort in order (e.g. 1,2,3 or a,b,c)
			this.members.sort( dojo.hitch(this, function(a,b){
				var val = 0;
				
				if (!this.isPreview){
					val = this._sortByViolation({
						a: a,
						b: b
					});
				}
				
				
				if (val === 0){
					//a and b have same violation state
					//so alphabatize the order
					var x = a[sortProp].toLowerCase();
			    	var y = b[sortProp].toLowerCase();
			   	 	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
				}
				
				return val;
			}));
		} else {
			//sort in reverse order (e.g. 3,2,1 or c,b,a)
			this.members.sort(dojo.hitch(this, function(a,b){
				var val = 0;
				
				if (!this.isPreview){
					val = this._sortByViolation({
						a: a,
						b: b
					});
				}
				
				if (val === 0){
					//a and b have same violation state
					//so alphabatize the order
					var x = a[sortProp].toLowerCase();
			    	var y = b[sortProp].toLowerCase();
			   	 	return ((x > y) ? -1 : ((x < y) ? 1 : 0));
				}
				
				return val;
			}));
		}	
		
		this.clearBody();
		this._buildRows();
		
		for (userUri in this._dirtyUsers){
			//restore the dirty state of the rows
			var row = this._getMemberRow({
				userUri: userUri
			});
			
			dojo.forEach(this._dirtyUsers[userUri], dojo.hitch(this, function(stateMethod){
				this[stateMethod]({
					row:row
				});
			}));
		}
		
		if (this._refreshCallback) {
			this._refreshCallback.call();
		}
	},
	
	//
	// Helper to determine the violation state of two members.  Members
	// that have role violations will be placed first in the members list.
	//
	_sortByViolation: function(args){
		var val = 0;
		
		var a = args.a;
		var b = args.b;
		
		var aViolations = false;
		var bViolations = false;
		
		var aViolations = dojo.some(this.project.contexts, dojo.hitch(this, function(context){
			var memberContext = a.contextMap[context.uri];
			
			if (memberContext){
				var roleViolations = memberContext.roleViolations;
			
				return (roleViolations && roleViolations.length > 0);	
			}
			
			return false;
		}));
		
		var bViolations = dojo.some(this.project.contexts, dojo.hitch(this, function(context){
			var memberContext = b.contextMap[context.uri];
			if (memberContext){
				var roleViolations = memberContext.roleViolations;
			
				return (roleViolations && roleViolations.length > 0);	
			}
			
			return false;
		}));
		
		if (aViolations && !bViolations) {
			//a has a violation, move it to the front
			return -1;
		}
		
		if (!aViolations && bViolations) {
			//b has a violation, move it to the front
			return 1;
		} 
		
		return 0;
	},
	
	_addMember: function(row) {
		var userUri = row[ROW_USER_URI];
		var newMember = [this._membersMap[userUri]];
		
		if (!this.getLoadingState(userUri)){
			var undoDeleteButton = this._getSimpleTbButton({
				row: row,
				buttonId: "undoDeleteMember" //$NON-NLS-1$
			});
			if (undoDeleteButton.isFocusable()){
				//The member is set to be removed, but since the user
				//wants to add the member, call _deleteMember to handle
				//removing the member from "removeMembers" request.
				this._restoreDeleteMember(row);
			}
			
			dojo.addClass(row, "dirtyState"); //$NON-NLS-1$
			dojo.addClass(row, "j-table-restored"); //$NON-NLS-1$
			dojo.publish(TOPIC_ADD_MEMBER, [newMember]);
			
			this.setLoadingState({
				userUri: userUri,
				isLoading: true
			});
			
			//Update Buttons
			var addMemberButton = this._getSimpleTbButton({
				row: row,
				buttonId: "addMember" //$NON-NLS-1$
			});
			var undoButton = this._getSimpleTbButton({
				row: row,
				buttonId: "undoAddMember" //$NON-NLS-1$
			});
			undoButton.set("visible", true); //$NON-NLS-1$
			undoButton.focus();
			addMemberButton.set("visible", false); //$NON-NLS-1$
		}
	},
	
	_restoreAddMember: function(row) {
		var userUri = row[ROW_USER_URI];
		var newMember = [this._membersMap[userUri]];
		
		dojo.publish(TOPIC_DO_NOT_ADD_MEMBER, [newMember]);
			
		this.setLoadingState({
			userUri: userUri,
			isLoading: false
		});
		
		//Update Buttons
		var addMemberButton = this._getSimpleTbButton({
			row: row,
			buttonId: "addMember" //$NON-NLS-1$
		});
		var undoButton = this._getSimpleTbButton({
			row: row,
			buttonId: "undoAddMember" //$NON-NLS-1$
		});
		addMemberButton.set("visible", true); //$NON-NLS-1$
		addMemberButton.focus();
		undoButton.set("visible", false); //$NON-NLS-1$
	},
	
	_restoreDeleteMember: function(row) {
		var userUri = row[ROW_USER_URI];
		var member = this._membersMap[userUri];
		
		dojo.removeClass(row, "dirtyState"); //$NON-NLS-1$
		dojo.removeClass(row, "j-table-restored"); //$NON-NLS-1$
		
		if (this._dirtyUsers[userUri].length > 1){
			var i = dojo.indexOf(this._dirtyUsers[userUri], "_deleteMember"); //$NON-NLS-1$
			this._dirtyUsers[userUri].splice(i, 1);
		} else {
			delete this._dirtyUsers[userUri];
		}
		
		dojo.publish(TOPIC_REMOVE_MEMBER_FROM_DELETE_REQUEST, [{
			member: member
		}]);
		if (this.isPreview) {
			dojo.publish(TOPIC_REMOVE_MEMBER_FROM_ADD_REQUEST, [{
				member: member,
				shouldRemoveFromRequest: true
			}]);
		}
		
		//Update button states
		var deleteMemberButton = this._getSimpleTbButton({
			row: row,
			buttonId: "deleteMember" //$NON-NLS-1$
		});
		var undoButton = this._getSimpleTbButton({
			row: row,
			buttonId: "undoDeleteMember" //$NON-NLS-1$
		});
		deleteMemberButton.set("visible", true); //$NON-NLS-1$
		deleteMemberButton.focus();
		undoButton.set("visible", false); //$NON-NLS-1$
	},
	
	_deleteRow: function(row) {
		var userUri = row[ROW_USER_URI];
		var member = this._membersMap[userUri];
		
		//remove the row from the table
		var memberDetailWidgetId = row[ROW_MEMBER_DETAIL_WIDGET_PROP];
		var memberDetailWidget = dijit.byId(memberDetailWidgetId);
		
		if (memberDetailWidget) {
			memberDetailWidget.close();
		}
		dojo.destroy(row);
		delete this._membersMap[userUri];
		delete this._dirtyUsers[userUri];
		
		for (var i=0; i<this.members.length; i++){
			if(this.members[i].uri === userUri){
				this.members.splice(i, 1);
				break;
			}
		}
		
		dojo.publish(TOPIC_REMOVE_MEMBER_FROM_DELETE_REQUEST, [{
			member: member
		}]);
		if (this.isPreview) {
			dojo.publish(TOPIC_REMOVE_MEMBER_FROM_ADD_REQUEST, [{
				member: member,
				shouldRemoveFromRequest: true
			}]);
		}
	},
	
	/*
	 * ================
	 * Event Action Methods
	 * ================
	 */
	
	//
	// Set the member into a "delete" state in the UI.  This method is used
	// to tell the top-level page which members should be removed from the 
	// project and table.
	//
	_deleteMember: function(row){
		var userUri = row[ROW_USER_URI];
		var member = this._membersMap[userUri];
		
		if (!this.getLoadingState(userUri)) {		
			//set the member into the "delete" state
			var deleteButton = this._getSimpleTbButton({
				row: row,
				buttonId: "deleteMember" //$NON-NLS-1$
			});
			
			dojo.addClass(row, "dirtyState"); //$NON-NLS-1$
			dojo.addClass(row, "j-table-restored"); //$NON-NLS-1$
			
			if (this._dirtyUsers[userUri] && dojo.indexOf(this._dirtyUsers[userUri], "_deleteMember") === -1){ //$NON-NLS-1$
				this._dirtyUsers[userUri].push("_deleteMember"); //$NON-NLS-1$
			} else if (!this._dirtyUsers[userUri]){
				this._dirtyUsers[userUri] = ["_deleteMember"] //$NON-NLS-1$
			}
			
			var addMemberButton = this._getSimpleTbButton({
				row: row,
				buttonId: "undoAddMember" //$NON-NLS-1$
			});
			if (addMemberButton.isFocusable()) {
				this._restoreAddMember(row);
			}
			dojo.publish(TOPIC_ADD_MEMBER_TO_DELETE_REQUEST, [{
				member: member
			}]);
			
			//Update button states
			var deleteMemberButton = this._getSimpleTbButton({
				row: row,
				buttonId: "deleteMember" //$NON-NLS-1$
			});
			var undoButton = this._getSimpleTbButton({
				row: row,
				buttonId: "undoDeleteMember" //$NON-NLS-1$
			});
			undoButton.set("visible", true); //$NON-NLS-1$
			undoButton.focus();
			deleteMemberButton.set("visible", false); //$NON-NLS-1$
		}
	},
	
	/*
	 * ================
	 * MembersTable Util Methods
	 * ================
	 */
	
	_addRichHoverToColTh: function(){
		var colList = dojo.query("th.headerColumn.domain-column", this._thead); //$NON-NLS-1$
		
		dojo.forEach(this.project.contexts, dojo.hitch(this, function(context, index){
			var thNode = colList[index];
			var rl = new ResourceLink({
				uri: context.uri,
				label: (thNode.innerText) ? thNode.innerText : thNode.textContent,
				lazyFetch: true
			});	
			this._childrenWidgets.push(rl);
			dojo.place(rl.domNode, thNode, "only"); //$NON-NLS-1$
		}));
	},
	
	//
	// Clears out and builds a new members map against the current state of 
	// the this.members attribute.  Can be access through the this._membersMap
	// object.
	//
	_buildMembersMap: function(){
		if(this.members && this.members.length > 0){
			this._membersMap = {};
			
			dojo.forEach(this.members, dojo.hitch(this, function(member){
				this._membersMap[member.uri] = member;
			}));
		}
	},
	
	//
	// Return a reference to the DOM node that a member's information is
	// stored at.
	//
	_getMemberRow: function(args){
		var userUri = args.userUri;
		var memberRow = null; 
		
		dojo.some(this.tbody.childNodes, dojo.hitch(this, function(row){
			if (row[ROW_USER_URI] === userUri){
				memberRow = row;
				return true;
			}
			
			return false;
		}));
		
		return memberRow;
	},
	
	//
	// Wrapper to handle XHR requests
	//
	_makeRemoteCall: function(dfd, callback) {
		makeRemoteCall(dfd, dojo.hitch(this, callback));
	},
	
	//
	// Sets the state of given row to/from a dirty state
	//
	_setRowState: function(args){
		var isPreviewState = args.isPreviewState;
		var member = args.member;
		var row = args.row;
		
		var statusContent = [];
		
		var simpleTb = dijit.byId(row[ROW_BUTTONS_PROP]);
		var undoAddMemberButton = this._getSimpleTbButton({
			row: row,
			buttonId: "undoAddMember" //$NON-NLS-1$
		});
		var addMemberButton = this._getSimpleTbButton({
			row: row,
			buttonId: "addMember" //$NON-NLS-1$
		});
		undoAddMemberButton.set("visible", isPreviewState); //$NON-NLS-1$
		addMemberButton.set("visible", !isPreviewState); //$NON-NLS-1$
		
		var curPressState = undoAddMemberButton.isFocusable();
		
		dojo.query(".domain-column", row).forEach(dojo.hitch(this, function(appCol){ //$NON-NLS-1$
			var contextUri = appCol[COL_CONTEXT_URI];
			var memberContext = member.contextMap[contextUri];	
			
			var roleViolations = memberContext.roleViolations;
			var contextRoles = memberContext.roles; 
			
			//check that a user has membership roles and/or role violations
			var hasViolations = (roleViolations && roleViolations.length > 0);
			var hasRoles = (contextRoles && contextRoles.length > 0);
			
			if (hasRoles) {
				var span = dojo.create("span", { //$NON-NLS-1$
					className: "", //$NON-NLS-1$
					innerHTML: "&nbsp;", //$NON-NLS-1$
					title: "" //$NON-NLS-1$
				}, appCol, "only"); //$NON-NLS-1$
				
				if (isPreviewState && memberContext.isInferred) {
					span.className = "j-hint"; //$NON-NLS-1$
					span.innerHTML = ELLIPSIS_HTML + "&nbsp;"; //$NON-NLS-1$
					dojo.create("img", { //$NON-NLS-1$
						className: "checkmark", //$NON-NLS-1$
						src: GRAY_CHECKMARK_IMG_SRC
					}, span);
					span.title = this.messages.previewMembershipTitle;
				}
				else if (!memberContext.isInferred) {
					if (this.displayErrors && hasViolations) {
						//display error icon
						dojo.create("img", { //$NON-NLS-1$
							src: ERROR_IMG_SRC,
							className: "statusCol-img" //$NON-NLS-1$
						}, span);
						span.title = this.messages.errorTitle;
						
						//track the error messages
						for (var i = 0; i < roleViolations.length; i++) {
							statusContent.push(dojo.create("div", { //$NON-NLS-1$
								innerHTML: jazz.util.html.removeScript(roleViolations[i].description),
								className: "violationMsg" //$NON-NLS-1$
							}));
						}
					} else {
						//membership is ok, so display a checkmark
						dojo.create("img", { //$NON-NLS-1$
							className: "checkmark", //$NON-NLS-1$
							src: BLACK_CHECKMARK_IMG_SRC
						}, span);
						span.title = this.messages.isMemberTitle;
					}
				}
			}
		}));
		
		var statusCol = dojo.query("status-column", row); //$NON-NLS-1$
		if (statusContent.length > 0){
			statusCol.innerHTML - ""; //$NON-NLS-1$
			
			dojo.forEach(statusContent, dojo.hitch(this, function(msgDiv){
				dojo.place(msgDiv, statusCol);
			}));
			
			var divNode = dojo.create("div", { //$NON-NLS-1$
				innerHTML: this.messages.accessControlErrorAction
			}, statusCol);
			this._connectMemberDetailsAction(divNode, row);
		} else {
			statusCol.innerHTML = this.messages.okLabel;
		}
		
		//The details row is actually a StyledBox that contains the 
		// members detail widget as its content. As such, we need to 
		// take some extra steps to actually retrieve the reference to the
		// node to perform a refresh action on it.
		var styledBox = dijit.byId( row[ROW_MEMBER_DETAIL_WIDGET_PROP] );
		if (styledBox){
			var detailsWidgetNode = styledBox.get("contentNode"); //$NON-NLS-1$
			var detailsWidgetId = dojo.attr(detailsWidgetNode, "widgetId"); //$NON-NLS-1$
			var detailsWidget = dijit.byId(detailsWidgetId);
			
			detailsWidget.set("member", member); //$NON-NLS-1$
			detailsWidget.set("isPreview", isPreviewState); //$NON-NLS-1$
			detailsWidget.refresh();
		}
		
		var deleteMemberButton = this._getSimpleTbButton({
			row: row,
			buttonId: "deleteMember" //$NON-NLS-1$
		});
		
		if (isPreviewState || deleteMemberButton.pressed) {
			dojo.addClass(row, "dirtyState"); //$NON-NLS-1$
			dojo.addClass(row, "j-table-restored"); //$NON-NLS-1$
		} else {
			dojo.removeClass(row, "dirtyState"); //$NON-NLS-1$
			dojo.removeClass(row, "j-table-restored"); //$NON-NLS-1$
		}
		
		
	},
	
	/*
	 * ================
	 * User Details Util Methods
	 * ================
	 */
	
	//
	// Create a MemberDetailsView box to display information about the chosen
	// project member within a LPA project. 
	//
	_displayUserDetails: function(row){
		var simpleToolbarId = row[ROW_BUTTONS_PROP];
		var simpleToolbar = dijit.byId(simpleToolbarId);
		var twistieButton = this._getSimpleTbButton({
			row: row,
			buttonId: "displayUser" //$NON-NLS-1$
		});
		
		var userUri = row[ROW_USER_URI];
		
		if (twistieButton.pressed) {		
			var member = this._membersMap[userUri];
			var previewMemberState = member.previewState;
			
			var newRow = row.parentNode.insertRow(row.rowIndex - 5);
			var newCol = dojo.create("td", { //$NON-NLS-1$
				colSpan: row.childNodes.length
			}, newRow);
			var memberDetailsBox = new StyledBox({
				contentNode: new com.ibm.team.lpa.app.ui.internal.MemberDetailsView({
					member: (previewMemberState) ? previewMemberState : member,
					contexts: this.project.contexts,
					destroyContents: true,
					displayErrors: this.displayErrors,
					isPreview: (previewMemberState) ? true : this.isPreview,
					project: this.project
				}).domNode,
				destroyContents: true,
				headerHoverState: false,
				iconPath: MEMBER_ICON_SRC,
				primaryTitle: dojo.string.substitute(this.messages.membersDetailTitle, [
					jazz.util.html.removeScript(member.label)
				]),
				trim: SB_TrimStyles.EDITOR_FOCUS,
				onClose: dojo.hitch(this, this._closeUserDetails, row, newRow)
			});
			
			row[ROW_MEMBER_DETAIL_WIDGET_PROP] = memberDetailsBox.id;
			
			if (this._dirtyUsers[userUri] && dojo.indexOf(this._dirtyUsers[userUri], "_displayUserDetails") === -1){ //$NON-NLS-1$
				this._dirtyUsers[userUri].push("_displayUserDetails"); //$NON-NLS-1$
			} else if (!this._dirtyUsers[userUri]){
				this._dirtyUsers[userUri] = ["_displayUserDetails"] //$NON-NLS-1$
			}
			
			dojo.addClass(row, "double-row"); //$NON-NLS-1$
			dojo.addClass(row, "no-fill"); //$NON-NLS-1$
			dojo.addClass(newRow, "no-fill"); //$NON-NLS-1$
			dojo.place(memberDetailsBox.domNode, newCol);
		} else if (!this.expandDetails){
			//if we are allowed to close details, 
			//close the details widget and destory it
			
			var memberDetailsWidgetId = row[ROW_MEMBER_DETAIL_WIDGET_PROP];
			var memberDetailsWidget = dijit.byId(memberDetailsWidgetId);
			if (memberDetailsWidget){
				memberDetailsWidget.close();
			}
			
			if (this._dirtyUsers[userUri].length > 1){
				var i = dojo.indexOf(this._dirtyUsers[userUri], "_displayUserDetails"); //$NON-NLS-1$
				this._dirtyUsers[userUri].splice(i, 1);
			} else {
				delete this._dirtyUsers[userUri];
			}
		}
	},
	
	_closeUserDetails: function(memberRow, detailsRow){
		dojo.destroy(detailsRow);
		dojo.removeClass(memberRow, "double-row"); //$NON-NLS-1$
		dojo.removeClass(memberRow, "no-fill");	 //$NON-NLS-1$
		var simpleToolbarId = memberRow[ROW_BUTTONS_PROP];
		var simpleToolbar = dijit.byId(simpleToolbarId);
		
		var displayUserButton = this._getSimpleTbButton({
			row: memberRow,
			buttonId: "displayUser" //$NON-NLS-1$
		});
		
		if (displayUserButton.pressed){
			displayUserButton.set("pressed", false); //$NON-NLS-1$
		}
		
	},
	
	_getSimpleTbButton: function(args){
		var row = args.row;
		var buttonId = args.buttonId
		var simpleTbId = row[ROW_BUTTONS_PROP];
		var simpleTb = dijit.byId(simpleTbId);
		var id = simpleTbId+buttonId;
		
		return this._simpleTbButtonMap[id];
	},
	
	/*
	 * ================
	 * Event Handlers
	 * ================
	 */
	
	_onMouseClick: function(e){
	},
	
	_connectMemberDetailsAction: function(divNode, rowNode) {
		for(var i=0; i<divNode.children.length; ++i) {
			if (divNode.children[i] && divNode.children[i].tagName == "A") { //$NON-NLS-1$
				divNode.children[i].onclick = dojo.hitch(this, function(event) {
					dojo.stopEvent(event);
					var displayButton = this._getSimpleTbButton({
						row: rowNode,
						buttonId: "displayUser" //$NON-NLS-1$
					});
					
					if (!displayButton.pressed) {
						displayButton.set("pressed", true); //$NON-NLS-1$
						this._displayUserDetails(rowNode);
					}
				})
				break;
			}
		}
	}
});

})();
