/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.lpa.app.ui.internal.ProjectEditor"); //$NON-NLS-1$

dojo.require("com.ibm.team.lpa.app.client.LifecycleProjectAdminClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.app.ui.internal.ContextDetailsWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.app.ui.internal.ContextPickerDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.common.internal.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.common.ui.FileUploadDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.common.ui.MonitoredTaskProgressWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.common.JobMonitor"); //$NON-NLS-1$

dojo.require("dojo.html"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

dojo.require("dijit._TemplatedMixin"); //$NON-NLS-1$
dojo.require("dijit._WidgetsInTemplateMixin"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._BidiSupport"); //$NON-NLS-1$

dojo.require("jazz.app.i18n");  //$NON-NLS-1$
dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("jazz.ui.internal.TruncatedTextNode"); //$NON-NLS-1$

dojo.require("jazz.util.html"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.lpa.app.ui.internal", "ProjectEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var htmlEncode = com.ibm.team.lpa.common.internal.util.htmlEncode;
var LifecycleProjectAdminClient = com.ibm.team.lpa.app.client.LifecycleProjectAdminClient;
var ContextPicker = com.ibm.team.lpa.app.ui.internal.ContextPickerDialog;
var BreadCrumbs = jazz.ui.Breadcrumbs;
var MessageBox = jazz.ui.MessageBox;
var ResourceLink = jazz.ui.ResourceLink;
var StyledTable = jazz.ui.StyledTable;
var Toolbar = jazz.ui.Toolbar;
var Button = jazz.ui.toolbar.Button;
var JobMonitor = com.ibm.team.lpa.common.JobMonitor;
var MonitoredTaskProgressWidget = com.ibm.team.lpa.common.ui.MonitoredTaskProgressWidget;
var TruncatedTextNode = jazz.ui.internal.TruncatedTextNode;

//
// Topics
//
var TOPIC_DISPLAY_MSG = "com.ibm.team.lpa.app.ui.internal.ProjectEditor#message"; //$NON-NLS-1$
var TOPIC_CHECK_FOR_CHANGE = "com.ibm.team.lpa.app.ui.internal.ProjectEditor#checkForChange"; //$NON-NLS-1$

//
// Node Properties
//
var ROW_APP_PROP = "_jazzApplications"; //$NON-NLS-1$
var ROW_DOMAIN_PROP = "_jazzDomains"; //$NON-NLS-1$
var ROW_CONTEXT_PROP = "_jazzContextIds"; //$NON-NLS-1$
var ROW_BUTTONS_PROP = "_jazzRowButtons"; //$NON-NLS-1$
var ROW_CONTAINER_URI_PROP = "_jazzArtifactContainerId"; //$NON-NLS-1$
var ROW_NEW_CONTAINER_URI_PROP = "_jazzNewArtifactContainerId"; //$NON-NLS-1$

//
// Constants
//
var CONTAINER_PROP = "artifactContainers"; //$NON-NLS-1$

//
// RDF Names
//
var RDF_SYNTAX_TYPE_URI = "http://www.w3.org/1999/02/22-rdf-syntax-ns#type"; //$NON-NLS-1$
var LPA_APPLICATION_URI = "http://jazz.net/xmlns/foundation/lpa/1.0/Application"; //$NON-NLS-1$
var LPA_DOMAIN_URI = "http://jazz.net/xmlns/foundation/lpa/1.0/domain"; //$NON-NLS-1$
var DC_TITLE = "http://purl.org/dc/terms/title"; //$NON-NLS-1$

//
// Graphic URI Paths
//
var GRAPHICS_FOLDER = "ui/graphics/"; //$NON-NLS-1$
var GRAPHICS_ICONS_FOLDER = GRAPHICS_FOLDER + "icons/"; //$NON-NLS-1$

var ERROR_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "error_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var DELETE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "delete_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var RESTORE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "restore_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var PROJECT_ICON_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "lpa-proj_obj32.png"); //$NON-NLS-1$ //$NON-NLS-2$
var REFRESH_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "refresh_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var REMOVE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "remove_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var CLOSED_TWISTIE_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "closed-twistie.png"); //$NON-NLS-1$ //$NON-NLS-2$
var OPEN_TWISTIE_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "open-twistie.png"); //$NON-NLS-1$ //$NON-NLS-2$
var TREE_ARROW_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "tree-arrow.png"); //$NON-NLS-1$ //$NON-NLS-2$
var CHANGE_CONTAINER_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "change-proj_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$


function makeRemoteCall(dfd, callback, errback) {
	dfd.addBoth(function(result) {
		if(result instanceof Error) {
			if (errback) {
				errback(result.jfsHttpException.message, dfd.ioArgs.xhr);
			} else {
				defaultHandleError(result.jfsHttpException.message, result.jfsHttpException.msgType);
			}
		} else {
			callback(result, dfd.ioArgs.xhr);
		}
	});
}

function defaultHandleError(message, msgType) {
	dojo.publish(TOPIC_DISPLAY_MSG, [{
		content: message, 
		type: (msgType && msgType === "info") ? MessageBox.STATUS_TYPES.INFO : MessageBox.STATUS_TYPES.ERROR //$NON-NLS-1$
	}]);
}

function getElement(e, tagName){
	var element= e.target || e.srcElement;
	return getParentElement(element, tagName);
}

function getParentElement(node, tagName){
	var element = node;
	while(element && element.tagName !== tagName){
		element = element.parentNode;
	}
	
	return element || null;
}

dojo.declare("com.ibm.team.lpa.app.ui.internal.ProjectEditor", [dijit._Widget, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], { //$NON-NLS-1$
	
	templatePath: dojo.moduleUrl("com.ibm.team.lpa.app","ui/internal/templates/ProjectEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.lpa.app.ui.internal", "ProjectEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._refreshIconSrc = REFRESH_IMG_SRC;
		
		this._projectIconSrc = PROJECT_ICON_SRC;
		
		this._isEditMode = true;
		if (dojo.hash().indexOf("/projects/new") >= 0){ //$NON-NLS-1$
			this._isEditMode = false;
		}
		
		this._blockSaveAction = true;
		this._templateMap = {};
		this._domainObjMap = {};
		this._applicationMap = {};
		this._containersToLink = {}; //used to track containers that will be linked to the lifecycle project
		this._allContainersRegistered = true;

		// properties used to track references that need to be destroyed on table destruction
		this._childrenWidgets = [];
	},
	
	buildRendering: function() {
		this.inherited(arguments);
	},
	
	postCreate: function() {
		if (!this.textDir)
			this.textDir = jazz.app.i18n.getPreferredBaseTextDir();
		this._breadcrumbs = new BreadCrumbs({
			segments: [{
					label: this.messages.allProjects, 
					href: net.jazz.ajax._contextRoot + "/lpa/projects" //$NON-NLS-1$
			}]
		}, this._breadcrumbNode);
		
		this.subscribe(TOPIC_DISPLAY_MSG, "displayMessage"); //$NON-NLS-1$
		this.subscribe(TOPIC_CHECK_FOR_CHANGE, "_checkForChange"); //$NON-NLS-1$
		this.connect(this.ProjectNameInput, "onkeyup", "handleChange");
		this.connect(this.descriptionInput, "onkeyup", "handleChange");
		this.refresh();
	},
	
	handleChange: function (e) {
		if (this.textDir == "auto") {
			this.applyTextDir(e.target, e.target.value);
		}
	},
	
	refresh: function(){
		window.onbeforeunload = null;
		this._isSaving = false;
		this._blockSaveAction = true;
		this._makeReadOnly();
		com.ibm.team.lpa.common.internal.util.checkAuth(this.messageBox, dojo.hitch(this, function(response) {
			if (response === 1){
				this._blockSaveAction = false;
			}
		}));
		
		//reset the UI's state
		this._domainObjMap = {};
		this._applicationMap = {};
		this._containersToLink = {};
		
		//build the dynamic elements
		this._buildDomainsMap();
		
		if (this._isEditMode){
			this._setToEditProjectMode();
			
			this.displayMessage({
				content: this.messages.loading,
				type: MessageBox.STATUS_TYPES.INFO,
				closable: false
			});
			
			this._createCurrentContainerTable();
			this._loadProject();
		} else {
			this._appMapBuilt = false;
			this._triggerTemplateChangeNeeded = false;
			this._hideMessages();	
			this._setToNewProjectMode();
			this._buildApplicationsMap();
			this._getTemplates();
			setTimeout(dojo.hitch(this, function() {
				this._showProjectNameEdit();
			}));
		}
		
		this._createAdditionalContainerTable();
	},
	
	beforeUnloadMsg: function(){
		if (this._checkForChange()){
			return this.messages.unloadMsg;
		}
	},
	
	//******************************
	// Refresh UI Helper Methods - Edit Project
	//******************************
	
	_buildDomainsMap: function(){
		this._makeRemoteCall(LifecycleProjectAdminClient.getDomains(), function(result){
			dojo.forEach(result, dojo.hitch(this, function(domain){
				this._domainObjMap[domain.uri] = domain;
			}));
		});
	},
	
	_setToEditProjectMode: function(){
		dojo.removeClass(this.refreshButton, "hide"); //$NON-NLS-1$
		dojo.removeClass(this._editModeArea, "hide"); //$NON-NLS-1$
		dojo.attr(this._projectMembersLink, "href", net.jazz.ajax._contextRoot + "/lpa/members/"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.attr(this._projectConfigLink, "href", net.jazz.ajax._contextRoot + "/lifecycle-project/configs"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_createCurrentContainerTable: function(){
		if (!this._curContainerTable){
			var titleNode = dojo.create("div", {});	 //$NON-NLS-1$
		
			//create the Table's title
			dojo.create("span", { //$NON-NLS-1$
				innerHTML: this.messages.configuredDomains,
				className: "tableTitle" //$NON-NLS-1$
			}, titleNode);
			
			this._curContainerTable = new com.ibm.team.lpa.app.ui.internal.ContainerLinksTable({
				heading: titleNode,
				_curContainers: this._containersToLink,
				isAdditionalTable: false
			}, this._projectContainersNode);
			this._childrenWidgets.push(this._curContainerTable);
		} else {
			this._curContainerTable.refresh();
			this._curContainerTable.set("_curContainers", this._containersToLink); //$NON-NLS-1$
		}
	},
	
	onUpdateProjectConfig: function(event) {
		if (event) dojo.stopEvent(event);
		new com.ibm.team.lpa.common.ui.FileUploadDialog({
			title: this.messages.updateProjectConfigDialogTitle,
			onUpload: dojo.hitch(this, function(args) {
				switch(args.statusCode) {
					case 200:
					case 201:
						var summary = this.messages.updateProjectConfigSuccess;
					    var type = "OK"; //$NON-NLS-1$
						break;
					default:
						summary = dojo.string.substitute(this.messages.updateProjectConfigError, [args.statusCode, args.reasonPhrase]); 
						type = "ERROR"; //$NON-NLS-1$
				}
				this.messageBox.showMessage({
					summary: summary,
					type: MessageBox.STATUS_TYPES[type],
					closable: true
				});
			}),
			uri: this._projectConfigLink.href
		});
	},
	
	_loadProject: function(){
		var pathArr = dojo.hash().split("?")[0].split("/"); //$NON-NLS-1$ //$NON-NLS-2$
		var projectId = pathArr[3];
		var projectName = pathArr[4];
		var projectUriParam = com.ibm.team.lpa._projectsService + "/" + projectId; //$NON-NLS-1$
		
		//update members page link
		var membersPageLink = net.jazz.ajax._contextRoot + "/lpa/members#project=" + projectId; //$NON-NLS-1$
		dojo.attr(this._projectMembersLink, "href", membersPageLink); //$NON-NLS-1$
		
		//update project config link
		var projectConfigLink = net.jazz.ajax._contextRoot + "/lifecycle-project/configs?project=" + encodeURIComponent(projectUriParam); //$NON-NLS-1$
		if (projectName) {
			projectConfigLink += "&projectName=" + projectName; //$NON-NLS-1$
		}
		dojo.attr(this._projectConfigLink, "href", projectConfigLink); //$NON-NLS-1$
		
		this._makeRemoteCall(LifecycleProjectAdminClient.getProject(projectUriParam), dojo.hitch(this, function(result){
			this._project = result;
			
			this._setProjectTitle(this._project.label);
			this._descriptionInput.value = this._project.description;
			this.applyTextDir(this._descriptionInput, this._descriptionInput.value);
			
			this._createCurrentContainerTable();
			
			var contexts = this._project.contexts;
			if (contexts.length > 0){
				this._curContainerTable.clearBody();
				dojo.forEach(contexts, dojo.hitch(this, function(container){
					this._curContainerTable.addContainerLink(container);
				}));
			}
			
			this._hideMessages();
			this._showProjectNameEdit();
			this._projectNameInput.setSelectionRange(this._projectNameInput.value.length, this._projectNameInput.value.length);
		}));
	},
	
	//******************************
	// Refresh UI Helper Methods - Create Project
	//******************************
	
	_setToNewProjectMode: function(){
		this._templateMap = {};
		
		this._clearTemplateContainers();
		dojo.removeClass(this._templateContainersTable, "hide"); //$NON-NLS-1$
		dojo.removeClass(this._templatePickerArea, "hide"); //$NON-NLS-1$
		dojo.removeClass(this._languagePickerArea, "hide"); //$NON-NLS-1$
		
		this._setProjectTitle(this.messages.projectNameLabel);
		this._descriptionInput.value = ""; //$NON-NLS-1$
		
		this._allContainersRegistered = true;
	},
	
	_buildApplicationsMap: function(){
		this._makeRemoteCall(LifecycleProjectAdminClient.getApplications(), function(applications){
			for (var subjectUri in applications) {
				var subject = applications[subjectUri];
				var type = subject[RDF_SYNTAX_TYPE_URI][0].value;
				
				if (LPA_APPLICATION_URI === type) {//is the current subject an LPA application?
					if (this._applicationMap[subjectUri]){
						//if we have a duplicate application, append the URI to the display name
						this._applicationMap[subjectUri].displayName += "(" + uri + ")" //$NON-NLS-1$ //$NON-NLS-2$
					} else {
						//add the application to the map
						var title = subject[DC_TITLE][0].value;
						var domain = subject[LPA_DOMAIN_URI][0].value;
						var uri = subjectUri.replace("/rootservices", ""); //$NON-NLS-1$ //$NON-NLS-2$
						
						var app = {
							displayName: title,
							domain: domain,
							label: title,
							uri: uri
						};
						this._applicationMap[subjectUri] = app;
					}
				}
			} // end loop
			this._appMapBuilt = true;
			if (this._triggerTemplateChangeNeeded) {
				this.onTemplateChange();
			}
		});
	},
	
	//
	// Retrieve a list of templates loaded to the LPA server and display them
	// in the template dropdown for the user.
	//
	_getTemplates: function(){
		var messages = this.messages;
		
		var loadingMsg = messages.loading;
		dojo.empty(this._templateSelect);
		dojo.create("option", { //$NON-NLS-1$
			innerHTML: loadingMsg,
			value: -1
		}, this._templateSelect);
		
		dojo.empty(this._languageSelect);
		dojo.create("option", { //$NON-NLS-1$
			innerHTML: loadingMsg,
			value: -1
		}, this._languageSelect);
		
		this._makeRemoteCall(LifecycleProjectAdminClient.getTemplates(), function(result){
			dojo.empty(this._templateSelect);
			
			if (result.length === 0) {
				this.displayMessage({
					content: dojo.string.substitute(messages.noTemplatesErrorMsg, [net.jazz.ajax._contextRoot + "/lpa/templates"]), //$NON-NLS-1$
					type: MessageBox.STATUS_TYPES.ERROR
				});
			} else {
				
				if (result[0]){
					this._updateTemplateDescription(result[0]);
					dojo.removeClass(this._showMoreBtn, "hide"); //$NON-NLS-1$
				} else {
					this._templateDescTrunc.innerHTML = messages.noTemplateUA;
					this._templateDescFull.innerHTML = messages.noTemplateUA;
				}
				
				var templateId = this._getQueryStringValue("template"); //$NON-NLS-1$
				
				//If a template is not specified as a query parameter to
				//use by default, we want to initially select the first
				//template in the list for which an application is available
				//for every domain in the template. (This will be the
				//template 'Empty Lifecycle Project' if there are no
				//other templates that meet this condition)
				var defaultTemplateSelected = false;
				var allApplicationsAvailable = dojo.hitch(this, function(template) {
					var allAppsAvailable = true;
					if (template[CONTAINER_PROP]) {
						var artifactContainers = template[CONTAINER_PROP];
						for (var i = 0; i < artifactContainers.length && allAppsAvailable; i++) {
							var domainObj = this._domainObjMap[artifactContainers[i].domain];
							var applications = this._getApplicationByDomain(domainObj.uri);
							allAppsAvailable = applications.length !== 0;
						}
					}
					return allAppsAvailable;
				});
				
				dojo.forEach(result, dojo.hitch(this, function(template){
					this._templateMap[template.id] = template;
					
					var option = dojo.create("option", { //$NON-NLS-1$
						value: template.id,
						innerHTML: jazz.util.html.escape(template.title)
					}, this._templateSelect);		
					
					if (templateId == template.id){
						dojo.attr(option, "selected", true); //$NON-NLS-1$
					} else if (templateId === undefined && !defaultTemplateSelected) {
						if (allApplicationsAvailable(template)) {
							dojo.attr(option, "selected", true); //$NON-NLS-1$
							defaultTemplateSelected = true;
						}
					}
				}));
				
				if (this._appMapBuilt) {
					this.onTemplateChange();
				} else {
					this._triggerTemplateChangeNeeded = true;
				}
			}
		});
	},
	
	//******************************
	// Refresh UI Helper Methods
	//******************************
	
	_createAdditionalContainerTable: function(){
		if (!this._addTable){
			var titleNode = dojo.create("div", {}); //$NON-NLS-1$
		
			//create the Table's title
			dojo.create("span", { //$NON-NLS-1$
				innerHTML: this.messages.additionalDomains,
				className: "tableTitle" //$NON-NLS-1$
			}, titleNode);
			
			//create the "Add..." button
			dojo.create("a", { //$NON-NLS-1$
				innerHTML: this.messages.add,
				className: "addAnchor", //$NON-NLS-1$
				href: "#" //$NON-NLS-1$
			}, titleNode);
			
			this._addTable = new com.ibm.team.lpa.app.ui.internal.ContainerLinksTable({
				heading: titleNode,
				_curContainers: this._containersToLink,
				isAdditionalTable: true
			}, this._addContainersNode);
			this._childrenWidgets.push(this._addTable);
		} else {
			this._addTable.refresh();
			this._addTable.set("_curContainers", this._containersToLink); //$NON-NLS-1$
		}
		
	},
	
	//******************************
	// Project Saving Methods
	//******************************
	
	onSave: function(){
		if (!this._blockSaveAction){
			this._makeReadOnly();
			this.displayMessage({
				content: this.messages.saving,
				type: MessageBox.STATUS_TYPES.INFO,
				closable: false
			});
			
			if (this._isEditMode){
				this._updateProject();
			} else {
				if (this._allContainersRegistered){
					this._isSaving = true;
					this._createNewProject();
				} else {
					this.displayMessage({
						content: this.messages.registerApplicationsError,
						type: MessageBox.STATUS_TYPES.ERROR,
						closable: true
					});
				}
			}
		}
		
		
		return;
	},
	
	_updateProject: function(){
		var reqContainerUris = [];
		
		//determine the current project containers that need to be removed
		var curContainers = this._curContainerTable.getContainers();
		var containersToRemove = this._curContainerTable.getContainersToRemove();
		for (uri in curContainers){
			if (!containersToRemove[uri]) {
				reqContainerUris.push({
					uri: uri
				});
			}
		}
		
		//determine the containers that get added because they "changed" an original container
		var containersToChange = this._curContainerTable.getContainersToAdd();
		for (uri in containersToChange){
			reqContainerUris.push({
				uri: uri
			});
		}
		
		//get the new containers to add to the project
		var additionalContainers = this._addTable.getContainers();
		for (uri in additionalContainers){
			reqContainerUris.push({
				uri: uri
			});
		}
		
		this._updateForSaving(true);
		
		this._makeRemoteCall(LifecycleProjectAdminClient.updateProject(this._project.uri, {
			title: this._projectNameInput.value,
			description: this._descriptionInput.value,
			contexts: reqContainerUris
		}),
		function(result){
			this._updateForSaving(false);
			this.refresh();
		}, function(message, xhr) {
			this._updateForSaving(false);
			defaultHandleError(message, "error"); //$NON-NLS-1$
		});
	},
	
	_createNewProject: function(){
		//build the request
		var templateId = this._templateSelect.value;
		
		var requestParams = {
			projectName: this._projectNameInput.value,
			lpaProjectDescription: this._descriptionInput.value
		};
		var artifactContainers = this._getTemplateContainerLinksRequestObj();
		
		this._updateForSaving(true);
		
		//make the request
		this._makeRemoteCall(
			LifecycleProjectAdminClient.postTemplate(
				templateId, 
				requestParams, 
				artifactContainers
			), function(result, ioargs){
				this._hideMessages();
				this._onCreateFromTemplateSuccess({
					location: ioargs.getResponseHeader("Location") //$NON-NLS-1$
				});
			}, function(message, xhr) {
				this._updateForSaving(false);
				defaultHandleError(message, "error"); //$NON-NLS-1$
			}
		);
	},
	
	_updateForSaving: function(isSaving) {
		dojo.query("input, select, textarea", this._projectEditorRoot).forEach(function(node, index, arr) { //$NON-NLS-1$
			node.disabled = isSaving;
		});
	},
	
	_getTemplateContainerLinksRequestObj: function(){
		//reset state from previous template
		
		var localeId = this._languageSelect.value;
		var request = [];
		dojo.query(".templateContainerRow", this.templateContainersTbody).forEach(dojo.hitch(this, function(row){ //$NON-NLS-1$
			var containerId = row[ROW_CONTEXT_PROP];
			
			var applicationUri = ""; //$NON-NLS-1$
			var domainUri = row[ROW_APP_PROP];
			var appSelect = dojo.query("SPAN[name=" + domainUri + "] select", row)[0]; //$NON-NLS-2$ //$NON-NLS-1$
			var appLabel = ""; //$NON-NLS-1$
			
			if (appSelect){
				 applicationUri = appSelect.value;
				 appLabel = this._getApplicationByUri(applicationUri).label;
			} else {
				var application = this._getApplicationByDomain(domainUri)[0];
				applicationUri = application.uri;
				appLabel = application.label;
			}
			var obj = {
				id: containerId,
				locale: localeId,
				applicationUrl: applicationUri,
				applicationTitle: appLabel
			};	
			
			var projectInput = dojo.query(".toBeCreatedInput", row)[0]; //$NON-NLS-1$
			var processTemplateSelect = dojo.query(".processTemplatesSelect", row)[0]; //$NON-NLS-1$
			var projectTemplateSelect = dojo.query(".projectTemplatesSelect", row)[0]; //$NON-NLS-1$
			
			if(dojo.hasClass(projectInput, "hide")){ //$NON-NLS-1$
				var containerAnchor = dojo.query(".jazz-ui-ResourceLink", row)[0]; //$NON-NLS-1$
				var containerLink = dijit.byId(containerAnchor.id);
				
				obj.projectId = containerLink.label;
			} else {
				obj.name = projectInput.value;
				obj.processTemplate = processTemplateSelect.value;
				if (projectTemplateSelect) {
					obj.projectTemplate = projectTemplateSelect.value;
				}
			}
			
			request.push(obj);
		}));
		
		return request;
	},
	
	_onCreateFromTemplateSuccess: function(args){
		var location = args.location;
		
		var monitor = new JobMonitor({
			uri: location
		});
		monitor.addListener(dojo.hitch(this, this._monitorCb));
		
		var projectName = jazz.util.html.escape(this._projectNameInput.value);
		var templateCreationMessageBox = new MonitoredTaskProgressWidget({
			monitor: monitor,
			inProgressMessage: document.createTextNode(dojo.string.substitute(this.messages.createFromTemplateInProgress, [projectName])),
			failureMessage: document.createTextNode(dojo.string.substitute(this.messages.createFromTemplateFailure, [projectName])),
			successMessage: document.createTextNode(dojo.string.substitute(this.messages.createFromTemplateSuccess, [projectName]))
		});
		dojo.place(templateCreationMessageBox.domNode, this.messageArea, "only"); //$NON-NLS-1$
		dojo.removeClass(this.messageArea, "hide"); //$NON-NLS-1$
	},
	
	_monitorCb: function(job){
		if (job.state === "FINISHED") { //$NON-NLS-1$
				this._updateForSaving(false);
				
				//this.deploymentRunning = false;
				if (job.resolution === "SUCCESS") { //$NON-NLS-1$
					//this.newProject = null;
					//this.projectWidget.isDirty = false;
					this._hideMessages();
					dojo.empty(this.messageArea);
					
					var result = dojo.fromJson(job.resultMessage);
					if (result.lpaProjects && result.lpaProjects.length > 0) {
						var projectUri = result.lpaProjects[0].link;
						var projectUriParts = projectUri.split("/"); //$NON-NLS-1$
						var projectId = projectUriParts[projectUriParts.length - 1];
						var encodedLocation = projectId + "/" + encodeURIComponent(result.lpaProjects[0].name); //$NON-NLS-1$
						this.displayMessage({
							content: this.messages.loading,
							type: MessageBox.STATUS_TYPES.INFO,
							closable: false
						});	
						
						this._makeRemoteCall(LifecycleProjectAdminClient.getProject(projectUri), function(project){
							var reqContainerUris = [];
							var containers = project.contexts;
							dojo.forEach(containers, dojo.hitch(this, function(container){
								reqContainerUris.push({
									uri: container.uri
								});
							}))
							
							var additionalContainers = this._addTable.getContainers();
							for (uri in additionalContainers){
								reqContainerUris.push({
									uri: uri
								});
							}
							this._makeRemoteCall(LifecycleProjectAdminClient.updateProject(project.uri, {
								title: project.label,
								description: project.description,
								contexts: reqContainerUris
							}), function(result){
								dojo.hash("/projects/edit/" + encodedLocation); //$NON-NLS-1$
							});
						});
					} else {
						dojo.hash("/projects"); //$NON-NLS-1$
					}
				} else if (job.resolution === "FAILURE") { //$NON-NLS-1$
					this.saveButton.disabled = false;
					this._isSaving = false;
				} else if (job.resolution === "ERROR") { //$NON-NLS-1$
					var msg;
					if (job.resultMessage) {
						msg = dojo.string.substitute(this.messages.creatingFromTemplateError, [ job.resultMessage ]);
					}
					else {
						msg = this.messages.creatingFromTemplateErrorGeneric;
					}
					
					// Only hide the steps if prevalidation fails.  Otherwise,
					// let the user see where creation failed so they can take
					// steps to recover.
					if (!job.steps || !job.steps[0] || job.steps[0].resolution !== "SUCCESS") { //$NON-NLS-1$
						this._hideMessages();
						dojo.empty(this.messageArea);
					}
					this.saveButton.disabled = false;
					this._isSaving = false;
					
					this.displayMessage({
						content: msg,
						type: MessageBox.STATUS_TYPES.ERROR,
						closable: false,
						errorDetails: job.result
					});
				}
			}
	},	
	
	//******************************
	// MessageBox Management
	//******************************
	displayMessage: function(args) {
		var closable = args.closable;
		var content = args.content;
		var type = args.type;
		var detailObj = args.errorDetails;
		
		var errorDetail;
		if (detailObj) {
				var detailJson = dojo.fromJson(detailObj);
				
				//Error Response
				if (detailJson && detailJson.response) {
					errorDetail = ""; //$NON-NLS-1$
					errorDetail += "<p><strong>"; //$NON-NLS-1$
					errorDetail += this.messages.response;
					errorDetail += "</strong></p>"; //$NON-NLS-1$
					errorDetail += "<p>"; //$NON-NLS-1$
					
					var formattedResponse= detailJson.response.replace(/<\/?[^>]+(>|$)/g, " "); //$NON-NLS-1$
					formattedResponse= jazz.util.html.escape(formattedResponse);
					formattedResponse = formattedResponse.replace(/\r\n/g, "<br />"); //$NON-NLS-1$
					formattedResponse = formattedResponse.replace(/\n/g, "<br />"); //$NON-NLS-1$
					
					errorDetail += formattedResponse;
					errorDetail += "</p>"; //$NON-NLS-1$
				}
				
				//Error Stacktrace
				if (detailJson && detailJson.stacktrace) {
					if (!errorDetail)
						errorDetail = ""; //$NON-NLS-1$
					errorDetail += "<p><strong>"; //$NON-NLS-1$
					errorDetail += this.messages.stacktrace;
					errorDetail += "</strong></p>"; //$NON-NLS-1$
					errorDetail += "<p>"; //$NON-NLS-1$
					
					var formattedStacktrace= jazz.util.html.escape(detailJson.stacktrace);
					formattedStacktrace = formattedStacktrace.replace(/\r\n/g, "<br />"); //$NON-NLS-1$
					formattedStacktrace = formattedStacktrace.replace(/\n/g, "<br />"); //$NON-NLS-1$
					
					errorDetail += formattedStacktrace;
					errorDetail += "</p>"; //$NON-NLS-1$
				}
		}
		
		var isClosable = (closable) ? closable : true;
		
		if (!errorDetail) {
			this.messageBox.showMessage({
				closable: isClosable,
				summary: content,
				type: type
			});
		} else {
			this.messageBox.showMessage({
				closable: isClosable,
				summary: content,
				type: type,
				details : [ {message: errorDetail, code: MessageBox.STATUS_TYPES.ERROR} ]
			});
		}
	},

	_hideMessages: function() {
		this.messageBox.hideMessage();
		dojo.addClass(this.messageArea, "hide"); //$NON-NLS-1$
	},
	
	
	//******************************
	// Util Functions
	//******************************
	
	onToggleFullTemplateDescription: function(e){
		dojo.stopEvent(e);
		
		if (dojo.hasClass(this._templateDescFull, "hide")){ //$NON-NLS-1$
			dojo.addClass(this._templateDescTrunc, "hide"); //$NON-NLS-1$
			dojo.addClass(this._showMoreBtn, "hide"); //$NON-NLS-1$
			
			dojo.removeClass(this._templateDescFull, "hide"); //$NON-NLS-1$
			dojo.removeClass(this._showLessBtn, "hide"); //$NON-NLS-1$
		} else {
			dojo.removeClass(this._templateDescTrunc, "hide"); //$NON-NLS-1$
			dojo.removeClass(this._showMoreBtn, "hide"); //$NON-NLS-1$
			
			dojo.addClass(this._templateDescFull, "hide"); //$NON-NLS-1$
			dojo.addClass(this._showLessBtn, "hide"); //$NON-NLS-1$
		}
	},
	
	_updateTemplateDescription: function(template){
		var description = template.description;
		this._templateDescFull.innerHTML = jazz.util.html.escape(description);
		
		if (this._truncatedNode) {
			this._truncatedNode.attr("value", template.description);	 //$NON-NLS-1$
		} else {
			var tn = this._truncatedNode = new jazz.ui.internal.TruncatedTextNode({value: template.description});
			tn.placeAt(this._templateDescTrunc);
			dojo.addClass(tn.domNode, "truncated"); //$NON-NLS-1$
			setTimeout(dojo.hitch(this, function(tn) {
				tn.startup();
			}, tn), 0);
		}
	},
	
	//
	// Determines if the user has made any changes to the attributes of 
	// the project. If they are creating a new project, just check if the 
	// project title was changed. If they are editing a project, check all
	// of the project attributes
	//
	_checkForChange: function(){
		var isChanged = false;
		var isContainerChange = false;
		var isProjectNameValid = false;
		
		if (!this._isEditMode){
			if (!this._isSaving && (this._projectNameInput.value !== this.messages.projectNameLabel)){
				isChanged = true;
			}
		} else {
			if (this._project.label !== this._projectNameInput.value) {
				isChanged = true;
			}
			
			if (this._project.description !== this._descriptionInput.value) {
				isChanged = true;
			}
			
			var containersToChange = this._curContainerTable.getContainersToAdd();
			for (id in containersToChange){
				if (containersToChange[id]) {
					isChanged = true;
					isContainerChange = true;
					break;
				}
			}
			
			var containersToRemove = this._curContainerTable.getContainersToRemove();
			for (id in containersToRemove){
				if (containersToRemove[id]) {
					isChanged = true;
					isContainerChange = true;
					break;
				}
			}
			
			var containersToAdd = this._addTable.getContainers();
			for (id in containersToAdd){
				if (containersToAdd[id]) {
					isChanged = true;
					break;
				}
			}
			
			if (isContainerChange){
				this.displayMessage({
					content: this.messages.projectChangeWarning,
					type: MessageBox.STATUS_TYPES.WARNING
				});
			} else {
				this._hideMessages();
			}
		}
		
		// validate project name
		if (this._projectNameInput.value && this._projectNameInput.value.indexOf("/") !== -1) { //$NON-NLS-1$
			isProjectNameValid = false;
			this.displayMessage({
				content: this.messages.containSlashError,
				type: MessageBox.STATUS_TYPES.ERROR,
				closable: true
			});
		} else {
			isProjectNameValid = true;
			if (!isContainerChange) {
				// if container changed, a warning message should be displayed
				// so here we shouldn't hide that warning in that case
				this._hideMessages();
			}
		}

		if (isChanged && this._allContainersRegistered && isProjectNameValid) {
			this._makeSavable();
		} else {
			this._makeReadOnly();
		}
		
		return isChanged;
	},
	
	//
	// Empties the Template Container table of its rows and displays the default
	// string for the empty table 
	//
	_clearTemplateContainers: function(){
		dojo.empty(this._templateContainersTbody);
		this._containerCountNode.innerHTML = "(0)"; //$NON-NLS-1$
		var tr = dojo.create("tr", { //$NON-NLS-1$
			className: "emptytemplateContainerRow" //$NON-NLS-1$
		}, this._templateContainersTbody);
		
		dojo.create("td", { //$NON-NLS-1$
			className: "j-hint noTemplateContainersCol", //$NON-NLS-1$
			colSpan: 4,
			innerHTML: this.messages.noTemplateDomains
		}, tr);
	},
	
	//
	// get an application object by searching the available
	// applications by their domain.
	//
	_getApplicationByDomain: function(domainUri){
		var applications = this._applicationMap;
		var apps = [];
		for(appUri in applications){
			if (applications[appUri].domain === domainUri){
				apps.push(applications[appUri]);
			}
		}
		
		apps.sort(function(a,b){
			var x = a.uri.toLowerCase();
	    	var y = b.uri.toLowerCase();
	   	 	return ((x < y) ? -1 : ((x > y) ? 1 : 0));
		})
		
		return apps;
	},
	
	_getApplicationByUri: function(uri){
		var applications = this._applicationMap;
		var apps = [];
		for(appUri in applications){
			if (applications[appUri].uri === uri){
				return applications[appUri];
			}
		}
		
		return null;
	},
	
	//
	// Retrieve the value of a query param in the URI.
	//
	// Params:
	//  queryVarName (String): the name of the query param to retrieve
	//
	// Return:
	//	a string representing the query param's value.
	//
	_getQueryStringValue: function(queryVarName){
		var queryArr = dojo.hash().split(queryVarName+"="); //$NON-NLS-1$
		return queryArr[1];
	},
	
	
	//
	// Get the current template selected by the user.
	//
	// @return a template object or null if there are no templates
	//
	_getSelectedTemplate: function(){
		var id = this._templateSelect.value;
		
		return this._templateMap[id] || null;
	},
	
	//
	// Get a text node that contains the description of the 
	// chosen template. If there are no templates loaded,
	// provide a message saying so. 
	//
	_getTemplateDescNode: function(args){
		var template = this._getSelectedTemplate();
		
		if(template){
			return document.createTextNode(template.description);
		} 
		
		return document.createTextNode(this.messages.noTemplateUA);
	},
	
	//
	// Wrapper method to make sure the project editor ui is in a state that cannot
	// be saved by the user.
	//
	_makeReadOnly: function() {
		this.readOnly = true;
		this.saveButton.disabled = true;
		dojo.style(this.modifiedFlag, "display", "none"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	//
	// Allows the user to use the UI to save the current state of the project
	//
	_makeSavable: function(){
		this.readOnly = false;
		this.saveButton.disabled = false;
		dojo.style(this.modifiedFlag, "display", "inline"); //$NON-NLS-2$ //$NON-NLS-1$
	},
	
	//
	// Make xhr requests
	// error handling is automatically handled
	//
	_makeRemoteCall: function(dfd, callback, errback) {
		if (errback) {
			makeRemoteCall(dfd, dojo.hitch(this, callback), dojo.hitch(this, errback));
		} else {
			makeRemoteCall(dfd, dojo.hitch(this, callback));
		}
	},
	
	//
	// Updates the project title's UI elements to a new value
	//
	// Params:
	//	projectName - a string representing the new project name
	//
	_setProjectTitle: function(projectName){
		this._projectNamePreview.innerHTML = jazz.util.html.escape(projectName);
		this._projectNamePreview.prevValue = undefined;
		this._projectNameInput.value = projectName;
		this.applyTextDir(this._projectNameInput, this._projectNameInput.value);
		this.applyTextDir(this._projectNamePreview, this._projectNamePreview.innerHTML);
		this._projectNamePreview.style.textAlign = (dojo._isBodyLtr() ? "left" : "right");
	},
	
	//****************************************
	// Event Management for Changing Templates
	//****************************************
	
	onTemplateChange: function(){
		this._hideMessages();
	
		var template = this._getSelectedTemplate();
		
		//reset state from previous template
		this._allContainersRegistered = true;
		var containersToLink = this._containersToLink;
		for(containerId in containersToLink){
			if (!this._containersToLink[containerId].inAddTable){
				delete containersToLink[containerId];
			}
		}
		
		// update the template description area with the new choice	
		if (template){
			this._updateTemplateDescription(template);
		} else {
			this._templateDescTrunc.innerHTML = messages.noTemplateUA;
			this._templateDescFull.innerHTML = messages.noTemplateUA;
		}
		//this._templateDesc.innerHTML = (result[0]) ? jazz.util.html.escape(result[0].description) : messages.noTemplateUA;
		
		this._updateTemplateLanguageSelect({
			locales: template.locales
		});
		
		// update the container editor table
		dojo.empty(this._templateContainersTbody);
		
		if(template[CONTAINER_PROP]){
			var artifactContainers = template[CONTAINER_PROP];
			var acAmount = artifactContainers.length;
			
			this._containerCountNode.innerHTML = "(" + acAmount + ")"; //$NON-NLS-1$ //$NON-NLS-2$

			dojo.forEach(artifactContainers, dojo.hitch(this, function(container) {
				this._addTemplateContainerRow({
					container: container
				});
			}));
			
			dojo.query(".toBeCreatedInput").forEach(dojo.hitch(this, function(input){ //$NON-NLS-1$
				this._updateProjectAssociationLabels(null, {
					projectInputForm: input
				});
			}));
		} else {
			this._containerCountNode.innerHTML = "(0)"; //$NON-NLS-1$
			var tr = dojo.create("tr", { //$NON-NLS-1$
				className: "emptytemplateContainerRow" //$NON-NLS-1$
			}, this._templateContainersTbody);
			
			dojo.create("td", { //$NON-NLS-1$
				className: "j-hint noTemplateContainersCol", //$NON-NLS-1$
				colSpan: 4,
				innerHTML: this.messages.noTemplateDomains
			}, tr);
		}
		
		this._checkForChange();
	},
	
	_updateTemplateLanguageSelect: function(args){
		var locales = args.locales;
		
		dojo.empty(this._languageSelect);
		dojo.forEach(locales, dojo.hitch(this, function(locale){
			var option = dojo.create("option", { //$NON-NLS-1$
				value: locale.id,
				innerHTML: locale.name
			}, this._languageSelect);
			
			if (locale.isClientLocale && locale.isClientLocale === "true"){ //$NON-NLS-1$
				dojo.attr(option, "selected", true); //$NON-NLS-1$
			}
		}));
	},
	
	_addTemplateContainerRow: function(args){
		var container = args.container;
		var domainObj = this._domainObjMap[container.domain];
		var applications = this._getApplicationByDomain(domainObj.uri);
		
		var tr = dojo.create("tr", { //$NON-NLS-1$
			className: "templateContainerRow" //$NON-NLS-1$
		}, this._templateContainersTbody);
		if(applications.length > 0) tr[ROW_APP_PROP] = domainObj.uri;//application.uri;
		tr[ROW_DOMAIN_PROP] = domainObj.uri;
		tr[ROW_CONTEXT_PROP] = container.id;
		
		//
		//create container label column
		//
		var td = dojo.create("td", { //$NON-NLS-1$
			className: "templateContainerLabelCol j-label", //$NON-NLS-1$
			innerHTML: this.messages.createLabel
		}, tr);
		
		//
		//create container details column
		//
		var td = dojo.create("td", { //$NON-NLS-1$
			className: "templateContainerDetailsCol" //$NON-NLS-1$
		}, tr);
		
		//
		//create project name input row of details column
		//
		var toBeCreatedDiv = dojo.create("div", { //$NON-NLS-1$
			className: "toBeCreatedDiv" //$NON-NLS-1$
		}, td);
		
		var toBeCreatedNameInput = dojo.create("input", { //$NON-NLS-1$
			className: "toBeCreatedInput", //$NON-NLS-1$
			'size': "55" //$NON-NLS-1$ //$NON-NLS-2$
		}, toBeCreatedDiv);
		var initialName = this._projectNameInput.value + (container.subject ? " (" + container.subject + ")" : ""); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		toBeCreatedNameInput.value = initialName;
		this.applyTextDir(toBeCreatedNameInput, toBeCreatedNameInput.value);
		this.connect(toBeCreatedNameInput, "onkeyup", this._updateProjectAssociationLabels); //$NON-NLS-1$
		
		//create a span to store the resource link of linked artifact containers
		dojo.create("span", { //$NON-NLS-1$
			className: "artifactContainerLinkSpan hide" //$NON-NLS-1$
		}, toBeCreatedDiv);
		
		//check to see if there is an artifact container, if not then display an error
		var toBeCreatedDetailsLabel = dojo.create("span", { //$NON-NLS-1$
			className: "toBeCreatedDetailsLabel" //$NON-NLS-1$
		}, toBeCreatedDiv);
		
		var appLabel = ""; //$NON-NLS-1$
		if (applications.length === 1) {
			appLabel = "'" + applications[0].label + "'"; //$NON-NLS-1$ //$NON-NLS-2$
			toBeCreatedDetailsLabel.innerHTML = dojo.string.substitute(this.messages.toBeCreatedInputLabel, [domainObj.uri, appLabel, domainObj.label]);
		} else if (applications.length > 1) {
			toBeCreatedDetailsLabel.innerHTML = dojo.string.substitute(this.messages.toBeCreatedInputLabel, [domainObj.uri, "", domainObj.label]); //$NON-NLS-1$
			//get the <span> created as part of setting the innerHTML so we can add select to it
			var innerSpan = dojo.query("SPAN[name=" + domainObj.uri + "]", toBeCreatedDetailsLabel)[0]; //$NON-NLS-1$ //$NON-NLS-2$
			
			var select = dojo.create("select", { //$NON-NLS-1$
				className: "applicationSelect" //$NON-NLS-1$
			}, innerSpan);
			
			dojo.forEach(applications, dojo.hitch(this, function(app){
				var option = dojo.create("option", { //$NON-NLS-1$
					value: app.uri,
					innerHTML: app.label
				}, select);
			}));
		} else {
			this._allContainersRegistered = false;
			this._makeReadOnly();
			appLabel = "<span class='errorText errorImg'>" + this.messages.ApplicationPickerNoApplicationsForTemplateContextBrief + "</span>"; //$NON-NLS-1$ //$NON-NLS-2$
			toBeCreatedDetailsLabel.innerHTML = dojo.string.substitute(this.messages.toBeCreatedInputLabel, ["", appLabel, domainObj.label]); //$NON-NLS-1$
			
			//if there is no application registered, create an HP explaining so
			var template = this._getSelectedTemplate();
			var hp = new jazz.ui.HoverPopup({
				around: dojo.query(".errorText", toBeCreatedDetailsLabel)[0], //$NON-NLS-1$
				html: dojo.string.substitute(this.messages.ApplicationPickerNoApplicationsForTemplateContext, [domainObj.label, template.title])
			});
			
			this._childrenWidgets.push(hp);
			
			this.displayMessage({
				content: this.messages.registerApplicationsError,
				type: MessageBox.STATUS_TYPES.ERROR,
				closable: true
			});
		}
		
		//if there are any association details - display them
		if (container.providesAssociations) {
			var associationList = dojo.create("ul", { //$NON-NLS-1$
				className: "associationList" //$NON-NLS-1$
			}, toBeCreatedDiv);
			
			dojo.forEach(container.providesAssociations, dojo.hitch(this, function(association){
				var associationLi = dojo.create("li", { //$NON-NLS-1$
					className: "associationItem j-hint", //$NON-NLS-1$
					innerHTML: dojo.string.substitute(this.messages.providesService, {
						imageSrc: association.icon ? association.icon : "", //$NON-NLS-1$
						serviceName: association.serviceLabel,
						consumerId: association.target
					})
				}, associationList);
			}));
		}
		
		td = dojo.create("td", { //$NON-NLS-1$
			className: "templatesTd" //$NON-NLS-1$
		}, tr);
		var select = dojo.create("select", { //$NON-NLS-1$
			className: "processTemplatesSelect" //$NON-NLS-1$
		}, td);
		dojo.forEach(container.processTemplates, dojo.hitch(this, function(select, template) {
			var option = dojo.create("option", { //$NON-NLS-1$
				value: template.processTemplateId
			}, select);
			option.appendChild(document.createTextNode(template.processTemplateName));
		}, select));
		if (container.projectTemplates) {
			select.style.display = "none"; //$NON-NLS-1$
			select = dojo.create("select", { //$NON-NLS-1$
				className: "projectTemplatesSelect" //$NON-NLS-1$
			}, td);
			dojo.forEach(container.projectTemplates, dojo.hitch(this, function(select, template) {
				var option = dojo.create("option", { //$NON-NLS-1$
					value: template.projectTemplateId
				}, select);
				option.appendChild(document.createTextNode(template.projectTemplateName));
			}, select));
		}
		
		//
		//create the "Link to Existing..." Column
		//
		td = dojo.create("td", { //$NON-NLS-1$
			className: "artifactContainerCommandsTd" //$NON-NLS-1$
		}, tr);
		
		var div = dojo.create("div", { //$NON-NLS-1$
			className: "linkToExistingDiv" //$NON-NLS-1$
		}, td);
		
		//button to link to existing artifact containers
		dojo.create("a", { //$NON-NLS-1$
			className: "linkToExistingBtn rowAnchor", //$NON-NLS-1$
			href: "#", //$NON-NLS-1$
			innerHTML: this.messages.linkExistingProject
		}, div);
		
		//button to remove link to an existing artifact container
		dojo.create("a", { //$NON-NLS-1$
			className: "removeContainerLinkBtn rowAnchor hide", //$NON-NLS-1$
			href: "#", //$NON-NLS-1$
			innerHTML: this.messages.createNewProject
		}, div);
	},
	
	//
	// Callback and helper method that will update the project names in the
	// "Provides <functionality> to Project Name <project name>"
	//
	// Params:
	//	e - the event object for when a user performs a keyup event on the project
	//		name input form
	//	args - arg object that is used for when the method is used outside of the event callback loop
	//
	_updateProjectAssociationLabels: function(e, args){
		var input = e ? getElement(e, "INPUT") : args.projectInputForm; //$NON-NLS-1$
		var parentRow = getParentElement(input, "TR"); //$NON-NLS-1$
		var id = parentRow[ROW_CONTEXT_PROP]; 
		
		var newLabel = jazz.util.html.escape(input.value);
		if (this.textDir == "auto") {
			this.applyTextDir(input, input.value);
		}
	
		dojo.query("SPAN[name=" + id + "]").forEach(dojo.hitch(this, function(labelNode){ //$NON-NLS-1$ //$NON-NLS-2$
			dojo.create("span", { //$NON-NLS-1$
				innerHTML: newLabel
			}, labelNode, "only"); //$NON-NLS-1$
		}));
	},
	
	
	//
	// Callback and helper method that will update the project names in the
	// "Provides <functionality> to Project Name <project name>" to use resource links instead of a string
	//
	// Params/Args: 
	//	context - an object representing the artifact conatiner resource that the RL should point to
	//  parentRow - the row in which the resource link should be added		
	//
	_updateProjectAssociationLabelsWithResourceLinks: function(args){
		var context = args.context;
		var parentRow = args.parentRow;
		var id = parentRow[ROW_CONTEXT_PROP];
		
		dojo.query("SPAN[name=" + id + "]").forEach(dojo.hitch(this, function(labelNode){ //$NON-NLS-1$ //$NON-NLS-2$
			var rl = new ResourceLink({
				uri: context.uri,
				label: context.label,
				lazyFetch: true
			});
			this._childrenWidgets.push(rl);
	
			dojo.place(rl.domNode, labelNode, "only"); //$NON-NLS-1$
		})); 
	},
	
	//******************************
	// Event Management
	//******************************
	
	//
	// Toggles the display of the Templates Container table
	// when the user clicks on the Table's header row
	//
	onToggleTableHeader: function(e){
		dojo.stopEvent(e);
		
		var table = getElement(e, "TABLE"); //$NON-NLS-1$
		if(dojo.hasClass(table, "expanded")){ //$NON-NLS-1$
			dojo.removeClass(table, "expanded"); //$NON-NLS-1$
			dojo.addClass(table, "collapsed"); //$NON-NLS-1$
		} else {
			dojo.removeClass(table, "collapsed"); //$NON-NLS-1$
			dojo.addClass(table, "expanded"); //$NON-NLS-1$
		}
	},
	
	//
	// Hide the project name preview ui and display the
	// input box so the user can change the project's name.
	//
	_showProjectNameEdit: function(e){
		this.applyTextDir(this._projectNameInput, this._projectNameInput.value);
		dojo.addClass(this._projectNamePreview, "hide"); //$NON-NLS-1$
		dojo.removeClass(this._projectNameInput, "hide"); //$NON-NLS-1$
		this._projectNameInput.focus();
		this._projectNameInput.select();
	},
	
	//
	// Hide the project name editor and update the text in the 
	// project name preview
	//
	_endProjectNameEdit: function(e){
		if (e.keyCode === dojo.keys.ENTER || e.type === "blur") { //$NON-NLS-1$
			if (this._projectNameInput.value === "") { //$NON-NLS-1$
				this._projectNameInput.value = this.messages.projectNameLabel;
			}
			dojo.addClass(this._projectNameInput, "hide"); //$NON-NLS-1$
			dojo.removeClass(this._projectNamePreview, "hide"); //$NON-NLS-1$
		}
		
		var curProjectName = this._projectNamePreview.innerHTML;
		var newProjectName = this._projectNameInput.value;
		this._projectNamePreview.innerHTML = jazz.util.html.escape(newProjectName);
		this.applyTextDir(this._projectNamePreview, this._projectNamePreview.innerHTML);
		this._projectNamePreview.style.textAlign = (dojo._isBodyLtr() ? "left" : "right");
				
		dojo.query(".toBeCreatedInput").forEach(dojo.hitch(this, function(input){ //$NON-NLS-1$
			var inputVal = input.value;
			var compareTo = this._projectNamePreview.prevValue
				? this._projectNamePreview.prevValue
				: curProjectName;
			if (inputVal.indexOf(compareTo) === 0 && !(compareTo.length === 0 && inputVal.length !== 0 && inputVal.charAt(0) !== ' ')){ //$NON-NLS-1$
				//if any of the container project names begin with the LPA project name
				//update their values with the new project name
				input.value = inputVal.replace(compareTo, newProjectName);
				this._updateProjectAssociationLabels(null, {
					projectInputForm: input
				});
			}
		}));
		
		this._projectNamePreview.prevValue = newProjectName;
		
		this._checkForChange();
		
	},
	
	//
	// Generic event handler that directs an event to its appropriate 
	// callback action depending on the clicked target
	//
	_onMouseClick: function(e){
		// if-statement used to filter even bubbling and let clicks on valid
		// links occur.
		var anchor = getElement(e, "A"); //$NON-NLS-1$
		if (anchor && (anchor.href.indexOf("#") === anchor.href.length - 1)) { //$NON-NLS-1$
			dojo.stopEvent(e);
			
			if (dojo.hasClass(anchor, "linkToExistingBtn")) { //$NON-NLS-1$
				this._showContextPicker({
					button: anchor
				});
			} else if (dojo.hasClass(anchor, "removeContainerLinkBtn")) { //$NON-NLS-1$
				this._removeContainerLink({
					button: anchor
				});
			}
		}
	},
	
	_showContextPicker: function(args){
		var button = args.button;
		
		var row = getParentElement(button, "TR"); //$NON-NLS-1$
		var domainObj = this._domainObjMap[row[ROW_DOMAIN_PROP]];
		var contextPicker = new ContextPicker({
			onAdd: dojo.hitch(this, function(result){
				this._onAddContainer(result, row);
			}),
			defaultApplicationUri: row[ROW_APP_PROP],
			domain: domainObj,
			mode: ContextPicker.MODE_TYPES.TEMPLATE_CONTAINER,
			curContainers: this._containersToLink
		});
		
		this._childrenWidgets.push(contextPicker);
	},
	
	_removeContainerLink: function(args){
		var button = args.button;		
		var row = getParentElement(button, "TR"); //$NON-NLS-1$

		//change the state of the row
		var input = dojo.query(".toBeCreatedInput", row)[0]; //$NON-NLS-1$
		dojo.removeClass(input, "hide"); //$NON-NLS-1$
		
		var rlSpan = dojo.query(".artifactContainerLinkSpan", row)[0]; //$NON-NLS-1$
		dojo.addClass(rlSpan, "hide"); //$NON-NLS-1$
		
		var linkBtn = dojo.query(".linkToExistingBtn", row)[0]; //$NON-NLS-1$
		dojo.removeClass(linkBtn, "hide"); //$NON-NLS-1$
		
		dojo.addClass(button, "hide"); //$NON-NLS-1$
		
		//retrieve the container uri and remove it from the containers
		//that we will link to
		var rlNode = dojo.query(".jazz-ui-ResourceLink", rlSpan)[0]; //$NON-NLS-1$
		var rl = dijit.byId(rlNode.id);
		delete this._containersToLink[rl.uri];
		
		this._updateProjectAssociationLabels(null, {
			projectInputForm: input
		});
		
		var projectTemplateSelect = dojo.query(".projectTemplatesSelect", row); //$NON-NLS-1$
		if (projectTemplateSelect.length > 0){
			dojo.removeClass(projectTemplateSelect[0], "hide"); //$NON-NLS-1$
		} else {
			var processTemplateSelect = dojo.query(".processTemplatesSelect", row)[0]; //$NON-NLS-1$
			dojo.removeClass(processTemplateSelect, "hide"); //$NON-NLS-1$
		}
	},
	
	_onAddContainer: function(result, parentRow){
		var application = result.application;
		var contexts = result.contexts;
		
		var context = contexts[0];
		this._containersToLink[context.uri] = context;
		this._containersToLink[context.uri].isTemplateContainer = true;
		
		var actionLabelCol = dojo.query(".templateContainerLabelCol", parentRow)[0]; //$NON-NLS-1$
		dojo.place(document.createTextNode(this.messages.linkToLabel), actionLabelCol, "only"); //$NON-NLS-1$
		
		var input = dojo.query(".toBeCreatedInput", parentRow)[0]; //$NON-NLS-1$
		dojo.addClass(input, "hide"); //$NON-NLS-1$
		
		var rlSpan = dojo.query(".artifactContainerLinkSpan", parentRow)[0]; //$NON-NLS-1$
		var containerRl = new ResourceLink({
			uri: context.uri,
			label: context.label,
			lazyFetch: true
		});
		this._childrenWidgets.push(containerRl);
		dojo.place(containerRl.domNode, rlSpan, "only") //$NON-NLS-1$
		
		dojo.removeClass(rlSpan, "hide"); //$NON-NLS-1$
		
		this._updateProjectAssociationLabelsWithResourceLinks({
			parentRow: parentRow,
			context: context
		});
		
		var linkBtn = dojo.query(".linkToExistingBtn", parentRow)[0]; //$NON-NLS-1$
		dojo.addClass(linkBtn, "hide"); //$NON-NLS-1$
		
		var removeLinkBtn = dojo.query(".removeContainerLinkBtn", parentRow)[0]; //$NON-NLS-1$
		dojo.removeClass(removeLinkBtn, "hide"); //$NON-NLS-1$
		
		var projectTemplateSelect = dojo.query(".projectTemplatesSelect", parentRow); //$NON-NLS-1$
		if (projectTemplateSelect.length > 0){
			dojo.addClass(projectTemplateSelect[0], "hide"); //$NON-NLS-1$
		} else {
			var processTemplateSelect = dojo.query(".processTemplatesSelect", parentRow)[0]; //$NON-NLS-1$
			dojo.addClass(processTemplateSelect, "hide"); //$NON-NLS-1$
		}
		
	}
});

var containerTableMessages = dojo.i18n.getLocalization("com.ibm.team.lpa.app.ui.internal", "ProjectEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.lpa.app.ui.internal.ContainerLinksTable", jazz.ui.StyledTable,  { //$NON-NLS-1$
	
	className: "artifactContainerTable", //$NON-NLS-1$
	
	columns: [
		{
			label: containerTableMessages.nameLabel,
			className: "nameCol" //$NON-NLS-1$
		},
		{
			label: containerTableMessages.actionsLabel,
			className: "actionsCol" //$NON-NLS-1$
		}
	],
	
	trim: StyledTable.TrimStyles.PRIMARY_COLLAPSABLE,
	
	constructor: function(args){	
		this.messages = containerTableMessages;
		
		this.isAdditionalTable = args.isAdditionalTable;
		this._curContainers = args._curContainers;
		this._tableContainers = {};
		this._containersToRemove = {};
		this._containersToAdd = {};
		
		this._simpleTbButtonMap = {};
		this._childrenWidgets = {};
	},
	
	postCreate: function(){
		this.inherited(arguments);
		this.connect(this.domNode, "onclick", this._onMouseClick); //$NON-NLS-1$
		
		dojo.addClass(this.domNode, this.className);
		this.refresh();
	},
	
	destroy: function(){
		this.deleteChildWidgets();
		if (this._childrenWidgets) delete this._childrenWidgets;
		
		this.inherited(arguments);
	},
	
	refresh: function(){
		this._tableContainers = {};
		this._containersToRemove = {};
		this._containersToAdd = {};
		
		this.clearBody();
		this.deleteChildWidgets();
		
		if (this.isAdditionalTable) {
			this._createEmptyAdditionalTableRow();
		} else {
			this._createEmptyContainerTableRow();
		}
	},
	
	deleteChildWidgets: function(){
		for (id in this._childrenWidgets){
			this._childrenWidgets[id].destroy();
		}
		this._childrenWidgets = {};
	},
	
	_createEmptyAdditionalTableRow: function(){
		this._emptyTableRow = dojo.create("tr", { //$NON-NLS-1$
			className: "emptyTableLabelRow j-hint" //$NON-NLS-1$
		}, this.tbody);
		
		dojo.create("td", { //$NON-NLS-1$
			innerHTML: this.messages.noAdditionalDomains,
			colSpan: 3
		}, this._emptyTableRow);
	},
	
	_createEmptyContainerTableRow: function(){
		this._emptyTableRow = dojo.create("tr", { //$NON-NLS-1$
			className: "emptyTableLabelRow j-hint" //$NON-NLS-1$
		}, this.tbody);
		
		dojo.create("td", { //$NON-NLS-1$
			innerHTML: this.messages.noConfiguredDomains,
			colSpan: 3
		}, this._emptyTableRow);
	},
	
	getContainers: function(){
		return this._tableContainers;
	},
	
	getContainersToRemove: function(){
		return this._containersToRemove;
	},
	
	getContainersToAdd: function(){
		return this._containersToAdd;
	},
	
	addContainerLink: function(container){
		dojo.addClass(this._emptyTableRow, "hide"); //$NON-NLS-1$
		
		var tr = dojo.create("tr", { //$NON-NLS-1$
			className: "containerLinkRow" //$NON-NLS-1$
		}, this.tbody);
		tr[ROW_CONTAINER_URI_PROP] = container.uri;
		tr[ROW_APP_PROP] = container.application;
		
		this._tableContainers[container.uri] = container;
		this._curContainers[container.uri] = container;
		
		var nameCol = dojo.create("td", { //$NON-NLS-1$
			className: "containerLinkName" //$NON-NLS-1$
		}, tr); 
		
		var containerRl = new ResourceLink({
			uri: container.uri,
			label: jazz.util.html.escape(container.label),
			lazyFetch: true
		});
		this._childrenWidgets[containerRl.id] = containerRl;
		dojo.place(containerRl.domNode, nameCol, "only"); //$NON-NLS-1$
		
		var actionCol = dojo.create("td", { //$NON-NLS-1$
			className: "containerLinkActions" //$NON-NLS-1$
		}, tr); 
		
		var simpleToolbar = new Toolbar();
		
		tr[ROW_BUTTONS_PROP] = simpleToolbar.id;
		if (this.isAdditionalTable) {
			// There is some code that runs after this method which clears out the message area.
			// Use setTimeout to make sure this runs after the message area has been cleared
			setTimeout(dojo.hitch(this, function () {
				dojo.publish(TOPIC_DISPLAY_MSG, [{
					content: this.messages.additionalArtifactContainerMsg,
					type: MessageBox.STATUS_TYPES.WARNING,
					closable: true
				}]);
			}), 0);
		} else {
			var button = new Button({ //$NON-NLS-1$
				title: this.messages.changeContainer,
				imgSrc: CHANGE_CONTAINER_SRC,
				onClick: dojo.hitch(this, function(event) {
					dojo.stopEvent(event);
					this._changeContainer(tr);
				})
			});
			dojo.addClass(button.focusNode, "changeLink action"); //$NON-NLS-1$
			simpleToolbar.addChild(button);
			this._simpleTbButtonMap[simpleToolbar.id + "changeLink"] = button; //$NON-NLS-1$
		}
		var button = new Button({ //$NON-NLS-1$
			title: this.messages.undoLabel, //$NON-NLS-1$
			imgSrc: RESTORE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				dojo.removeClass(tr, "j-table-restored"); //$NON-NLS-1$
				if (this._simpleTbButtonMap[simpleToolbar.id + "changeLink"] && !this._simpleTbButtonMap[simpleToolbar.id + "changeLink"].isFocusable()) { //$NON-NLS-1$ //$NON-NLS-2$
					this._setToRowToOrigState({
						row: tr,
						simpleBtn: this._simpleTbButtonMap[simpleToolbar.id + "changeLink"] //$NON-NLS-1$
					});
					this._simpleTbButtonMap[simpleToolbar.id + "changeLink"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
					this._simpleTbButtonMap[simpleToolbar.id + "changeLink"].focus(); //$NON-NLS-1$ 
				} else {
					delete this._containersToRemove[tr[ROW_CONTAINER_URI_PROP]];
					this._simpleTbButtonMap[simpleToolbar.id + "removeLink"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
					this._simpleTbButtonMap[simpleToolbar.id + "removeLink"].focus(); //$NON-NLS-1$
				}
				this._simpleTbButtonMap[simpleToolbar.id + "undoButton"].set("visible", false); //$NON-NLS-1$ //$NON-NLS-2$
				dojo.publish(TOPIC_CHECK_FOR_CHANGE);
			})
		});
		dojo.addClass(button.focusNode, "undoButton action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		button.set("visible", false); //$NON-NLS-1$
		this._simpleTbButtonMap[simpleToolbar.id + "undoButton"] = button; //$NON-NLS-1$
		
		var button = new Button({ //$NON-NLS-1$
			title: this.messages.removeLink,
			imgSrc: REMOVE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				if (this._simpleTbButtonMap[simpleToolbar.id + "changeLink"]) { //$NON-NLS-1$
					this._simpleTbButtonMap[simpleToolbar.id + "changeLink"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
				}
				this._simpleTbButtonMap[simpleToolbar.id + "undoButton"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleToolbar.id + "removeLink"].set("visible", false); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleToolbar.id + "undoButton"].focus(); //$NON-NLS-1$ 
				
				if (this.isAdditionalTable) {
					this.removeContainerLink(tr);
				} else {
					this._setContainerToRemove(tr);
				}
			})
		});
		dojo.addClass(button.focusNode, "removeLink action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "removeLink"] = button; //$NON-NLS-1$
	
		this._childrenWidgets[simpleToolbar.id] = simpleToolbar;
		
		var actionButtons = simpleToolbar.getChildren();
		for (var i=0; i < actionButtons.length; i++) {
			actionButtons[i].connect(actionButtons[i].focusNode, "onfocus", function(event) { //$NON-NLS-1$
				clearTimeout(tr._blurTimeout);
			});
			actionButtons[i].connect(actionButtons[i].focusNode, "onblur", function(event) { //$NON-NLS-1$
				tr._blurTimeout = setTimeout(function() {
					dojo.removeClass(tr, "focused"); //$NON-NLS-1$
				}, 0);
			});
		}
		simpleToolbar.connect(simpleToolbar.domNode, "onfocus", function(event) { //$NON-NLS-1$
			var i;
			var actionButtons = this.getChildren();
			dojo.addClass(tr, "focused"); //$NON-NLS-1$
			for (i = 0; i < actionButtons.length; i++) {
				if (actionButtons[i].isFocusable()) { //$NON-NLS-1$
					actionButtons[i].focus();
					break;
				}
			}
			if (i === actionButtons.length) {
				dojo.removeClass(tr, "focused"); //$NON-NLS-1$
			}
		});
		
		
		dojo.place(simpleToolbar.domNode, actionCol);
	},
	
	//******************************
	// Event Management
	//******************************
	
	//
	// Generic event handler that directs an event to its appropriate 
	// callback action depending on the clicked target
	//
	_onMouseClick: function(e){
		var anchor = getElement(e, "A"); //$NON-NLS-1$
		if (anchor && (anchor.href.indexOf("#") === anchor.href.length - 1)) { //$NON-NLS-1$
			dojo.stopEvent(e);
			
			if (dojo.hasClass(anchor, "addAnchor")) { //$NON-NLS-1$
				//WARNING: internal StyledTable API, used to handle that we have an action 
				//button in the header and that the table gets collapsed before _onMouseClick executes
				this._toggleCollapsed(); 
				
				this._showContextPicker({
					cb: this._onAddContainers,
					type: ContextPicker.MODE_TYPES.ADD_CONTAINER
				});
			}
		}
	},
	
	_showContextPicker: function(args){
		var cb = args.cb;
		var defaultAppUri = args.defaultAppUri;
		var type = args.type;
		
		var contextPicker = new ContextPicker({
			onAdd: dojo.hitch(this, cb),
			mode: type,
			defaultApplicationUri: (defaultAppUri) ? defaultAppUri : null,
			curContainers: this._curContainers
		});
	},
	
	_onAddContainers: function(result){
		var containers = result.contexts;
		dojo.forEach(containers, dojo.hitch(this, function(container){
			container["inAddTable"] = true; //$NON-NLS-1$
			this.addContainerLink(container);
		}));
		dojo.publish(TOPIC_CHECK_FOR_CHANGE);
	},
	
	_changeContainer: function(row){
		var simpleTbId = row[ROW_BUTTONS_PROP];
		var simpleTb = this._childrenWidgets[simpleTbId];
		var simpleBtn = this._simpleTbButtonMap[simpleTbId+"changeLink"]; //$NON-NLS-1$
	
		this._showContextPicker({
			cb: dojo.hitch(this, function(result){
				this._setToRowToOrigState({
					row: row,
					simpleBtn: this._simpleTbButtonMap[simpleTbId + "removeLink"] //$NON-NLS-1$
				});
				
				dojo.addClass(row, "j-table-restored"); //$NON-NLS-1$
				
				this._changeContainerCb({
					container: result.contexts[0],
					row: row
				});
				
				this._simpleTbButtonMap[simpleTb.id + "changeLink"].set("visible", false); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleTb.id + "undoButton"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleTb.id + "removeLink"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleTb.id + "undoButton"].focus(); //$NON-NLS-1$ 
				dojo.publish(TOPIC_CHECK_FOR_CHANGE);
			}),
			defaultAppUri: row[ROW_APP_PROP],
			type: ContextPicker.MODE_TYPES.CHANGE_CONTAINER
		});	
	},
	
	_changeContainerCb: function(args){
		var newContainer = args.container;
		var row = args.row;
		
		row[ROW_NEW_CONTAINER_URI_PROP] = newContainer.uri;
		this._curContainers[newContainer.uri] = newContainer;
		this._containersToAdd[newContainer.uri] = newContainer;
		
		var origContainerUri = row[ROW_CONTAINER_URI_PROP];
		this._containersToRemove[origContainerUri] = this._tableContainers[origContainerUri];
		
		//remove old rl
		this._removeRowRl(row);
		
		// create new rl
		this._addRowRl({
			container: newContainer,
			row: row
		});
	},
	
	_addRowRl: function(args){
		var container = args.container;
		var row = args.row;
		
		var nameCol = dojo.query(".containerLinkName", row)[0]; //$NON-NLS-1$
		var containerRl = new ResourceLink({
			uri: container.uri,
			label: jazz.util.html.escape(container.label),
			lazyFetch: true
		});
		this._childrenWidgets[containerRl.id] = containerRl;
		dojo.place(containerRl.domNode, nameCol, "only");	 //$NON-NLS-1$
	},
	
	_removeRowRl: function(row){
		var rlCol = dojo.query(".containerLinkName", row)[0]; //$NON-NLS-1$
		var rlNode = dojo.query(".jazz-ui-ResourceLink", rlCol)[0]; //$NON-NLS-1$
		var rl = this._childrenWidgets[rlNode.id];
		rl.destroy();
		delete this._childrenWidgets[rlNode.id];
		dojo.empty(rlCol);
	},
	
	removeContainerLink: function(row){
		var id = row[ROW_CONTAINER_URI_PROP];
		
		delete this._curContainers[id];
		delete this._tableContainers[id];
		
		dojo.destroy(row);
		
		if ( dojo.query(".containerLinkRow", this.tbody).length <= 0 ){ //$NON-NLS-1$
			dojo.removeClass(this._emptyTableRow, "hide"); //$NON-NLS-1$
		}
		
		dojo.publish(TOPIC_CHECK_FOR_CHANGE);
	},
	
	_setContainerToRemove: function(row){
		var containerUri = row[ROW_CONTAINER_URI_PROP];
		var simpleTbId = row[ROW_BUTTONS_PROP];
		
		this._setToRowToOrigState({
			row: row,
			simpleBtn: this._simpleTbButtonMap[simpleTbId+"changeLink"] //$NON-NLS-1$
		});
		
		dojo.addClass(row, "j-table-restored"); //$NON-NLS-1$
		this._containersToRemove[containerUri] = this._tableContainers[containerUri];
		dojo.publish(TOPIC_CHECK_FOR_CHANGE);
	},
	
	//******************************
	// Util Functions
	//******************************
	
	//
	// Sets the row to its original state in the UI
	//
	_setToRowToOrigState: function(args){
		var row = args.row;
		var simpleBtn = args.simpleBtn;
		
		var origContainerUri = row[ROW_CONTAINER_URI_PROP];
		
		if (row[ROW_NEW_CONTAINER_URI_PROP] && row[ROW_NEW_CONTAINER_URI_PROP] !== ""){ //$NON-NLS-1$
			var newContainerUri = row[ROW_NEW_CONTAINER_URI_PROP];
			delete this._containersToAdd[newContainerUri];
			delete this._curContainers[newContainerUri];
			row[ROW_NEW_CONTAINER_URI_PROP] = ""; //$NON-NLS-1$
			
			//remove old rl
			this._removeRowRl(row);
			
			// create new rl
			this._addRowRl({
				container: this._tableContainers[origContainerUri],
				row: row
			});
		} 
		
		delete this._containersToRemove[origContainerUri];
		
		if (simpleBtn) {
			dojo.removeClass(row, "j-table-restored"); //$NON-NLS-1$
			var simpleTbId = row[ROW_BUTTONS_PROP];
			var simpleTb = this._childrenWidgets[simpleTbId];
			this._setButtonState({
				simpleTb: simpleTb,
				simpleBtn: simpleBtn,
				pressed: false
			});
		}
		
	},
	
	//
	// Sets the simple TB button to its original state in the UI
	//
	_setButtonState: function(args){
		var simpleTb = args.simpleTb;
		var simpleBtn = args.simpleBtn;
		var pressed = args.pressed;
		
		simpleBtn.set("pressed", pressed); //$NON-NLS-1$
	}
});	
})();