/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.lpa.app.ui.internal.ProjectsPage"); //$NON-NLS-1$

dojo.require("com.ibm.team.lpa.app.client.LifecycleProjectAdminClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.app.ui.internal.ConfirmDeleteDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.app.ui.internal.CreateProjectInfoWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.app.ui.internal.ContextDetailsWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.lpa.common.internal.util"); //$NON-NLS-1$
dojo.require("dijit._TemplatedMixin"); //$NON-NLS-1$
dojo.require("dijit._WidgetsInTemplateMixin"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("jazz.app.ua.PageHoverHelp"); //$NON-NLS-1$
dojo.require("jazz.ui.Breadcrumbs"); //$NON-NLS-1$
dojo.require("jazz.ui.FilterBox"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.ui.PaginationControl"); //$NON-NLS-1$
dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.lpa.app.ui.internal", "ProjectsPageMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var htmlEncode = com.ibm.team.lpa.common.internal.util.htmlEncode;

var BreadCrumbs = jazz.ui.Breadcrumbs;
var LifecycleProjectAdminClient = com.ibm.team.lpa.app.client.LifecycleProjectAdminClient;
var MessageBox = jazz.ui.MessageBox;
var ResourceLink = jazz.ui.ResourceLink;
var Toolbar = jazz.ui.Toolbar;
var Button = jazz.ui.toolbar.Button;

//
// Node Properties
//
var PROJECT_URI_PROP = "_jazzProjectUri"; //$NON-NLS-1$
var PROJECT_RESOURCE_URI_PROP = "_jazzProjectResourceUri"; //$NON-NLS-1$
var CONTEXT_WIDGET_ID_PROP = "_jazzContextDetailWidget"; //$NON-NLS-1$
var ROW_BUTTONS_PROP = "_jazzRowButtons"; //$NON-NLS-1$

//
// Topics
//
var TOPIC_DISPLAY_MSG = "com.ibm.team.lpa.app.ui.internal.ProjectsPage#message"; //$NON-NLS-1$

//
// Image Locations
//
var GRAPHICS_FOLDER = "ui/graphics/"; //$NON-NLS-1$
var GRAPHICS_ICONS_FOLDER = GRAPHICS_FOLDER + "icons/"; //$NON-NLS-1$

var REFRESH_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "refresh_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var DELETE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "delete_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var RESTORE_IMG_SRC = dojo.moduleUrl("com.ibm.team.lpa.app",GRAPHICS_ICONS_FOLDER + "restore_16.png"); //$NON-NLS-1$ //$NON-NLS-2$
var CLOSED_TWISTIE_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "closed-twistie.png"); //$NON-NLS-1$ //$NON-NLS-2$
var OPEN_TWISTIE_SRC = dojo.moduleUrl("com.ibm.team.lpa.app", GRAPHICS_ICONS_FOLDER + "open-twistie.png"); //$NON-NLS-1$ //$NON-NLS-2$

//
// RDF Names
//
var RDF_SYNTAX_TYPE_URI = "http://www.w3.org/1999/02/22-rdf-syntax-ns#type"; //$NON-NLS-1$
var LPA_APPLICATION_URI = "http://jazz.net/xmlns/foundation/lpa/1.0/Application"; //$NON-NLS-1$
var LPA_DOMAIN_URI = "http://jazz.net/xmlns/foundation/lpa/1.0/domain"; //$NON-NLS-1$
var DC_TITLE = "http://purl.org/dc/terms/title"; //$NON-NLS-1$

var PAGINATION_INCREMENTS = [10, 25, 50, 75, 100];

function makeRemoteCall(dfd, callback, errback) {
	dfd.addBoth(function(result) {
		if(result instanceof Error) {
			if (errback) {
				errback(result.jfsHttpException.message);
			} else {
				var msgType = result.jfsHttpException.msgType;
				
				var mbArgs = {
					content: result.jfsHttpException.message,
					type: (msgType && msgType === "info") ? MessageBox.STATUS_TYPES.INFO : MessageBox.STATUS_TYPES.ERROR //$NON-NLS-1$
				};				
				if (result.jfsHttpException.subStatus) {
					mbArgs.details = [{
						message: result.jfsHttpException.subStatus
					}];
				}
				
				dojo.publish(TOPIC_DISPLAY_MSG, [mbArgs]);
			}
		} else {
			callback(result);
		}
	});
}

function getElement(e, tagName){
	var element= e.target || e.srcElement;
	return getParentElement(element, tagName);
}

function getParentElement(node, tagName){
	var element = node;
	while(element && element.tagName !== tagName){
		element = element.parentNode;
	}
	
	return element || null;
}

dojo.declare("com.ibm.team.lpa.app.ui.internal.ProjectsPage", [dijit._Widget, dijit._TemplatedMixin, dijit._WidgetsInTemplateMixin], { //$NON-NLS-1$
	
	templatePath: dojo.moduleUrl("com.ibm.team.lpa.app","ui/internal/templates/ProjectsPage.html"), //$NON-NLS-1$ //$NON-NLS-2$

	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.lpa.app.ui.internal", "ProjectsPageMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.membersPageMessages = dojo.i18n.getLocalization("com.ibm.team.lpa.app.ui.internal", "MembersPageMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this._refreshIconSrc = REFRESH_IMG_SRC;
		
		this._blockSaveAction = true;
		this.projects = null; // tracks the current list of projects
		this.lpaCache = null; // caches the results returned from queries to LPA server??
		this._applicationMap = {}; // a map that tracks references to each application of the LPA
		this._projectMap = {};
		this._filterIndex = [];
		
		this._simpleTbButtonMap = {}; //tracks buttons created in a simple toolbar
		
		// properties used to track references that need to be destroyed on table destruction
		this._childrenWidgets = [];
		
		this._newProjectHref = net.jazz.ajax._contextRoot + "/lpa/projects/new"; //$NON-NLS-1$
	},
	
	postCreate: function() {
		if (net.jazz.ajax._helpRoot) {
			new jazz.app.ua.PageHoverHelp({ 
				uaKey: "com.ibm.team.lpa.app.lpaProjects" //$NON-NLS-1$
			}, this.titleUA);
		} else {
			new jazz.app.ua.PageHoverHelp({ 
				contentNode: new com.ibm.team.lpa.app.ui.internal.CreateProjectInfoWidget().domNode
			}, this.titleUA);
		}
		
		this.subscribe(TOPIC_DISPLAY_MSG, "displayMessage"); //$NON-NLS-1$
		
		this.refresh();
	},
	
	_destroyChildWidgets: function(){
		dojo.forEach(this._childrenWidgets, function(widget){
			widget.destroy();
		});
	},
	
	refresh: function() {
		this._hideMessages();
		this._destroyChildWidgets();
		
		this._blockSaveAction = true;
		com.ibm.team.lpa.common.internal.util.checkAuth(this.messageBox, dojo.hitch(this, function(response) {
			if (response === 1){
				this._blockSaveAction = false;
			}
		}));
		
		//reset pagination
		this.paginationControlNode.setTotal(0);
		this._initPaginationIncrementUI();
		
		//clear the state
		this._makeReadOnly();
		this.toDelete = {count: 0, uris: []};
		this.newProject = null;
		this.editProject = null;
		this._applicationMap = {};
		this._projectMap = {};
		this._filterIndex = [];
		
		dojo.addClass(this.projectsList, "hide"); //$NON-NLS-1$
		dojo.addClass(this.noProjectsMessage, "hide"); //$NON-NLS-1$
		dojo.removeClass(this.loadingMessage, "hide"); //$NON-NLS-1$
		
		this._makeRemoteCall(LifecycleProjectAdminClient.getProjects(), dojo.hitch(this, function(result){
			dojo.empty(this.projectsList);
			this.projects = result;
			this.loadApplications();
		}));
	},
	
	loadApplications: function(applications) {
		this._makeRemoteCall(LifecycleProjectAdminClient.getApplications(), dojo.hitch(this, function(result){
			this._applicationMap = {};
			this.lpaCache.applications = result;
			this._buildApplicationMap({
				applications: result
			});
			
			this._buildProjectMap();
			this.displayProjects();
		}));
	},
	
	_buildProjectMap: function(){
		var projects = this.projects;
		
		if (projects){
			dojo.forEach(projects, dojo.hitch(this, function(project){
				this._projectMap[project.uri] = project;
			}));
		}
	},
	
	_buildApplicationMap: function(args){
		var applications = args.applications;	
		for (var subjectUri in applications) {
			var subject = applications[subjectUri];
			var type = subject[RDF_SYNTAX_TYPE_URI][0].value;
			
			if (LPA_APPLICATION_URI === type) {//is the current subject an LPA application?
				if (this._applicationMap[subjectUri]){
					//if we have a duplicate application, append the URI to the display name
					this._applicationMap[subjectUri].displayName += "(" + uri + ")" //$NON-NLS-1$ //$NON-NLS-2$
				} else {
					//add the application to the map
					var title = subject[DC_TITLE][0].value;
					var domain = subject[LPA_DOMAIN_URI][0].value;
					var uri = subjectUri.replace("/rootservices", ""); //$NON-NLS-1$ //$NON-NLS-2$
					
					var app = {
						displayName: title,
						domain: domain,
						label: title,
						uri: uri
					};
					this._applicationMap[subjectUri] = app;
					this._applicationMap[domain] = app;
				}
			}
		} // end loop
	},
	
	//******************************
	// Project List Builder Methods
	//******************************
	
	//
	// Builds the DOM that will display the projects
	//
	displayProjects: function() {
		if (this.projects.length <=0 ){
			dojo.removeClass(this.noProjectsMessage, "hide"); //$NON-NLS-1$
		} else {
			dojo.addClass(this.noProjectsMessage, "hide"); //$NON-NLS-1$
		}
		
		
		dojo.forEach(this.projects, dojo.hitch(this, function(project){
			this._createProjectListItem({
				project: project
			});
		}));
		
		this._updateProjectsVisibility(null, 1, this.paginationIncrement);
		this._refreshPaginationUI();
		
		dojo.addClass(this.loadingMessage, "hide"); //$NON-NLS-1$
		dojo.removeClass(this.projectsList, "hide"); //$NON-NLS-1$
	},
	
	//
	// Helper method that handles the creation of the DOM to display a 
	// single project
	//
	_createProjectListItem: function(args){
		var project = args.project;
		
		//create the root nodes
		var li = dojo.create("li", { //$NON-NLS-1$
			className: "projectsListItem" //$NON-NLS-1$
		}, this.projectsList);
		li[PROJECT_URI_PROP] = project.uri;
		li[PROJECT_RESOURCE_URI_PROP] = project.uri.substring(project.uri.lastIndexOf("/")+1) + "/" + encodeURIComponent(project.label); //$NON-NLS-1$ //$NON-NLS-2$
	
		this._addToFilter({
			project: project,
			node: li
		});
		
		var div = dojo.create("div", { //$NON-NLS-1$
			className: "projectWrapper" //$NON-NLS-1$
		}, li);
		
		//create the title row
		this._createProjectTitleRow({
			liNode: li,
			rootNode: div,
			title: project.label
		});
		
		//add the description of the project
		var descriptionDiv = dojo.create("div", { //$NON-NLS-1$
			className: "projectDescription", //$NON-NLS-1$
			innerHTML: htmlEncode(jazz.util.html.escape(project.description)).replace( /\n/g, '<br>') //$NON-NLS-1$
		}, div);
		
		if (project.contexts.length > 0){
			//add link to the members page
			this._createMembersRow({
				description: project.description,
				uri: project.uri,
				rootNode: div
			});
			
			//add project relationships
			this._createContainerList({
				project: project,
				rootNode:div
			});
		}
	},
	
	//
	// Helper method to build a project's title
	//
	_createProjectTitleRow: function(args){
		var liNode = args.liNode;
		var rootNode = args.rootNode;
		var title = args.title;
		
		var titleDiv = dojo.create("div", { //$NON-NLS-1$
			className: "projectTitleRow" //$NON-NLS-1$
		}, rootNode);
		
		var title = dojo.create("a", { //$NON-NLS-1$
			className: "projectTitle", //$NON-NLS-1$
			href: "#", //$NON-NLS-1$
			innerHTML: jazz.util.html.escape(title)
		}, titleDiv);
		
		var simpleToolbar = new Toolbar();
		
		liNode[ROW_BUTTONS_PROP] = simpleToolbar.id;
		var button = new Button({ //$NON-NLS-1$
			title: this.messages.deleteProject,
			imgSrc: DELETE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				dojo.addClass(liNode, "projectPressed"); //$NON-NLS-1$
				this._makeSavable();
				this._simpleTbButtonMap[simpleToolbar.id + "undoProject"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleToolbar.id + "deleteProject"].set("visible", false); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleToolbar.id + "undoProject"].focus(); //$NON-NLS-1$ 
			})
		});
		dojo.addClass(button.focusNode, "deleteProject action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		this._simpleTbButtonMap[simpleToolbar.id + "deleteProject"] = button; //$NON-NLS-1$
		
		var button = new Button({ //$NON-NLS-1$
			title: this.messages.undoLabel,
			imgSrc: RESTORE_IMG_SRC,
			onClick: dojo.hitch(this, function(event) {
				dojo.stopEvent(event);
				dojo.removeClass(liNode, "projectPressed"); //$NON-NLS-1$
				if ( dojo.query(".projectPressed").length <= 0 ){ //$NON-NLS-1$
					//if there are no projects marked for deletion,
					//the save button should be disbled
					this._makeReadOnly();
				}
				this._simpleTbButtonMap[simpleToolbar.id + "undoProject"].set("visible", false); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleToolbar.id + "deleteProject"].set("visible", true); //$NON-NLS-1$ //$NON-NLS-2$
				this._simpleTbButtonMap[simpleToolbar.id + "deleteProject"].focus(); //$NON-NLS-1$ 
			})
		});
		dojo.addClass(button.focusNode, "undoProject action"); //$NON-NLS-1$
		simpleToolbar.addChild(button);
		button.set("visible", false); //$NON-NLS-1$
		this._simpleTbButtonMap[simpleToolbar.id + "undoProject"] = button; //$NON-NLS-1$
		this._childrenWidgets.push(simpleToolbar);
		
		dojo.place(simpleToolbar.domNode, titleDiv);
		
		var actionButtons = simpleToolbar.getChildren();
		for (var i=0; i < actionButtons.length; i++) {
			actionButtons[i].connect(actionButtons[i].focusNode, "onfocus", function(event) { //$NON-NLS-1$
				clearTimeout(liNode._blurTimeout);
			});
			actionButtons[i].connect(actionButtons[i].focusNode, "onblur", function(event) { //$NON-NLS-1$
				liNode._blurTimeout = setTimeout(function() {
					dojo.removeClass(liNode, "focused"); //$NON-NLS-1$
				}, 0);
			});
		}
		
		simpleToolbar.connect(simpleToolbar.domNode, "onfocus", function(event) { //$NON-NLS-1$
			var i;
			var actionButtons = this.getChildren();
			dojo.addClass(liNode, "focused"); //$NON-NLS-1$
			for (i = 0; i < actionButtons.length; i++) {
				if (actionButtons[i].isFocusable()) { //$NON-NLS-1$
					actionButtons[i].focus();
					break;
				}
			}
			if (i === actionButtons.length) {
				dojo.removeClass(liNode, "focused"); //$NON-NLS-1$
			}
		});
	},
	
	//
	// Helper method to build the link to a project's members page
	//
	_createMembersRow: function(args){
		var description = args.description;
		var projectUriParts = args.uri.split("/"); //$NON-NLS-1$
		var projectId = projectUriParts[projectUriParts.length - 1];
		var rootNode = args.rootNode;
		
		var messages = this.messages;
		
		var membersDiv = dojo.create("div", { //$NON-NLS-1$
			className: "projectMembersDiv" //$NON-NLS-1$
		}, rootNode);
		
		dojo.create("span", { //$NON-NLS-1$
			className: "membersLabel j-label", //$NON-NLS-1$
			innerHTML: messages.membersLabel
		}, membersDiv);
		
		dojo.create("a", { //$NON-NLS-1$
			className: "membersLink", //$NON-NLS-1$
			href: net.jazz.ajax._contextRoot + "/lpa/members#project=" + projectId, //$NON-NLS-1$
			innerHTML: messages.showProjectMembers
		}, membersDiv);
	},
	
	//
	// Helper method to build the DOM ti display details about a 
	// project's artifact containers
	//
	_createContainerList: function(args){
		var rootNode = args.rootNode;
		var project = args.project;
		var contexts = project.contexts;
		
		//create root nodes and title
		var containerDiv = dojo.create("div", { //$NON-NLS-1$
			className: "containerListWrapper" //$NON-NLS-1$
		}, rootNode);
		
		var containerLabel = dojo.create("div", { //$NON-NLS-1$
			className: "containerLabel j-label", //$NON-NLS-1$
			innerHTML: this.messages.artifactContainers
		}, containerDiv);
		
		var containerList = dojo.create("ul", { //$NON-NLS-1$
			className: "containerList" //$NON-NLS-1$
		}, containerDiv);
		
		dojo.forEach(contexts, dojo.hitch(this, function(context){
			var li = dojo.create("li", { //$NON-NLS-1$
				className: "containerItem" //$NON-NLS-1$
			}, containerList);
			
			var twistieAnchor = dojo.create("a", { //$NON-NLS-1$
				className: "containerTwistieAnchor", //$NON-NLS-1$
				href: "#" //$NON-NLS-1$
			}, li);
			
			var twistieImg = dojo.create("img", { //$NON-NLS-1$
				className: "containerTwistieImg", //$NON-NLS-1$
				src: CLOSED_TWISTIE_SRC
			}, twistieAnchor);
			
			var div = dojo.create("span", { //$NON-NLS-1$
				className: "containerItemDiv" //$NON-NLS-1$
			}, li);
			
			var rl = new ResourceLink({
				uri: context.uri,
				label: jazz.util.html.escape(context.label),
				lazyFetch: true
			});
			this._childrenWidgets.push(rl);
			dojo.place(rl.domNode, div);
			
			if (context.domains.length > 0){
				dojo.create("span", { //$NON-NLS-1$
					innerHTML: dojo.string.substitute(this.messages.containerServer, [this._getApplicationLabelListStr(context), context.domains[0].label])
				}, div, "last"); //$NON-NLS-1$
			}
			
			var contextDiv = dojo.create("div", { //$NON-NLS-1$
				className: "contextDetailsDiv" //$NON-NLS-1$
			}, li);
			
			var contextDetailsWidget = new com.ibm.team.lpa.app.ui.internal.ContextDetailsWidget({
				context: context,
				lpaProject : project
			}, contextDiv);
			dojo.addClass(contextDetailsWidget.domNode, "hide");			 //$NON-NLS-1$
			this._childrenWidgets.push(contextDetailsWidget);
			li[CONTEXT_WIDGET_ID_PROP] = contextDetailsWidget.id;		
		}));
	},
	
	//******************************
	// Pagination Management Methods
	//******************************
	
	//
	// Updates the projects projects that are visible in a given page
	// determined by the Pagination Controller
	//
	_updateProjectsVisibility: function(paginationControl, start, end) {
		var projectNodes = this.projectsList.children;
		var projectNodesLength = projectNodes.length;
		
		if (end <= 0) {
			end = projectNodesLength;
		}
		
		for (var i = 1; i <= projectNodesLength; i++) {
			if (i >= start && i <= end) {
				dojo.removeClass(projectNodes[i-1], "hide"); //$NON-NLS-1$
			} else {
				dojo.addClass(projectNodes[i-1], "hide"); //$NON-NLS-1$
			}
		}
	},
	
	//
	// Initializes the pagination increment select and pagination
	// controller on the page
	//
	_initPaginationIncrementUI: function() {
		//the pagination control has been created already
		if (dojo.hasClass(this.paginationIncrementSelect, "_init")) return; //$NON-NLS-1$
		
		dojo.forEach(PAGINATION_INCREMENTS, dojo.hitch(this, function(inc){
			dojo.create("option", {value: inc, innerHTML: inc}, this.paginationIncrementSelect); //$NON-NLS-1$
		}));
		dojo.create("option", {value: 0, innerHTML: jazz.util.html.escape(this.messages.showAll)}, this.paginationIncrementSelect); //$NON-NLS-1$
		this.paginationIncrementSelect.value = 10;
		this.paginationIncrement = 10;
		this.connect(this.paginationIncrementSelect, "onchange", dojo.hitch(this, function() { //$NON-NLS-1$
			this.paginationIncrement = parseInt(this.paginationIncrementSelect.value);
			this._updateProjectsVisibility(null, 1, this.paginationIncrement);
			this._refreshPaginationUI();
		}));
		
		dojo.addClass(this.paginationIncrementSelect, "_init"); //$NON-NLS-1$
	},
	
	//
	// Refreshes the pagination controller's numbers when the project
	// list is updated
	//
	_refreshPaginationUI: function() {
		var projectListLength = this.projectsList.children.length;
		
		var increment = (this.paginationIncrement <= 0 || projectListLength < 1 ) ? projectListLength : this.paginationIncrement;
		this.paginationControlNode.set("increment", increment); //$NON-NLS-1$
		this.paginationControlNode.setTotal(projectListLength);
	},
	
	//******************************
	// MessageBox Management
	//******************************
	displayMessage: function(args) {
		var closable = args.closable;
		var content = args.content;
		var type = args.type;
		
		var isClosable = (closable) ? closable : true;
		var mbArgs = {
			closable: isClosable,
			summary: content,
			type: type
		};
		if (args.details) {
			mbArgs.details = args.details;
		}
		this.messageBox.showMessage(mbArgs);
	},

	_hideMessages: function() {
		this.messageBox.hideMessage();
	},
	
	//******************************
	// onSave Actions
	//******************************
	
	//
	// Performs the pending actions when the "save" button is clicked
	//
	onSave: function(){
		if (!this._blockSaveAction){
			this._deleteProjects();	
		}
	},
	
	_deleteProjects: function(){
		var messages = this.messages;
		var projectsToRemove = [];
		dojo.query(".projectPressed").forEach(dojo.hitch(this, function(node){ //$NON-NLS-1$
			var uri = node[PROJECT_URI_PROP];
			projectsToRemove.push( {
				uri: uri,
				label: this._projectMap[uri].label
			});
		}));
		
		projectsToRemove.sort(function(x, y) {
			return x.label.toLowerCase() > y.label.toLowerCase() ? 1 : -1;
		});
		
		new com.ibm.team.lpa.app.ui.internal.ConfirmDeleteDialog({			
			onDelete: dojo.hitch(this, function(result) { 
				this._performProjectDeleteRequest(projectsToRemove);
			}),
			objects: projectsToRemove,
			deletePromptTitle: messages.deletePromptTitle,
			deleteSingleMsg: messages.deletePromptListTextSingle,
			deleteMultiMsg: messages.deletePromptListTextMulti,
			deletePromptMsg: messages.deletePromptText,
			deleteButtonText: messages['delete'] //$NON-NLS-1$
		});
	},
	
	_performProjectDeleteRequest: function(projects){
		if (projects.length > 0){
			this.displayMessage({
				content: this.messages.deletingProjects,
				type: MessageBox.STATUS_TYPES.INFO
			});
			
			var index = 0;
			
			var cb = dojo.hitch(this, function(result){
				if (++index < projects.length){
					this._makeRemoteCall(LifecycleProjectAdminClient.deleteProject(projects[index].uri), cb);
				} else {
					this.displayMessage({
						content: this.messages.deleteProjectSuccess,
						type: MessageBox.STATUS_TYPES.OK
					});
					this.refresh();
				}
			});
			
			this._makeRemoteCall(LifecycleProjectAdminClient.deleteProject(projects[index].uri), cb);
		}
	},
	
	//******************************
	// Filter Management
	//******************************
	
	//
	// Callback when user types in the Filter Box
	//
	onFilter: function(value) {
		for(var i=0; i<this._filterIndex.length; i++) {
			var entry = this._filterIndex[i];
			var displayValue = "none"; //$NON-NLS-1$
			for(var j=0; j<entry.text.length; j++) {
				if(entry.text[j].indexOf(value.toLowerCase()) >= 0) {
					displayValue = ""; //$NON-NLS-1$
					break;
				}
			}
			dojo.style(entry.uiElement, "display", displayValue); //$NON-NLS-1$
		}
	},
	
	//
	// Used to add projects to the filter index.
	//
	// Params:
	//		project - a project object retrieved from the server
	//					(See methods used to display the projects 
	//					 in the UI for an example of how this method 
	//					 is used.)
	//
	_addToFilter: function(args){
		var project = args.project;
		var node = args.node;
		
		var filterObj = {
			text: [ project.label.toLowerCase() ],
			uiElement: node
		};
		
		var contexts = project.contexts;
		dojo.forEach(contexts, dojo.hitch(this, function(context){
			filterObj.text.push(context.label.toLowerCase());
		}));
		
		this._filterIndex.push( filterObj );
	},
	
	//******************************
	// Event Management
	//******************************
	
	//
	// Generic event handler that directs an event to its appropiate 
	// callback action depending on the clicked target
	//
	onMouseClick: function(e){
		// if-statement used to filter even bubbling and let clicks on valid
		// links occur.
		var anchor = getElement(e, "A"); //$NON-NLS-1$
		if (anchor && (anchor.href.indexOf("#") === anchor.href.length - 1)) { //$NON-NLS-1$
			dojo.stopEvent(e);
			
			if (dojo.hasClass(anchor, "projectTitle")) { //$NON-NLS-1$
				var li = getElement(e, "LI"); //$NON-NLS-1$
				var projectUri = li[PROJECT_RESOURCE_URI_PROP];
				
				dojo.hash("/projects/edit/" + projectUri); //$NON-NLS-1$
			} else if (dojo.hasClass(anchor, "containerTwistieAnchor")) { //$NON-NLS-1$
				this._toggleContainerDetails({
					evtNode: anchor
				});
			}
		}
	},
	
	//
	// Callback that toggles the display of Artifact Container details of a project
	//
	_toggleContainerDetails: function(args){
		var evtNode = args.evtNode;
		var twistieImg = evtNode.childNodes[0];
		
		var rootLi = evtNode.parentNode;
		var contextDetailsWidget = dijit.byId(rootLi[CONTEXT_WIDGET_ID_PROP]);
		
		if(dojo.hasClass(contextDetailsWidget.domNode, "hide")){ //$NON-NLS-1$
			twistieImg.src = OPEN_TWISTIE_SRC;
			dojo.removeClass(contextDetailsWidget.domNode, "hide"); //$NON-NLS-1$
			contextDetailsWidget.makeVisible();
		} else {
			twistieImg.src = CLOSED_TWISTIE_SRC;
			dojo.addClass(contextDetailsWidget.domNode, "hide"); //$NON-NLS-1$
		}
	},
	
	//******************************
	// Util Functions
	//******************************
	
	_getApplicationLabelListStr: function(container){
		return this._applicationMap[container.application].label;
	},
	
	_makeReadOnly: function() {
		this.readOnly = true;
		this.saveButton.disabled = true;
	},
	
	_makeSavable: function(){
		this.readOnly = false;
		this.saveButton.disabled = false;
	},
	
	//
	// Make xhr requests
	// error handling is automatically handled
	//
	_makeRemoteCall: function(dfd, callback) {
		makeRemoteCall(dfd, dojo.hitch(this, callback));
	}
});
})();